/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/process","vs/base/parts/ipc/common/ipc","os","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/node/watcher/watcher","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","path","assert","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(J){for(var e=[],D=0,L=J.length;D<L;D++)e[D]=te[J[D]];return e};define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let m in i)D.call(i,m)&&I.push(i[m]);return I}e.values=L;function R(i,I){for(let m in i)if(D.call(i,m)&&I({key:m,value:i[m]},function(){delete i[m]})===!1)return}e.forEach=R;function k(i,I){const m=Object.create(null);for(const E of i){const h=I(E);let S=m[h];S||(S=m[h]=[]),S.push(E)}return m}e.groupBy=k;function A(i){const I=Object.create(null);return i&&i.forEach((m,E)=>{I[E]=m}),I}e.fromMap=A;function P(i,I){const m=[],E=[];for(let h of i)I.has(h)||m.push(h);for(let h of I)i.has(h)||E.push(h);return{removed:m,added:E}}e.diffSets=P;function w(i,I){const m=[],E=[];for(let[h,S]of i)I.has(h)||m.push(S);for(let[h,S]of I)i.has(h)||E.push(S);return{removed:m,added:E}}e.diffMaps=w;class b{constructor(){this.map=new Map}add(I,m){let E=this.map.get(I);E||(E=new Set,this.map.set(I,E)),E.add(m)}delete(I,m){const E=this.map.get(I);!E||(E.delete(m),E.size===0&&this.map.delete(I))}forEach(I,m){const E=this.map.get(I);!E||E.forEach(m)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(P,w,b)=>{let i=null,I=null;if(typeof b.value=="function"?(i="value",I=b.value):typeof b.get=="function"&&(i="get",I=b.get),!I)throw new Error("not supported");b[i]=A(I,w)}}e.createDecorator=D;function L(A,P,w){let b=null,i=null;if(typeof w.value=="function"?(b="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(b="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${P}`;w[b]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,m)}),this[I]}}e.memoize=L;function R(A,P,w){return D((b,i)=>{const I=`$debounce$${i}`,m=`$debounce$result$${i}`;return function(...E){this[m]||(this[m]=w?w():void 0),clearTimeout(this[I]),P&&(this[m]=P(this[m],...E),E=[this[m]]),this[I]=setTimeout(()=>{b.apply(this,E),this[m]=w?w():void 0},A)}})}e.debounce=R;function k(A,P,w){return D((b,i)=>{const I=`$throttle$timer$${i}`,m=`$throttle$result$${i}`,E=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...S){if(this[m]||(this[m]=w?w():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...S)),this[h])return;const f=this[E]+A;f<=Date.now()?(this[E]=Date.now(),b.apply(this,[this[m]]),this[m]=w?w():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),b.apply(this,[this[m]]),this[m]=w?w():void 0},f-Date.now()))}})}e.throttle=k}),define(te[8],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function R(a){w(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function k(a){w(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=k;function A(a){if(a instanceof Error){let{name:t,message:s}=a;const r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:r}}return a}e.transformErrorForSerialization=A;const P="Canceled";function w(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=w;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function m(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=m;function E(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function S(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=S;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;function y(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=y;function c(a,t=Object.create(null)){const s=new Error(a);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=c}),define(te[17],ne([0,1,8]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(M,B=0){return M[M.length-(1+B)]}e.tail=L;function R(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=R;function k(M,B,V=(Q,Z)=>Q===Z){if(M===B)return!0;if(!M||!B||M.length!==B.length)return!1;for(let Q=0,Z=M.length;Q<Z;Q++)if(!V(M[Q],B[Q]))return!1;return!0}e.equals=k;function A(M,B,V){let Q=0,Z=M.length-1;for(;Q<=Z;){const K=(Q+Z)/2|0,H=V(M[K],B);if(H<0)Q=K+1;else if(H>0)Z=K-1;else return K}return-(Q+1)}e.binarySearch=A;function P(M,B){let V=0,Q=M.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);B(M[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=P;function w(M,B,V){if(M=M|0,M>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],K=[],H=[];for(let re of B){const ie=V(re,Q);ie<0?Z.push(re):ie>0?K.push(re):H.push(re)}return M<Z.length?w(M,Z,V):M<Z.length+H.length?H[0]:w(M-(Z.length+H.length),K,V)}e.quickSelect=w;function b(M,B){const V=[];let Q;for(const Z of M.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=b;function i(M,B,V){const Q=[];function Z(re,ie,ae){if(ie===0&&ae.length===0)return;const ue=Q[Q.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=ie,ue.toInsert.push(...ae)):Q.push({start:re,deleteCount:ie,toInsert:ae})}let K=0,H=0;for(;;){if(K===M.length){Z(K,0,B.slice(H));break}if(H===B.length){Z(K,M.length-K,[]);break}const re=M[K],ie=B[H],ae=V(re,ie);ae===0?(K+=1,H+=1):ae<0?(Z(K,1,[]),K+=1):ae>0&&(Z(K,0,[ie]),H+=1)}return Q}e.sortedDiff=i;function I(M,B,V){const Q=i(M,B,V),Z=[],K=[];for(const H of Q)Z.push(...M.slice(H.start,H.start+H.deleteCount)),K.push(...H.toInsert);return{removed:Z,added:K}}e.delta=I;function m(M,B,V){if(V===0)return[];const Q=M.slice(0,V).sort(B);return h(M,B,Q,V,M.length),Q}e.top=m;function E(M,B,V,Q,Z){return V===0?Promise.resolve([]):new Promise((K,H)=>{(async()=>{const re=M.length,ie=M.slice(0,V).sort(B);for(let ae=V,ue=Math.min(V+Q,re);ae<re;ae=ue,ue=Math.min(ue+Q,re)){if(ae>V&&await new Promise(fe=>setTimeout(fe)),Z&&Z.isCancellationRequested)throw(0,D.canceled)();h(M,B,ie,ae,ue)}return ie})().then(K,H)})}e.topAsync=E;function h(M,B,V,Q,Z){for(const K=V.length;Q<Z;Q++){const H=M[Q];if(B(H,V[K-1])<0){V.pop();const re=P(V,ie=>B(H,ie)<0);V.splice(re,0,H)}}}function S(M){return M.filter(B=>!!B)}e.coalesce=S;function f(M){let B=0;for(let V=0;V<M.length;V++)M[V]&&(M[B]=M[V],B+=1);M.length=B}e.coalesceInPlace=f;function p(M,B,V){M.splice(V,0,M.splice(B,1)[0])}e.move=p;function g(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=g;function y(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=y;function c(M,B=V=>V){const V=new Set;return M.filter(Q=>{const Z=B(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=c;function a(M){const B=Object.create(null);return V=>{const Q=M(V);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=a;function t(M,B){const V=s(M,B);if(V!==-1)return M[V]}e.findLast=t;function s(M,B){for(let V=M.length-1;V>=0;V--){const Q=M[V];if(B(Q))return V}return-1}e.lastIndex=s;function r(M,B){return M.length>0?M[0]:B}e.firstOrDefault=r;function n(M,B,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,K=Math.min(M.length,B.length);Z<K&&V(M[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=n;function o(M){return[].concat(...M)}e.flatten=o;function l(M,B){let V=typeof B=="number"?M:0;typeof B=="number"?V=M:(V=0,B=M);const Q=[];if(V<=B)for(let Z=V;Z<B;Z++)Q.push(Z);else for(let Z=V;Z>B;Z--)Q.push(Z);return Q}e.range=l;function u(M,B,V){return M.reduce((Q,Z)=>(Q[B(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=u;function d(M,B){return M.push(B),()=>v(M,B)}e.insert=d;function v(M,B){const V=M.indexOf(B);if(V>-1)return M.splice(V,1),B}e.remove=v;function T(M,B,V){const Q=M.slice(0,B),Z=M.slice(B);return Q.concat(V,Z)}e.arrayInsert=T;function _(M,B){let V;if(typeof B=="number"){let Q=B;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=M.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),K=M[Q];M[Q]=M[Z],M[Z]=K}}e.shuffle=_;function O(M,B){const V=M.indexOf(B);V>-1&&(M.splice(V,1),M.unshift(B))}e.pushToStart=O;function N(M,B){const V=M.indexOf(B);V>-1&&(M.splice(V,1),M.push(B))}e.pushToEnd=N;function C(M,B){return Array.isArray(M)?M.map(B):B(M)}e.mapArrayOrNot=C;function F(M){return Array.isArray(M)?M:[M]}e.asArray=F;function z(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=z;function U(M,B){for(const V of M){const Q=B(V);if(Q!==void 0)return Q}}e.mapFind=U;function x(M,B,V){const Q=q(M,B),Z=M.length,K=V.length;M.length=Z+K;for(let H=Z-1;H>=Q;H--)M[H+K]=M[H];for(let H=0;H<K;H++)M[H+Q]=V[H]}e.insertInto=x;function j(M,B,V,Q){const Z=q(M,B),K=M.splice(Z,V);return x(M,Z,Q),K}e.splice=j;function q(M,B){return B<0?Math.max(B+M.length,0):Math.min(B,M.length)}function W(M,B){let V=Number.MAX_SAFE_INTEGER,Q=0;return M.forEach((Z,K)=>{const H=B(Z);H<V&&(V=H,Q=K)}),Q}e.minIndex=W;function $(M,B){let V=Number.MIN_SAFE_INTEGER,Q=0;return M.forEach((Z,K)=>{const H=B(Z);H>V&&(V=H,Q=K)}),Q}e.maxIndex=$;class G{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let V=this.firstIdx;for(;V<this.items.length&&B(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(B){let V=this.lastIdx;for(;V>=0&&B(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=G}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(R,arguments)),A}}e.once=D}),define(te[56],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=R;const k=Object.freeze([]);function A(){return k}L.empty=A;function*P(a){yield a}L.single=P;function w(a){return a||k}L.from=w;function b(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=b;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function I(a,t){for(const s of a)if(t(s))return!0;return!1}L.some=I;function m(a,t){for(const s of a)if(t(s))return s}L.find=m;function*E(a,t){for(const s of a)t(s)&&(yield s)}L.filter=E;function*h(a,t){let s=0;for(const r of a)yield t(r,s++)}L.map=h;function*S(...a){for(const t of a)for(const s of t)yield s}L.concat=S;function*f(a){for(const t of a)for(const s of t)yield s}L.concatNested=f;function p(a,t,s){let r=s;for(const n of a)r=t(r,n);return r}L.reduce=p;function*g(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}L.slice=g;function y(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const r=a[Symbol.iterator]();for(let n=0;n<t;n++){const o=r.next();if(o.done)return[s,L.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=y;function c(a,t,s=(r,n)=>r===n){const r=a[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const o=r.next(),l=n.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!s(o.value,l.value))return!1}}L.equals=c})(D=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,s=!1){let r=0,n=t.length,o="",l=0,u=16,d=0;function v(z){let U=0,x=0;for(;U<z;){const j=t.charCodeAt(r);if(j>=48&&j<=57)x=x*16+j-48;else if(j>=65&&j<=70)x=x*16+j-65+10;else if(j>=97&&j<=102)x=x*16+j-97+10;else break;r++,U++}return U<z&&(x=-1),x}function T(z){r=z,o="",l=0,u=16,d=0}function _(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&b(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&b(t.charCodeAt(r)))for(r++;r<t.length&&b(t.charCodeAt(r));)r++;else return d=3,t.substring(z,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&b(t.charCodeAt(r))){for(r++;r<t.length&&b(t.charCodeAt(r));)r++;U=r}else d=3;return t.substring(z,U)}function O(){let z="",U=r;for(;;){if(r>=n){z+=t.substring(U,r),d=2;break}const x=t.charCodeAt(r);if(x===34){z+=t.substring(U,r),r++;break}if(x===92){if(z+=t.substring(U,r),r++,r>=n){d=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const q=v(4);q>=0?z+=String.fromCharCode(q):d=4;break;default:d=5}U=r;continue}if(x>=0&&x<=31)if(w(x)){z+=t.substring(U,r),d=2;break}else d=6;r++}return z}function N(){if(o="",d=0,l=r,r>=n)return l=n,u=17;let z=t.charCodeAt(r);if(P(z)){do r++,o+=String.fromCharCode(z),z=t.charCodeAt(r);while(P(z));return u=15}if(w(z))return r++,o+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),u=14;switch(z){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,o=O(),u=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!w(t.charCodeAt(r));)r++;return o=t.substring(U,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const x=n-1;let j=!1;for(;r<x;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,j=!0;break}r++}return j||(r++,d=1),o=t.substring(U,r),u=13}return o+=String.fromCharCode(z),r++,u=16;case 45:if(o+=String.fromCharCode(z),r++,r===n||!b(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),u=11;default:for(;r<n&&C(z);)r++,z=t.charCodeAt(r);if(l!==r){switch(o=t.substring(l,r),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode(z),r++,u=16}}function C(z){if(P(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:T,getPosition:()=>r,scan:s?F:N,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>d}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,s){const r=[],n=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(v,T,_,O){l.value=v,l.offset=T,l.length=_,l.type=O,l.colonOffset=void 0,o=l}try{y(t,{onObjectBegin:(v,T)=>{if(s<=v)throw n;o=void 0,u=s>v,r.push("")},onObjectProperty:(v,T,_)=>{if(s<T||(d(v,T,_,"property"),r[r.length-1]=v,s<=T+_))throw n},onObjectEnd:(v,T)=>{if(s<=v)throw n;o=void 0,r.pop()},onArrayBegin:(v,T)=>{if(s<=v)throw n;o=void 0,r.push(0)},onArrayEnd:(v,T)=>{if(s<=v)throw n;o=void 0,r.pop()},onLiteralValue:(v,T,_)=>{if(s<T||(d(v,T,_,a(v)),s<=T+_))throw n},onSeparator:(v,T,_)=>{if(s<=T)throw n;if(v===":"&&o&&o.type==="property")o.colonOffset=T,u=!1,o=void 0;else if(v===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(u=!0,r[r.length-1]=""),o=void 0}}})}catch(v){if(v!==n)throw v}return{path:r,previousNode:o,isAtPropertyKey:u,matches:v=>{let T=0;for(let _=0;T<v.length&&_<r.length;_++)if(v[T]===r[_]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}e.getLocation=I;function m(t,s=[],r=k.DEFAULT){let n=null,o=[];const l=[];function u(v){Array.isArray(o)?o.push(v):n!==null&&(o[n]=v)}return y(t,{onObjectBegin:()=>{const v={};u(v),l.push(o),o=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const v=[];u(v),l.push(o),o=v,n=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:u,onError:(v,T,_)=>{s.push({error:v,offset:T,length:_})}},r),o[0]}e.parse=m;function E(t,s=[],r=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function l(v){return n.children.push(v),v}y(t,{onObjectBegin:v=>{n=l({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,T,_)=>{n=l({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:T,length:_,parent:n})},onObjectEnd:(v,T)=>{n.length=v+T-n.offset,n=n.parent,o(v+T)},onArrayBegin:(v,T)=>{n=l({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,T)=>{n.length=v+T-n.offset,n=n.parent,o(v+T)},onLiteralValue:(v,T,_)=>{l({type:a(v),offset:T,length:_,parent:n,value:v}),o(T+_)},onSeparator:(v,T,_)=>{n.type==="property"&&(v===":"?n.colonOffset=T:v===","&&o(T))},onError:(v,T,_)=>{s.push({error:v,offset:T,length:_})}},r);const d=n.children[0];return d&&delete d.parent,d}e.parseTree=E;function h(t,s){if(!t)return;let r=t;for(let n of s)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===n){r=l.children[1],o=!0;break}if(!o)return}else{const o=n;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=h;function S(t){if(!t.parent||!t.parent.children)return[];const s=S(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=S;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(s[r.children[0].value]=f(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function p(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=p;function g(t,s,r=!1){if(p(t,s,r)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=s;o++){const l=g(n[o],s,r);if(l)return l}return t}}e.findNodeAtOffset=g;function y(t,s,r=k.DEFAULT){const n=A(t,!1);function o(V){return V?()=>V(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(V){return V?Q=>V(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),d=l(s.onObjectProperty),v=o(s.onObjectEnd),T=o(s.onArrayBegin),_=o(s.onArrayEnd),O=l(s.onLiteralValue),N=l(s.onSeparator),C=o(s.onComment),F=l(s.onError),z=r&&r.disallowComments,U=r&&r.allowTrailingComma;function x(){for(;;){const V=n.scan();switch(n.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:z||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(V){case 12:case 13:z?j(10):C();break;case 16:j(1);break;case 15:case 14:break;default:return V}}}function j(V,Q=[],Z=[]){if(F(V),Q.length+Z.length>0){let K=n.getToken();for(;K!==17;){if(Q.indexOf(K)!==-1){x();break}else if(Z.indexOf(K)!==-1)break;K=x()}}}function q(V){const Q=n.getTokenValue();return V?O(Q):d(Q),x(),!0}function W(){switch(n.getToken()){case 11:let V=0;try{V=JSON.parse(n.getTokenValue()),typeof V!="number"&&(j(2),V=0)}catch(Q){j(2)}O(V);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function $(){return n.getToken()!==10?(j(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(N(":"),x(),B()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function G(){u(),x();let V=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(V||j(4,[],[]),N(","),x(),n.getToken()===2&&U)break}else V&&j(6,[],[]);$()||j(4,[],[2,5]),V=!0}return v(),n.getToken()!==2?j(7,[2],[]):x(),!0}function M(){T(),x();let V=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(V||j(4,[],[]),N(","),x(),n.getToken()===4&&U)break}else V&&j(6,[],[]);B()||j(4,[],[4,5]),V=!0}return _(),n.getToken()!==4?j(8,[4],[]):x(),!0}function B(){switch(n.getToken()){case 3:return M();case 1:return G();case 10:return q(!0);default:return W()}}return x(),n.getToken()===17?r.allowEmptyContent?!0:(j(4,[],[]),!1):B()?(n.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=y;function c(t,s){let r=A(t),n=[],o,l=0,u;do switch(u=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:l!==u&&n.push(t.substring(l,u)),s!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,s)),l=r.getPosition();break}while(o!==17);return n.join("")}e.stripComments=c;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(te[50],ne([0,1,36]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,b,i){let I,m,E,h,S;if(b){for(h=b.offset,S=h+b.length,E=h;E>0&&!P(w,E-1);)E--;let l=S;for(;l<w.length&&!P(w,l);)l++;m=w.substring(E,l),I=k(m,i)}else m=w,I=0,E=0,h=0,S=w.length;const f=A(i,w);let p=!1,g=0,y;i.insertSpaces?y=R(" ",i.tabSize||4):y="	";const c=(0,D.createScanner)(m,!1);let a=!1;function t(){return f+R(y,I+g)}function s(){let l=c.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=c.scan();return a=l===16||c.getTokenError()!==0,l}const r=[];function n(l,u,d){!a&&u<S&&d>h&&w.substring(u,d)!==l&&r.push({offset:u,length:d-u,content:l})}let o=s();if(o!==17){const l=c.getTokenOffset()+E,u=R(y,I);n(u,E,l)}for(;o!==17;){let l=c.getTokenOffset()+c.getTokenLength()+E,u=s(),d="";for(;!p&&(u===12||u===13);){const T=c.getTokenOffset()+E;n(" ",l,T),l=c.getTokenOffset()+c.getTokenLength()+E,d=u===12?t():"",u=s()}if(u===2)o!==1&&(g--,d=t());else if(u===4)o!==3&&(g--,d=t());else{switch(o){case 3:case 1:g++,d=t();break;case 5:case 12:d=t();break;case 13:p?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(a=!0);break;case 16:a=!0;break}p&&(u===12||u===13)&&(d=t())}const v=c.getTokenOffset()+E;n(d,l,v),o=u}return r}e.format=L;function R(w,b){let i="";for(let I=0;I<b;I++)i+=w;return i}function k(w,b){let i=0,I=0;const m=b.tabSize||4;for(;i<w.length;){const E=w.charAt(i);if(E===" ")I++;else if(E==="	")I+=m;else break;i++}return Math.floor(I/m)}function A(w,b){for(let i=0;i<b.length;i++){const I=b.charAt(i);if(I==="\r")return i+1<b.length&&b.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=A;function P(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=P}),define(te[44],ne([0,1,36,50]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,i,I){return k(b,i,void 0,I)}e.removeProperty=R;function k(b,i,I,m,E){const h=i.slice(),S=[],f=(0,D.parseTree)(b,S);let p,g;for(;h.length>0&&(g=h.pop(),p=(0,D.findNodeAtLocation)(f,h),p===void 0&&I!==void 0);)typeof g=="string"?I={[g]:I}:I=[I];if(p)if(p.type==="object"&&typeof g=="string"&&Array.isArray(p.children)){const y=(0,D.findNodeAtLocation)(p,[g]);if(y!==void 0)if(I===void 0){if(!y.parent)throw new Error("Malformed AST");const c=p.children.indexOf(y.parent);let a,t=y.parent.offset+y.parent.length;if(c>0){const s=p.children[c-1];a=s.offset+s.length}else a=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return A(b,{offset:a,length:t-a,content:""},m)}else return A(b,{offset:y.offset,length:y.length,content:JSON.stringify(I)},m);else{if(I===void 0)return[];const c=`${JSON.stringify(g)}: ${JSON.stringify(I)}`,a=E?E(p.children.map(s=>s.children[0].value)):p.children.length;let t;if(a>0){const s=p.children[a-1];t={offset:s.offset+s.length,length:0,content:","+c}}else p.children.length===0?t={offset:p.offset+1,length:0,content:c}:t={offset:p.offset+1,length:0,content:c+","};return A(b,t,m)}}else if(p.type==="array"&&typeof g=="number"&&Array.isArray(p.children))if(I!==void 0){const y=`${JSON.stringify(I)}`;let c;if(p.children.length===0||g===0)c={offset:p.offset+1,length:0,content:p.children.length===0?y:y+","};else{const a=g===-1||g>p.children.length?p.children.length:g,t=p.children[a-1];c={offset:t.offset+t.length,length:0,content:","+y}}return A(b,c,m)}else{const y=g,c=p.children[y];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===y){const t=p.children[y-1],s=t.offset+t.length,r=p.offset+p.length;a={offset:s,length:r-2-s,content:""}}else a={offset:c.offset,length:p.children[y+1].offset-c.offset,content:""};return A(b,a,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(b,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(I)},m)}}e.setProperty=k;function A(b,i,I){let m=P(b,i),E=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;E>0&&!(0,L.isEOL)(m,E-1);)E--;for(;h<m.length&&!(0,L.isEOL)(m,h);)h++}const S=(0,L.format)(m,{offset:E,length:h-E},I);for(let p=S.length-1;p>=0;p--){const g=S[p];m=P(m,g),E=Math.min(E,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const f=b.length-(m.length-h)-E;return[{offset:E,length:f,content:m.substring(E,h)}]}e.withFormatting=A;function P(b,i){return b.substring(0,i.offset)+i.content+b.substring(i.offset+i.length)}e.applyEdit=P;function w(b,i){let I=i.slice(0).sort((E,h)=>{const S=E.offset-h.offset;return S===0?E.length-h.length:S}),m=b.length;for(let E=I.length-1;E>=0;E--){let h=I[E];if(h.offset+h.length<=m)b=P(b,h);else throw new Error("Overlapping edit");m=h.offset}return b}e.applyEdits=w}),define(te[2],ne([0,1,68,56]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function A(n){k=n}if(e.setDisposableTracker=A,R){const n="__is_disposable_tracked__";A(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[n]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==g.None)try{o[n]=!0}catch{}}markAsDisposed(o){if(o&&o!==g.None)try{o[n]=!0}catch{}}markAsSingleton(o){}})}function P(n){return k?.trackDisposable(n),n}function w(n){k?.markAsDisposed(n)}function b(n,o){k?.setParent(n,o)}function i(n,o){if(!!k)for(const l of n)k.setParent(l,o)}function I(n){return k?.markAsSingleton(n),n}e.markAsSingleton=I;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function E(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=E;function h(n){if(L.Iterable.is(n)){let o=[];for(const l of n)if(l)try{l.dispose()}catch(u){o.push(u)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=h;function S(...n){const o=f(()=>h(n));return i(n,o),o}e.combinedDisposable=S;function f(n){const o=P({dispose:(0,D.once)(()=>{w(o),n()})});return o}e.toDisposable=f;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return b(o,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new p,P(this),b(this._store,this)}dispose(){w(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&b(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&b(o,null),o}}e.MutableDisposable=y;class c{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...l){let u=this.references.get(o);u||(u={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,u));const{object:d}=u,v=(0,D.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(o,u.object),this.references.delete(o))});return u.counter++,{object:d,dispose:v}}}e.ReferenceCollection=a;class t{constructor(o){this.referenceCollection=o}async acquire(o,...l){const u=this.referenceCollection.acquire(o,...l);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function r(n){const o=new p;try{n(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(k){this.element=k,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let k=this._first;for(;k!==D.Undefined;){const A=k.next;k.prev=D.Undefined,k.next=D.Undefined,k=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const P=new D(k);if(this._first===D.Undefined)this._first=P,this._last=P;else if(A){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==D.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==D.Undefined&&k.next!==D.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===D.Undefined&&k.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):k.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):k.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==D.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function J(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function A(w){k.push(w,Date.now())}function P(){const w=[];for(let b=0;b<k.length;b+=2)w.push({name:k[b],startTime:k[b+1]});return w}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(R+A.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,k=!1,A=!1,P=!1,w=!1,b=!1,i,I=D,m,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&h?.sandboxed,typeof navigator=="object"&&!S)E=navigator.userAgent,L=E.indexOf("Windows")>=0,R=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=E.indexOf("Linux")>=0,w=!0,i=navigator.language,I=i;else if(typeof h=="object"){L=h.platform==="win32",R=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=D,I=D;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),o=n.availableLanguages["*"];i=n.locale,I=o||D,m=n._translationsConfigFile}catch(n){}P=!0}else console.error("Unable to resolve platform.");var f;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function p(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let g=0;R?g=1:L?g=3:k&&(g=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=A,e.isNative=P,e.isWeb=w,e.isIOS=b,e.platform=g,e.userAgent=E,e.language=I;var y;(function(r){function n(){return e.language}r.value=n;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function l(){return e.language==="en"}r.isDefault=l})(y=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let d=0,v=o.length;d<v;d++){const T=o[d];if(T.id===u.data.vscodeSetImmediateId){o.splice(d,1),T.callback();return}}});let l=0;return u=>{const d=++l;o.push({id:d,callback:u}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const n=Promise.resolve();return o=>n.then(o)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:L?1:3;let a=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,a=new Uint16Array(r.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(k){return(0,D.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[9],ne([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,k=90,A=122,P=46,w=47,b=92,i=58,I=63;class m extends Error{constructor(c,a,t){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const r=c.indexOf(".")!==-1?"property":"argument";let n=`The "${c}" ${r} ${s} of type ${a}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function E(y,c){if(typeof y!="string")throw new m(c,"string",y)}function h(y){return y===w||y===b}function S(y){return y===w}function f(y){return y>=L&&y<=k||y>=R&&y<=A}function p(y,c,a,t){let s="",r=0,n=-1,o=0,l=0;for(let u=0;u<=y.length;++u){if(u<y.length)l=y.charCodeAt(u);else{if(t(l))break;l=w}if(t(l)){if(!(n===u-1||o===1))if(o===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const d=s.lastIndexOf(a);d===-1?(s="",r=0):(s=s.slice(0,d),r=s.length-1-s.lastIndexOf(a)),n=u,o=0;continue}else if(s.length!==0){s="",r=0,n=u,o=0;continue}}c&&(s+=s.length>0?`${a}..`:"..",r=2)}else s.length>0?s+=`${a}${y.slice(n+1,u)}`:s=y.slice(n+1,u),r=u-n-1;n=u,o=0}else l===P&&o!==-1?++o:o=-1}return s}function g(y,c){if(c===null||typeof c!="object")throw new m("pathObject","Object",c);const a=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return a?a===c.root?`${a}${t}`:`${a}${y}${t}`:t}e.win32={resolve(...y){let c="",a="",t=!1;for(let s=y.length-1;s>=-1;s--){let r;if(s>=0){if(r=y[s],E(r,"path"),r.length===0)continue}else c.length===0?r=D.cwd():(r=D.env[`=${c}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${c}\\`));const n=r.length;let o=0,l="",u=!1;const d=r.charCodeAt(0);if(n===1)h(d)&&(o=1,u=!0);else if(h(d))if(u=!0,h(r.charCodeAt(1))){let v=2,T=v;for(;v<n&&!h(r.charCodeAt(v));)v++;if(v<n&&v!==T){const _=r.slice(T,v);for(T=v;v<n&&h(r.charCodeAt(v));)v++;if(v<n&&v!==T){for(T=v;v<n&&!h(r.charCodeAt(v));)v++;(v===n||v!==T)&&(l=`\\\\${_}\\${r.slice(T,v)}`,o=v)}}}else o=1;else f(d)&&r.charCodeAt(1)===i&&(l=r.slice(0,2),o=2,n>2&&h(r.charCodeAt(2))&&(u=!0,o=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(a=`${r.slice(o)}\\${a}`,t=u,u&&c.length>0)break}return a=p(a,!t,"\\",h),t?`${c}\\${a}`:`${c}${a}`||"."},normalize(y){E(y,"path");const c=y.length;if(c===0)return".";let a=0,t,s=!1;const r=y.charCodeAt(0);if(c===1)return S(r)?"\\":y;if(h(r))if(s=!0,h(y.charCodeAt(1))){let o=2,l=o;for(;o<c&&!h(y.charCodeAt(o));)o++;if(o<c&&o!==l){const u=y.slice(l,o);for(l=o;o<c&&h(y.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!h(y.charCodeAt(o));)o++;if(o===c)return`\\\\${u}\\${y.slice(l)}\\`;o!==l&&(t=`\\\\${u}\\${y.slice(l,o)}`,a=o)}}}else a=1;else f(r)&&y.charCodeAt(1)===i&&(t=y.slice(0,2),a=2,c>2&&h(y.charCodeAt(2))&&(s=!0,a=3));let n=a<c?p(y.slice(a),!s,"\\",h):"";return n.length===0&&!s&&(n="."),n.length>0&&h(y.charCodeAt(c-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(y){E(y,"path");const c=y.length;if(c===0)return!1;const a=y.charCodeAt(0);return h(a)||c>2&&f(a)&&y.charCodeAt(1)===i&&h(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let c,a;for(let r=0;r<y.length;++r){const n=y[r];E(n,"path"),n.length>0&&(c===void 0?c=a=n:c+=`\\${n}`)}if(c===void 0)return".";let t=!0,s=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++s;const r=a.length;r>1&&h(a.charCodeAt(1))&&(++s,r>2&&(h(a.charCodeAt(2))?++s:t=!1))}if(t){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(y,c){if(E(y,"from"),E(c,"to"),y===c)return"";const a=e.win32.resolve(y),t=e.win32.resolve(c);if(a===t||(y=a.toLowerCase(),c=t.toLowerCase(),y===c))return"";let s=0;for(;s<y.length&&y.charCodeAt(s)===b;)s++;let r=y.length;for(;r-1>s&&y.charCodeAt(r-1)===b;)r--;const n=r-s;let o=0;for(;o<c.length&&c.charCodeAt(o)===b;)o++;let l=c.length;for(;l-1>o&&c.charCodeAt(l-1)===b;)l--;const u=l-o,d=n<u?n:u;let v=-1,T=0;for(;T<d;T++){const O=y.charCodeAt(s+T);if(O!==c.charCodeAt(o+T))break;O===b&&(v=T)}if(T!==d){if(v===-1)return t}else{if(u>d){if(c.charCodeAt(o+T)===b)return t.slice(o+T+1);if(T===2)return t.slice(o+T)}n>d&&(y.charCodeAt(s+T)===b?v=T:T===2&&(v=3)),v===-1&&(v=0)}let _="";for(T=s+v+1;T<=r;++T)(T===r||y.charCodeAt(T)===b)&&(_+=_.length===0?"..":"\\..");return o+=v,_.length>0?`${_}${t.slice(o,l)}`:(t.charCodeAt(o)===b&&++o,t.slice(o,l))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const c=e.win32.resolve(y);if(c.length<=2)return y;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const a=c.charCodeAt(2);if(a!==I&&a!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return y},dirname(y){E(y,"path");const c=y.length;if(c===0)return".";let a=-1,t=0;const s=y.charCodeAt(0);if(c===1)return h(s)?y:".";if(h(s)){if(a=t=1,h(y.charCodeAt(1))){let o=2,l=o;for(;o<c&&!h(y.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&h(y.charCodeAt(o));)o++;if(o<c&&o!==l){for(l=o;o<c&&!h(y.charCodeAt(o));)o++;if(o===c)return y;o!==l&&(a=t=o+1)}}}}else f(s)&&y.charCodeAt(1)===i&&(a=c>2&&h(y.charCodeAt(2))?3:2,t=a);let r=-1,n=!0;for(let o=c-1;o>=t;--o)if(h(y.charCodeAt(o))){if(!n){r=o;break}}else n=!1;if(r===-1){if(a===-1)return".";r=a}return y.slice(0,r)},basename(y,c){c!==void 0&&E(c,"ext"),E(y,"path");let a=0,t=-1,s=!0,r;if(y.length>=2&&f(y.charCodeAt(0))&&y.charCodeAt(1)===i&&(a=2),c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let n=c.length-1,o=-1;for(r=y.length-1;r>=a;--r){const l=y.charCodeAt(r);if(h(l)){if(!s){a=r+1;break}}else o===-1&&(s=!1,o=r+1),n>=0&&(l===c.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=o))}return a===t?t=o:t===-1&&(t=y.length),y.slice(a,t)}for(r=y.length-1;r>=a;--r)if(h(y.charCodeAt(r))){if(!s){a=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":y.slice(a,t)},extname(y){E(y,"path");let c=0,a=-1,t=0,s=-1,r=!0,n=0;y.length>=2&&y.charCodeAt(1)===i&&f(y.charCodeAt(0))&&(c=t=2);for(let o=y.length-1;o>=c;--o){const l=y.charCodeAt(o);if(h(l)){if(!r){t=o+1;break}continue}s===-1&&(r=!1,s=o+1),l===P?a===-1?a=o:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||s===-1||n===0||n===1&&a===s-1&&a===t+1?"":y.slice(a,s)},format:g.bind(null,"\\"),parse(y){E(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const a=y.length;let t=0,s=y.charCodeAt(0);if(a===1)return h(s)?(c.root=c.dir=y,c):(c.base=c.name=y,c);if(h(s)){if(t=1,h(y.charCodeAt(1))){let v=2,T=v;for(;v<a&&!h(y.charCodeAt(v));)v++;if(v<a&&v!==T){for(T=v;v<a&&h(y.charCodeAt(v));)v++;if(v<a&&v!==T){for(T=v;v<a&&!h(y.charCodeAt(v));)v++;v===a?t=v:v!==T&&(t=v+1)}}}}else if(f(s)&&y.charCodeAt(1)===i){if(a<=2)return c.root=c.dir=y,c;if(t=2,h(y.charCodeAt(2))){if(a===3)return c.root=c.dir=y,c;t=3}}t>0&&(c.root=y.slice(0,t));let r=-1,n=t,o=-1,l=!0,u=y.length-1,d=0;for(;u>=t;--u){if(s=y.charCodeAt(u),h(s)){if(!l){n=u+1;break}continue}o===-1&&(l=!1,o=u+1),s===P?r===-1?r=u:d!==1&&(d=1):r!==-1&&(d=-1)}return o!==-1&&(r===-1||d===0||d===1&&r===o-1&&r===n+1?c.base=c.name=y.slice(n,o):(c.name=y.slice(n,r),c.base=y.slice(n,o),c.ext=y.slice(r,o))),n>0&&n!==t?c.dir=y.slice(0,n-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let c="",a=!1;for(let t=y.length-1;t>=-1&&!a;t--){const s=t>=0?y[t]:D.cwd();E(s,"path"),s.length!==0&&(c=`${s}/${c}`,a=s.charCodeAt(0)===w)}return c=p(c,!a,"/",S),a?`/${c}`:c.length>0?c:"."},normalize(y){if(E(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===w,a=y.charCodeAt(y.length-1)===w;return y=p(y,!c,"/",S),y.length===0?c?"/":a?"./":".":(a&&(y+="/"),c?`/${y}`:y)},isAbsolute(y){return E(y,"path"),y.length>0&&y.charCodeAt(0)===w},join(...y){if(y.length===0)return".";let c;for(let a=0;a<y.length;++a){const t=y[a];E(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(y,c){if(E(y,"from"),E(c,"to"),y===c||(y=e.posix.resolve(y),c=e.posix.resolve(c),y===c))return"";const a=1,t=y.length,s=t-a,r=1,n=c.length-r,o=s<n?s:n;let l=-1,u=0;for(;u<o;u++){const v=y.charCodeAt(a+u);if(v!==c.charCodeAt(r+u))break;v===w&&(l=u)}if(u===o)if(n>o){if(c.charCodeAt(r+u)===w)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else s>o&&(y.charCodeAt(a+u)===w?l=u:u===0&&(l=0));let d="";for(u=a+l+1;u<=t;++u)(u===t||y.charCodeAt(u)===w)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(r+l)}`},toNamespacedPath(y){return y},dirname(y){if(E(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===w;let a=-1,t=!0;for(let s=y.length-1;s>=1;--s)if(y.charCodeAt(s)===w){if(!t){a=s;break}}else t=!1;return a===-1?c?"/":".":c&&a===1?"//":y.slice(0,a)},basename(y,c){c!==void 0&&E(c,"ext"),E(y,"path");let a=0,t=-1,s=!0,r;if(c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let n=c.length-1,o=-1;for(r=y.length-1;r>=0;--r){const l=y.charCodeAt(r);if(l===w){if(!s){a=r+1;break}}else o===-1&&(s=!1,o=r+1),n>=0&&(l===c.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=o))}return a===t?t=o:t===-1&&(t=y.length),y.slice(a,t)}for(r=y.length-1;r>=0;--r)if(y.charCodeAt(r)===w){if(!s){a=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":y.slice(a,t)},extname(y){E(y,"path");let c=-1,a=0,t=-1,s=!0,r=0;for(let n=y.length-1;n>=0;--n){const o=y.charCodeAt(n);if(o===w){if(!s){a=n+1;break}continue}t===-1&&(s=!1,t=n+1),o===P?c===-1?c=n:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||t===-1||r===0||r===1&&c===t-1&&c===a+1?"":y.slice(c,t)},format:g.bind(null,"/"),parse(y){E(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const a=y.charCodeAt(0)===w;let t;a?(c.root="/",t=1):t=0;let s=-1,r=0,n=-1,o=!0,l=y.length-1,u=0;for(;l>=t;--l){const d=y.charCodeAt(l);if(d===w){if(!o){r=l+1;break}continue}n===-1&&(o=!1,n=l+1),d===P?s===-1?s=l:u!==1&&(u=1):s!==-1&&(u=-1)}if(n!==-1){const d=r===0&&a?1:r;s===-1||u===0||u===1&&s===n-1&&s===r+1?c.base=c.name=y.slice(d,n):(c.name=y.slice(d,s),c.base=y.slice(d,n),c.ext=y.slice(s,n))}return r>0?c.dir=y.slice(0,r-1):a&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...A){const P=A.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(i=>!P[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete k[i];break}})}e.sanitizeProcessEnvironment=R}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:J)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return J[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=J,D.c=e,D.d=function(L,R,k){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:k})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var A in L)D.d(k,A,function(P){return L[P]}.bind(null,A));return k},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(J,e,D){(function(L){var R;e=J.exports=Z,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],b=0,i=b++;w[i]="0|[1-9]\\d*";var I=b++;w[I]="[0-9]+";var m=b++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=b++;w[E]="("+w[i]+")\\.("+w[i]+")\\.("+w[i]+")";var h=b++;w[h]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var S=b++;w[S]="(?:"+w[i]+"|"+w[m]+")";var f=b++;w[f]="(?:"+w[I]+"|"+w[m]+")";var p=b++;w[p]="(?:-("+w[S]+"(?:\\."+w[S]+")*))";var g=b++;w[g]="(?:-?("+w[f]+"(?:\\."+w[f]+")*))";var y=b++;w[y]="[0-9A-Za-z-]+";var c=b++;w[c]="(?:\\+("+w[y]+"(?:\\."+w[y]+")*))";var a=b++,t="v?"+w[E]+w[p]+"?"+w[c]+"?";w[a]="^"+t+"$";var s="[v=\\s]*"+w[h]+w[g]+"?"+w[c]+"?",r=b++;w[r]="^"+s+"$";var n=b++;w[n]="((?:<|>)?=?)";var o=b++;w[o]=w[I]+"|x|X|\\*";var l=b++;w[l]=w[i]+"|x|X|\\*";var u=b++;w[u]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[p]+")?"+w[c]+"?)?)?";var d=b++;w[d]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[g]+")?"+w[c]+"?)?)?";var v=b++;w[v]="^"+w[n]+"\\s*"+w[u]+"$";var T=b++;w[T]="^"+w[n]+"\\s*"+w[d]+"$";var _=b++;w[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;w[O]="(?:~>?)";var N=b++;w[N]="(\\s*)"+w[O]+"\\s+",P[N]=new RegExp(w[N],"g");var C=b++;w[C]="^"+w[O]+w[u]+"$";var F=b++;w[F]="^"+w[O]+w[d]+"$";var z=b++;w[z]="(?:\\^)";var U=b++;w[U]="(\\s*)"+w[z]+"\\s+",P[U]=new RegExp(w[U],"g");var x=b++;w[x]="^"+w[z]+w[u]+"$";var j=b++;w[j]="^"+w[z]+w[d]+"$";var q=b++;w[q]="^"+w[n]+"\\s*("+s+")$|^$";var W=b++;w[W]="^"+w[n]+"\\s*("+t+")$|^$";var $=b++;w[$]="(\\s*)"+w[n]+"\\s*("+s+"|"+w[u]+")",P[$]=new RegExp(w[$],"g");var G=b++;w[G]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var M=b++;w[M]="^\\s*("+w[d]+")\\s+-\\s+("+w[d]+")\\s*$";var B=b++;w[B]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)R(V,w[V]),P[V]||(P[V]=new RegExp(w[V]));function Q(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>k||!(oe?P[r]:P[a]).test(ee))return null;try{return new Z(ee,oe)}catch(ce){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Z))return new Z(ee,oe);R("SemVer",ee,oe),this.loose=oe;var ce=ee.trim().match(oe?P[r]:P[a]);if(!ce)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var pe=+ye;if(pe>=0&&pe<A)return pe}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,oe){var ce=Q(ee,oe);return ce?ce.version:null},e.clean=function(ee,oe){var ce=Q(ee.trim().replace(/^[=v]+/,""),oe);return ce?ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return R("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ce=this.prerelease[oe],ye=ee.prerelease[oe];if(R("prerelease compare",oe,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return H(ce,ye)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new Z(ee,ce).inc(oe,ye).version}catch(pe){return null}},e.diff=function(ee,oe){if(ue(ee,oe))return null;var ce=Q(ee),ye=Q(oe);if(ce.prerelease.length||ye.prerelease.length){for(var pe in ce)if((pe==="major"||pe==="minor"||pe==="patch")&&ce[pe]!==ye[pe])return"pre"+pe;return"prerelease"}for(var pe in ce)if((pe==="major"||pe==="minor"||pe==="patch")&&ce[pe]!==ye[pe])return pe},e.compareIdentifiers=H;var K=/^[0-9]+$/;function H(ee,oe){var ce=K.test(ee),ye=K.test(oe);return ce&&ye&&(ee=+ee,oe=+oe),ce&&!ye?-1:ye&&!ce?1:ee<oe?-1:ee>oe?1:0}function re(ee,oe,ce){return new Z(ee,ce).compare(new Z(oe,ce))}function ie(ee,oe,ce){return re(ee,oe,ce)>0}function ae(ee,oe,ce){return re(ee,oe,ce)<0}function ue(ee,oe,ce){return re(ee,oe,ce)===0}function fe(ee,oe,ce){return re(ee,oe,ce)!==0}function de(ee,oe,ce){return re(ee,oe,ce)>=0}function Ie(ee,oe,ce){return re(ee,oe,ce)<=0}function Ce(ee,oe,ce,ye){var pe;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),pe=ee===ce;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),pe=ee!==ce;break;case"":case"=":case"==":pe=ue(ee,ce,ye);break;case"!=":pe=fe(ee,ce,ye);break;case">":pe=ie(ee,ce,ye);break;case">=":pe=de(ee,ce,ye);break;case"<":pe=ae(ee,ce,ye);break;case"<=":pe=Ie(ee,ce,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return pe}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);R("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ee,oe){return H(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=re,e.compareLoose=function(ee,oe){return re(ee,oe,!0)},e.rcompare=function(ee,oe,ce){return re(oe,ee,ce)},e.sort=function(ee,oe){return ee.sort(function(ce,ye){return e.compare(ce,ye,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ce,ye){return e.rcompare(ce,ye,oe)})},e.gt=ie,e.lt=ae,e.eq=ue,e.neq=fe,e.gte=de,e.lte=Ie,e.cmp=Ce,e.Comparator=Ee;var _e={};function Pe(ee,oe){if(ee instanceof Pe)return ee.loose===oe?ee:new Pe(ee.raw,oe);if(ee instanceof Ee)return new Pe(ee.value,oe);if(!(this instanceof Pe))return new Pe(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Te(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ce,ye,pe,Oe,De,Y,se,le,ge,me,be){return((oe=Te(ce)?"":Te(ye)?">="+ce+".0.0":Te(pe)?">="+ce+"."+ye+".0":">="+oe)+" "+(Y=Te(se)?"":Te(le)?"<"+(+se+1)+".0.0":Te(ge)?"<"+se+"."+(+le+1)+".0":me?"<="+se+"."+le+"."+ge+"-"+me:"<="+Y)).trim()}function $e(ee,oe){for(var ce=0;ce<ee.length;ce++)if(!ee[ce].test(oe))return!1;if(oe.prerelease.length){for(ce=0;ce<ee.length;ce++)if(R(ee[ce].semver),ee[ce].semver!==_e&&ee[ce].semver.prerelease.length>0){var ye=ee[ce].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function Ne(ee,oe,ce){try{oe=new Pe(oe,ce)}catch(ye){return!1}return oe.test(ee)}function qe(ee,oe,ce,ye){var pe,Oe,De,Y,se;switch(ee=new Z(ee,ye),oe=new Pe(oe,ye),ce){case">":pe=ie,Oe=Ie,De=ae,Y=">",se=">=";break;case"<":pe=ae,Oe=de,De=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ee,oe,ye))return!1;for(var le=0;le<oe.set.length;++le){var ge=oe.set[le],me=null,be=null;if(ge.forEach(function(ke){ke.semver===_e&&(ke=new Ee(">=0.0.0")),me=me||ke,be=be||ke,pe(ke.semver,me.semver,ye)?me=ke:De(ke.semver,be.semver,ye)&&(be=ke)}),me.operator===Y||me.operator===se||(!be.operator||be.operator===Y)&&Oe(ee,be.semver)||be.operator===se&&De(ee,be.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?P[q]:P[W],ce=ee.match(oe);if(!ce)throw new TypeError("Invalid comparator: "+ee);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new Z(ce[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return R("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new Pe(ee.value,oe),Ne(this.value,ce,oe);if(ee.operator==="")return ce=new Pe(this.value,oe),Ne(ee.semver,ce,oe);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||pe||Oe&&De||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),R("range",ee,oe);var ce=oe?P[M]:P[G];ee=ee.replace(ce,Fe),R("hyphen replace",ee),ee=ee.replace(P[$],"$1$2$3"),R("comparator trim",ee,P[$]),ee=(ee=(ee=ee.replace(P[N],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var ye=oe?P[q]:P[W],pe=ee.split(" ").map(function(Oe){return function(De,Y){return R("comp",De),De=function(se,le){return se.trim().split(/\s+/).map(function(ge){return function(me,be){R("caret",me,be);var ke=be?P[j]:P[x];return me.replace(ke,function(Le,Se,we,Re,Ae){var Me;return R("caret",me,Le,Se,we,Re,Ae),Te(Se)?Me="":Te(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te(Re)?Me=Se==="0"?">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+".0 <"+(+Se+1)+".0.0":Ae?(R("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+Re+Ae+" <"+Se+"."+we+"."+(+Re+1):">="+Se+"."+we+"."+Re+Ae+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+Re+Ae+" <"+(+Se+1)+".0.0"):(R("no pr"),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+Re+" <"+Se+"."+we+"."+(+Re+1):">="+Se+"."+we+"."+Re+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+Re+" <"+(+Se+1)+".0.0"),R("caret return",Me),Me})}(ge,le)}).join(" ")}(De,Y),R("caret",De),De=function(se,le){return se.trim().split(/\s+/).map(function(ge){return function(me,be){var ke=be?P[F]:P[C];return me.replace(ke,function(Le,Se,we,Re,Ae){var Me;return R("tilde",me,Le,Se,we,Re,Ae),Te(Se)?Me="":Te(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te(Re)?Me=">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":Ae?(R("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Me=">="+Se+"."+we+"."+Re+Ae+" <"+Se+"."+(+we+1)+".0"):Me=">="+Se+"."+we+"."+Re+" <"+Se+"."+(+we+1)+".0",R("tilde return",Me),Me})}(ge,le)}).join(" ")}(De,Y),R("tildes",De),De=function(se,le){return R("replaceXRanges",se,le),se.split(/\s+/).map(function(ge){return function(me,be){me=me.trim();var ke=be?P[T]:P[v];return me.replace(ke,function(Le,Se,we,Re,Ae,Me){R("xRange",me,Le,Se,we,Re,Ae,Me);var it=Te(we),Ke=it||Te(Re),xe=Ke||Te(Ae);return Se==="="&&xe&&(Se=""),it?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&xe?(Ke&&(Re=0),xe&&(Ae=0),Se===">"?(Se=">=",Ke?(we=+we+1,Re=0,Ae=0):xe&&(Re=+Re+1,Ae=0)):Se==="<="&&(Se="<",Ke?we=+we+1:Re=+Re+1),Le=Se+we+"."+Re+"."+Ae):Ke?Le=">="+we+".0.0 <"+(+we+1)+".0.0":xe&&(Le=">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0"),R("xRange return",Le),Le})}(ge,le)}).join(" ")}(De,Y),R("xrange",De),De=function(se,le){return R("replaceStars",se,le),se.trim().replace(P[B],"")}(De,Y),R("stars",De),De}(Oe,oe)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(ye)})),pe=pe.map(function(Oe){return new Ee(Oe,oe)})},Pe.prototype.intersects=function(ee,oe){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ee.set.some(function(pe){return pe.every(function(Oe){return ye.intersects(Oe,oe)})})})})},e.toComparators=function(ee,oe){return new Pe(ee,oe).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if($e(this.set[oe],ee))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ee,oe,ce){var ye=null,pe=null;try{var Oe=new Pe(oe,ce)}catch(De){return null}return ee.forEach(function(De){Oe.test(De)&&(ye&&pe.compare(De)!==-1||(pe=new Z(ye=De,ce)))}),ye},e.minSatisfying=function(ee,oe,ce){var ye=null,pe=null;try{var Oe=new Pe(oe,ce)}catch(De){return null}return ee.forEach(function(De){Oe.test(De)&&(ye&&pe.compare(De)!==1||(pe=new Z(ye=De,ce)))}),ye},e.validRange=function(ee,oe){try{return new Pe(ee,oe).range||"*"}catch(ce){return null}},e.ltr=function(ee,oe,ce){return qe(ee,oe,"<",ce)},e.gtr=function(ee,oe,ce){return qe(ee,oe,">",ce)},e.outside=qe,e.prerelease=function(ee,oe){var ce=Q(ee,oe);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ee,oe,ce){return ee=new Pe(ee,ce),oe=new Pe(oe,ce),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(P[_]);return oe==null?null:Q((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(J,e){var D,L,R=J.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(f){if(D===setTimeout)return setTimeout(f,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch(p){try{return D.call(null,f,0)}catch(g){return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch(f){D=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(f){L=A}})();var w,b=[],i=!1,I=-1;function m(){i&&w&&(i=!1,w.length?b=w.concat(b):I=-1,b.length&&E())}function E(){if(!i){var f=P(m);i=!0;for(var p=b.length;p;){for(w=b,b=[];++I<p;)w&&w[I].run();I=-1,p=b.length}w=null,i=!1,function(g){if(L===clearTimeout)return clearTimeout(g);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(g);try{L(g)}catch(y){try{return L.call(null,g)}catch(c){return L.call(this,g)}}}(f)}}function h(f,p){this.fun=f,this.array=p}function S(){}R.nextTick=function(f){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];b.push(new h(f,p)),b.length!==1||i||P(E)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(f){return[]},R.binding=function(f){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(f){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[102],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new R(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,8,68,2,100,102]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(c){c.None=()=>R.Disposable.None;function a(U){return(x,j=null,q)=>{let W=!1,$;return $=U(G=>{if(!W)return $?$.dispose():W=!0,x.call(j,G)},null,q),W&&$.dispose(),$}}c.once=a;function t(U,x){return u((j,q=null,W)=>U($=>j.call(q,x($)),null,W))}c.map=t;function s(U,x){return u((j,q=null,W)=>U($=>{x($),j.call(q,$)},null,W))}c.forEach=s;function r(U,x){return u((j,q=null,W)=>U($=>x($)&&j.call(q,$),null,W))}c.filter=r;function n(U){return U}c.signal=n;function o(...U){return(x,j=null,q)=>(0,R.combinedDisposable)(...U.map(W=>W($=>x.call(j,$),null,q)))}c.any=o;function l(U,x,j){let q=j;return t(U,W=>(q=x(q,W),q))}c.reduce=l;function u(U){let x;const j=new m({onFirstListenerAdd(){x=U(j.fire,j)},onLastListenerRemove(){x.dispose()}});return j.event}function d(U,x,j=100,q=!1,W){let $,G,M,B=0;const V=new m({leakWarningThreshold:W,onFirstListenerAdd(){$=U(Q=>{B++,G=x(G,Q),q&&!M&&(V.fire(G),G=void 0),clearTimeout(M),M=setTimeout(()=>{const Z=G;G=void 0,M=void 0,(!q||B>1)&&V.fire(Z),B=0},j)})},onLastListenerRemove(){$.dispose()}});return V.event}c.debounce=d;function v(U,x=(j,q)=>j===q){let j=!0,q;return r(U,W=>{const $=j||!x(W,q);return j=!1,q=W,$})}c.latch=v;function T(U,x){return[c.filter(U,x),c.filter(U,j=>!x(j))]}c.split=T;function _(U,x=!1,j=[]){let q=j.slice(),W=U(M=>{q?q.push(M):G.fire(M)});const $=()=>{q&&q.forEach(M=>G.fire(M)),q=null},G=new m({onFirstListenerAdd(){W||(W=U(M=>G.fire(M)))},onFirstListenerDidAdd(){q&&(x?setTimeout($):$())},onLastListenerRemove(){W&&W.dispose(),W=null}});return G.event}c.buffer=_;class O{constructor(x){this.event=x}map(x){return new O(t(this.event,x))}forEach(x){return new O(s(this.event,x))}filter(x){return new O(r(this.event,x))}reduce(x,j){return new O(l(this.event,x,j))}latch(){return new O(v(this.event))}debounce(x,j=100,q=!1,W){return new O(d(this.event,x,j,q,W))}on(x,j,q){return this.event(x,j,q)}once(x,j,q){return a(this.event)(x,j,q)}}function N(U){return new O(U)}c.chain=N;function C(U,x,j=q=>q){const q=(...M)=>G.fire(j(...M)),W=()=>U.on(x,q),$=()=>U.removeListener(x,q),G=new m({onFirstListenerAdd:W,onLastListenerRemove:$});return G.event}c.fromNodeEventEmitter=C;function F(U,x,j=q=>q){const q=(...M)=>G.fire(j(...M)),W=()=>U.addEventListener(x,q),$=()=>U.removeEventListener(x,q),G=new m({onFirstListenerAdd:W,onLastListenerRemove:$});return G.event}c.fromDOMEventEmitter=F;function z(U){return new Promise(x=>a(U)(x))}c.toPromise=z})(P=e.Event||(e.Event={}));class w{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${w._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let b=-1;function i(c){const a=b;return b=c,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(a,t=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let t=b;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||a<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let n,o=0;for(const[l,u]of this._stacks)(!n||o<u)&&(n=l,o=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(n)}return()=>{const n=this._stacks.get(s)||0;this._stacks.set(s,n-1)}}}class m{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(a,t,s)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(t?[a,t]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,t);const o=this._leakageMon?.check(this._listeners.size),l=(0,R.toDisposable)(()=>{o&&o(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof R.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class E extends m{async fireAsync(a,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,n]=this._asyncDeliveryQueue.shift(),o=[],l={...n,waitUntil:u=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),o.push(u)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(u){(0,D.onUnexpectedError)(u);continue}Object.freeze(o),await Promise.allSettled(o).then(u=>{for(const d of u)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=E;class h extends m{constructor(a){super(a);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class S extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=S;class f extends m{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class p{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const t={event:a,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(t=>this.emitter.fire(t))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=p;class g{constructor(){this.buffers=[]}wrapEvent(a){return(t,s,r)=>a(n=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>t.call(s,n)):t.call(s,n)},void 0,r)}bufferEvents(a){const t=[];this.buffers.push(t);const s=a();return this.buffers.pop(),t.forEach(r=>r()),s}}e.EventBufferer=g;class y{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(te[27],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,w){const b=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function w(b){return b===P.None||b===P.Cancelled||b instanceof k?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=R.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=A}),define(te[51],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const m=this._icons.get(I.id);m?I.description?m.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function k(i,I){return new P(i,I)}e.registerCodicon=k;function A(i){return i?i.replace(/\$\((.*?)\)/g,(I,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(I,m,E){this.id=I,this.definition=m,this.description=E,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function w(i,I){const m=["codicon","codicon-"+i];return I&&m.push("codicon-modifier-"+I),m}e.getClassNamesArray=w;var b;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function m(S){if(S instanceof P)return["codicon","codicon-"+S.id];const f=I.exec(S.id);if(!f)return m(P.error);let[,p,g]=f;const y=["codicon","codicon-"+p];return g&&y.push("codicon-modifier-"+g.substr(1)),y}i.asClassNameArray=m;function E(S){return m(S).join(" ")}i.asClassName=E;function h(S){return"."+m(S).join(".")}i.asCSSSelector=h})(b=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"})}(P=e.Codicon||(e.Codicon={}))}),define(te[52],ne([0,1,8,2]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(y){const c=y;return c?[c.on,c.pause,c.resume,c.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function k(y){const c=y;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(y,c){return new P(y,c)}e.newWriteableStream=A;class P{constructor(c,a){this.reducer=c,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(a=>a(c))}emitError(c){this.listeners.error.length===0?(0,D.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(a=>a(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,a){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(c,a){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(y,c){const a=[];let t;for(;(t=y.read())!==null;)a.push(t);return c(a)}e.consumeReadable=w;function b(y,c,a){const t=[];let s;for(;(s=y.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return y.read()}}}e.peekReadable=b;function i(y,c){return new Promise((a,t)=>{const s=[];I(y,{onData:r=>{c&&s.push(r)},onError:r=>{c?t(r):a(void 0)},onEnd:()=>{a(c?c(s):void 0)}})})}e.consumeStream=i;function I(y,c){y.on("error",a=>c.onError(a)),y.on("end",()=>c.onEnd()),y.on("data",a=>c.onData(a))}e.listenStream=I;function m(y,c){return new Promise((a,t)=>{const s=new L.DisposableStore,r=[],n=u=>{if(r.push(u),r.length>c)return s.dispose(),y.pause(),a({stream:y,buffer:r,ended:!1})},o=u=>t(u),l=()=>a({stream:y,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>y.removeListener("error",o))),y.on("error",o),s.add((0,L.toDisposable)(()=>y.removeListener("end",l))),y.on("end",l),s.add((0,L.toDisposable)(()=>y.removeListener("data",n))),y.on("data",n)})}e.peekStream=m;function E(y,c){const a=A(c);return a.end(y),a}e.toStream=E;function h(){const y=A(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=h;function S(y){let c=!1;return{read:()=>c?null:(c=!0,y)}}e.toReadable=S;function f(y,c,a){const t=A(a);return I(y,{onData:s=>t.write(c.data(s)),onError:s=>t.error(c.error?c.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function p(y,c,a){let t=!1;return{read:()=>{const s=c.read();return t?s:(t=!0,s!==null?a([y,s]):y)}}}e.prefixedReadable=p;function g(y,c,a){let t=!1;const s=A(a);return I(c,{onData:r=>t?s.write(r):(t=!0,s.write(a([y,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(y)),s.end()}}),s}e.prefixedStream=g}),define(te[22],ne([0,1,52]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,k;class A{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return L?new A(Buffer.allocUnsafe(n)):new A(new Uint8Array(n))}static wrap(n){return L&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new A(n)}static fromString(n,o){return!(o?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(n)):(R||(R=new TextEncoder),new A(R.encode(n)))}static concat(n,o){if(typeof o=="undefined"){o=0;for(let d=0,v=n.length;d<v;d++)o+=n[d].byteLength}const l=A.alloc(o);let u=0;for(let d=0,v=n.length;d<v;d++){const T=n[d];l.set(T,u),u+=T.byteLength}return l}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(n,o){return new A(this.buffer.subarray(n,o))}set(n,o){n instanceof A?this.buffer.set(n.buffer,o):this.buffer.set(n,o)}readUInt32BE(n){return b(this.buffer,n)}writeUInt32BE(n,o){i(this.buffer,n,o)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,o){m(this.buffer,n,o)}readUInt8(n){return E(this.buffer,n)}writeUInt8(n,o){h(this.buffer,n,o)}}e.VSBuffer=A;function P(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}e.readUInt16LE=P;function w(r,n,o){r[o+0]=n&255,n=n>>>8,r[o+1]=n&255}e.writeUInt16LE=w;function b(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}e.readUInt32BE=b;function i(r,n,o){r[o+3]=n,n=n>>>8,r[o+2]=n,n=n>>>8,r[o+1]=n,n=n>>>8,r[o]=n}e.writeUInt32BE=i;function I(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}e.readUInt32LE=I;function m(r,n,o){r[o+0]=n&255,n=n>>>8,r[o+1]=n&255,n=n>>>8,r[o+2]=n&255,n=n>>>8,r[o+3]=n&255}e.writeUInt32LE=m;function E(r,n){return r[n]}e.readUInt8=E;function h(r,n,o){r[o]=n}e.writeUInt8=h;function S(r){return D.consumeReadable(r,n=>A.concat(n))}e.readableToBuffer=S;function f(r){return D.toReadable(r)}e.bufferToReadable=f;function p(r){return D.consumeStream(r,n=>A.concat(n))}e.streamToBuffer=p;async function g(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await p(r.stream)])}e.bufferedStreamToBuffer=g;function y(r){return D.toStream(r,n=>A.concat(n))}e.bufferToStream=y;function c(r){return D.transform(r,{data:n=>typeof n=="string"?A.fromString(n):A.wrap(n)},n=>A.concat(n))}e.streamToBufferReadableStream=c;function a(r){return D.newWriteableStream(n=>A.concat(n),r)}e.newWriteableBufferStream=a;function t(r,n){return D.prefixedReadable(r,n,o=>A.concat(o))}e.prefixedBufferReadable=t;function s(r,n){return D.prefixedStream(r,n,o=>A.concat(o))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(Y,...se){return se.length===0?Y:Y.replace(L,function(le,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=R;const k=/{([^}]+)}/g;function A(Y,se){return Y.replace(k,(le,ge)=>se[ge]??le)}e.format2=A;function P(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function w(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function b(Y,se){let le=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&le++;return le}e.count=b;function i(Y,se,le="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${le}`}e.truncate=i;function I(Y,se=" "){const le=m(Y,se);return E(le,se)}e.trim=I;function m(Y,se){if(!Y||!se)return Y;const le=se.length;if(le===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+le;return Y.substring(ge)}e.ltrim=m;function E(Y,se){if(!Y||!se)return Y;const le=se.length,ge=Y.length;if(le===0||ge===0)return Y;let me=ge,be=-1;for(;be=Y.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return Y.substring(0,me)}e.rtrim=E;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function S(Y){return Y.replace(/\*/g,"")}e.stripWildcards=S;function f(Y,se,le={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=w(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return le.global&&(ge+="g"),le.matchCase||(ge+="i"),le.multiline&&(ge+="m"),le.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=f;function p(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function g(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function y(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=y;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function a(Y){for(let se=0,le=Y.length;se<le;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=a;function t(Y,se=0,le=Y.length){for(let ge=se;ge<le;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,le)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let le=se;le>=0;le--){const ge=Y.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function n(Y,se,le=0,ge=Y.length,me=0,be=se.length){for(;le<ge&&me<be;le++,me++){let Se=Y.charCodeAt(le),we=se.charCodeAt(me);if(Se<we)return-1;if(Se>we)return 1}const ke=ge-le,Le=be-me;return ke<Le?-1:ke>Le?1:0}e.compareSubstring=n;function o(Y,se){return l(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=o;function l(Y,se,le=0,ge=Y.length,me=0,be=se.length){for(;le<ge&&me<be;le++,me++){let Se=Y.charCodeAt(le),we=se.charCodeAt(me);if(Se===we)continue;if(Se>=128||we>=128)return n(Y.toLowerCase(),se.toLowerCase(),le,ge,me,be);u(Se)&&(Se-=32),u(we)&&(we-=32);const Re=Se-we;if(Re!==0)return Re}const ke=ge-le,Le=be-me;return ke<Le?-1:ke>Le?1:0}e.compareSubstringIgnoreCase=l;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function d(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=d;function v(Y,se){return Y.length===se.length&&l(Y,se)===0}e.equalsIgnoreCase=v;function T(Y,se){const le=se.length;return se.length>Y.length?!1:l(Y,se,0,le)===0}e.startsWithIgnoreCase=T;function _(Y,se){let le,ge=Math.min(Y.length,se.length);for(le=0;le<ge;le++)if(Y.charCodeAt(le)!==se.charCodeAt(le))return le;return ge}e.commonPrefixLength=_;function O(Y,se){let le,ge=Math.min(Y.length,se.length);const me=Y.length-1,be=se.length-1;for(le=0;le<ge;le++)if(Y.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return ge}e.commonSuffixLength=O;function N(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=N;function C(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=C;function F(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=F;function z(Y,se,le){const ge=Y.charCodeAt(le);if(N(ge)&&le+1<se){const me=Y.charCodeAt(le+1);if(C(me))return F(ge,me)}return ge}e.getNextCodePoint=z;function U(Y,se){const le=Y.charCodeAt(se-1);if(C(le)&&se>1){const ge=Y.charCodeAt(se-2);if(N(ge))return F(ge,le)}return le}function x(Y,se){const le=ee.getInstance(),ge=se,me=Y.length,be=z(Y,me,se);se+=be>=65536?2:1;let ke=le.getGraphemeBreakType(be);for(;se<me;){const Le=z(Y,me,se),Se=le.getGraphemeBreakType(Le);if(Ne(ke,Se))break;se+=Le>=65536?2:1,ke=Se}return se-ge}e.nextCharLength=x;function j(Y,se){const le=ee.getInstance(),ge=se,me=U(Y,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const ke=U(Y,se),Le=le.getGraphemeBreakType(ke);if(Ne(Le,be))break;se-=ke>=65536?2:1,be=Le}return ge-se}e.prevCharLength=j;function q(Y,se){const le=ee.getInstance(),ge=Y.length,me=se,be=z(Y,ge,se),ke=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let Le=ke;for(;se<ge;){const we=z(Y,ge,se),Re=le.getGraphemeBreakType(we);if(Ne(Le,Re))break;se+=we>=65536?2:1,Le=Re}const Se=se;for(se=me,Le=ke;se>0;){const we=U(Y,se),Re=le.getGraphemeBreakType(we);if(Ne(Re,Le))break;se-=we>=65536?2:1,Le=Re}return[se,Se]}function W(Y,se){return se>0&&C(Y.charCodeAt(se))?q(Y,se-1):q(Y,se)}e.getCharContainingOffset=W;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(Y){return $.test(Y)}e.containsRTL=G;const M=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return M.test(Y)}e.containsEmoji=B;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function K(Y){for(let se=0,le=Y.length;se<le;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=K;function H(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const le=/\b/g;let ge=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<se);)ge=le.lastIndex,le.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ae=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function de(Y){return Y&&(Y=Y.replace(ae,""),Y=Y.replace(ue,""),Y=Y.replace(fe,"")),Y}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Ce(Y){return Ie(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const le=se.length,ge=Y.toLowerCase();let me=0,be=-1;for(;me<le;){const ke=ge.indexOf(se[me],be+1);if(ke<0)return!1;be=ke,me++}return!0}e.fuzzyContains=Ee;function _e(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=_e;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Te(Y,se=1){if(se===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=Te;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function $e(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=$e;function Ne(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var qe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=oe()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,ge=le.length/3;let me=1;for(;me<=ge;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ee._INSTANCE=null;function oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ce(Y,se){if(Y===0)return 0;const le=ye(Y,se);if(le!==void 0)return le;const ge=U(se,Y);return Y-=pe(ge),Y}e.getLeftDeleteOffset=ce;function ye(Y,se){let le=U(se,Y);for(Y-=pe(le);Oe(le)||le===65039||le===8419;){if(Y===0)return;le=U(se,Y),Y-=pe(le)}if(!!re(le)){if(Y>=0){const ge=U(se,Y);ge===8205&&(Y-=pe(ge))}return Y}}function pe(Y){return Y>=65536?2:1}function Oe(Y){return 127995<=Y&&Y<=127999}var De;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(te[103],ne([0,1,25]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(p){return R(p,0)}e.hash=L;function R(p,g){switch(typeof p){case"object":return p===null?k(349,g):Array.isArray(p)?w(p,g):b(p,g);case"string":return P(p,g);case"boolean":return A(p,g);case"number":return k(p,g);case"undefined":return k(937,g);default:return k(617,g)}}e.doHash=R;function k(p,g){return(g<<5)-g+p|0}e.numberHash=k;function A(p,g){return k(p?433:863,g)}function P(p,g){g=k(149417,g);for(let y=0,c=p.length;y<c;y++)g=k(p.charCodeAt(y),g);return g}e.stringHash=P;function w(p,g){return g=k(104579,g),p.reduce((y,c)=>R(c,y),g)}function b(p,g){return g=k(181387,g),Object.keys(p).sort().reduce((y,c)=>(y=P(c,y),R(p[c],y)),g)}class i{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=R(g,this._value),this._value}}e.Hasher=i;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function m(p,g,y=32){const c=y-g,a=~((1<<c)-1);return(p<<g|(a&p)>>>c)>>>0}function E(p,g=0,y=p.byteLength,c=0){for(let a=0;a<y;a++)p[g+a]=c}function h(p,g,y="0"){for(;p.length<g;)p=y+p;return p}function S(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(y=>y.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),g/4)}e.toHexString=S;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const y=g.length;if(y===0)return;const c=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=g.charCodeAt(0),r=0);;){let n=s;if(D.isHighSurrogate(s))if(r+1<y){const o=g.charCodeAt(r+1);D.isLowSurrogate(o)?(r++,n=D.computeCodePoint(s,o)):n=65533}else{t=s;break}else D.isLowSurrogate(s)&&(n=65533);if(a=this._push(c,a,n),r++,r<y)s=g.charCodeAt(r);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(g,y,c){return c<128?g[y++]=c:c<2048?(g[y++]=192|(c&1984)>>>6,g[y++]=128|(c&63)>>>0):c<65536?(g[y++]=224|(c&61440)>>>12,g[y++]=128|(c&4032)>>>6,g[y++]=128|(c&63)>>>0):(g[y++]=240|(c&1835008)>>>18,g[y++]=128|(c&258048)>>>12,g[y++]=128|(c&4032)>>>6,g[y++]=128|(c&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=f._bigBlock32,y=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,y.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,m(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let c=this._h0,a=this._h1,t=this._h2,s=this._h3,r=this._h4,n,o,l;for(let u=0;u<80;u++)u<20?(n=a&t|~a&s,o=1518500249):u<40?(n=a^t^s,o=1859775393):u<60?(n=a&t|a&s|t&s,o=2400959708):(n=a^t^s,o=3395469782),l=m(c,5)+n+r+o+g.getUint32(u*4,!1)&4294967295,r=s,s=t,t=m(a,30),a=c,c=l;this._h0=this._h0+c&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function L(d){return typeof d=="string"}e.isString=L;function R(d){return Array.isArray(d)&&d.every(v=>L(v))}e.isStringArray=R;function k(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=k;function A(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=A;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function w(d){return d===!0||d===!1}e.isBoolean=w;function b(d){return typeof d=="undefined"}e.isUndefined=b;function i(d){return!I(d)}e.isDefined=i;function I(d){return b(d)||d===null}e.isUndefinedOrNull=I;function m(d,v){if(!d)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=m;function E(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=E;function h(...d){const v=[];for(let T=0;T<d.length;T++){const _=d[T];if(I(_))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);v.push(_)}return v}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function f(d){if(!k(d))return!1;for(let v in d)if(S.call(d,v))return!1;return!0}e.isEmptyObject=f;function p(d){return typeof d=="function"}e.isFunction=p;function g(...d){return d.length>0&&d.every(p)}e.areFunctions=g;function y(d,v){const T=Math.min(d.length,v.length);for(let _=0;_<T;_++)c(d[_],v[_])}e.validateConstraints=y;function c(d,v){if(L(v)){if(typeof d!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(p(v)){try{if(d instanceof v)return}catch{}if(!I(d)&&d.constructor===v||v.length===1&&v.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function a(d){let v=[],T=Object.getPrototypeOf(d);for(;Object.prototype!==T;)v=v.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return v}e.getAllPropertyNames=a;function t(d){const v=[];for(const T of a(d))typeof d[T]=="function"&&v.push(T);return v}e.getAllMethodNames=t;function s(d,v){const T=O=>function(){const N=Array.prototype.slice.call(arguments,0);return v(O,N)};let _={};for(const O of d)_[O]=T(O);return _}e.createProxyObject=s;function r(d){return d===null?void 0:d}e.withNullAsUndefined=r;function n(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=n;function o(d){return class{constructor(){return new Proxy({},{get(v,T){if(v[T])return v[T];throw new Error(`Not Implemented: ${d}->${String(T)}`)}})}}}e.NotImplementedProxy=o;function l(d,v="Unreachable"){throw new Error(v)}e.assertNever=l;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(te[39],ne([0,1,9,4,25,18]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function P(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function w(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function b(r,n=D.posix.sep){if(!r)return"";const o=r.length,l=r.charCodeAt(0);if(A(l)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let d=3;const v=d;for(;d<o&&!A(r.charCodeAt(d));d++);if(v!==d&&!A(r.charCodeAt(d+1))){for(d+=1;d<o;d++)if(A(r.charCodeAt(d)))return r.slice(0,d+1).replace(/[\\/]/g,n)}}return n}else if(p(l)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<o;u++)if(A(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=b;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let o=2;const l=o;for(;o<r.length&&(n=r.charCodeAt(o),n!==92);o++);return!(l===o||(n=r.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,n=L.isWindows){const o=n?I:m;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||n&&E.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function S(r,n,o){const l=r===n;return!o||l?l:!r||!n?!1:(0,R.equalsIgnoreCase)(r,n)}e.isEqual=S;function f(r,n,o,l=D.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let d=n.length;return n.charAt(n.length-1)===l&&d--,r.charAt(d)===l}return n.charAt(n.length-1)!==l&&(n+=l),r.indexOf(n)===0}e.isEqualOrParent=f;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function g(r,n){return L.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(n,r)),r=(0,D.normalize)(r),L.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=g;function y(r){const n=(0,D.normalize)(r);return L.isWindows?r.length>3?!1:c(n)&&(r.length===2||n.charCodeAt(2)===92):n===D.posix.sep}e.isRootOrDriveLetter=y;function c(r){return L.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function a(r){return c(r)?r[0]:void 0}e.getDriveLetter=a;function t(r,n,o){return n.length>r.length?-1:r===n?0:(o&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function s(r){const n=r.split(":");let o,l,u;if(n.forEach(d=>{const v=Number(d);(0,k.isNumber)(v)?l===void 0?l=v:u===void 0&&(u=v):o=o?[o,d].join(":"):d}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:u!==void 0?u:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const f=Array.isArray(S)?[]:{};return Object.keys(S).forEach(p=>{S[p]&&typeof S[p]=="object"?f[p]=L(S[p]):f[p]=S[p]}),f}e.deepClone=L;function R(S){if(!S||typeof S!="object")return S;const f=[S];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const g in p)if(k.call(p,g)){const y=p[g];typeof y=="object"&&!Object.isFrozen(y)&&f.push(y)}}return S}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function A(S,f){return P(S,f,new Set)}e.cloneAndChange=A;function P(S,f,p){if((0,D.isUndefinedOrNull)(S))return S;const g=f(S);if(typeof g!="undefined")return g;if((0,D.isArray)(S)){const y=[];for(const c of S)y.push(P(c,f,p));return y}if((0,D.isObject)(S)){if(p.has(S))throw new Error("Cannot clone recursive data-structure");p.add(S);const y={};for(let c in S)k.call(S,c)&&(y[c]=P(S[c],f,p));return p.delete(S),y}return S}function w(S,f,p=!0){return(0,D.isObject)(S)?((0,D.isObject)(f)&&Object.keys(f).forEach(g=>{g in S?p&&((0,D.isObject)(S[g])&&(0,D.isObject)(f[g])?w(S[g],f[g],p):S[g]=f[g]):S[g]=f[g]}),S):f}e.mixin=w;function b(S,f){if(S===f)return!0;if(S==null||f===null||f===void 0||typeof S!=typeof f||typeof S!="object"||Array.isArray(S)!==Array.isArray(f))return!1;let p,g;if(Array.isArray(S)){if(S.length!==f.length)return!1;for(p=0;p<S.length;p++)if(!b(S[p],f[p]))return!1}else{const y=[];for(g in S)y.push(g);y.sort();const c=[];for(g in f)c.push(g);if(c.sort(),!b(y,c))return!1;for(p=0;p<y.length;p++)if(!b(S[y[p]],f[y[p]]))return!1}return!0}e.equals=b;function i(S){const f=new Set;return JSON.stringify(S,(p,g)=>{if((0,D.isObject)(g)||Array.isArray(g)){if(f.has(g))return"[Circular]";f.add(g)}return g})}e.safeStringify=i;function I(S,f,p){const g=f(S);return typeof g=="undefined"?p:g}e.getOrDefault=I;function m(S,f){const p=Object.create(null);return!S||!f||Object.keys(f).forEach(y=>{const c=S[y],a=f[y];b(c,a)||(p[y]=a)}),p}e.distinct=m;function E(S,f){const p=f.toLowerCase(),g=Object.keys(S).find(y=>y.toLowerCase()===p);return g?S[g]:S[f]}e.getCaseInsensitive=E;function h(S,f){const p=Object.create(null);for(const g of Object.keys(S))f(g,S[g])&&(p[g]=S[g]);return p}e.filter=h}),define(te[7],ne([0,1,9,4]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function P(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!R.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!k.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,n){return!r&&!n?"file":r}function b(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const i="",I="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(n,o,l,u,d,v=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=w(n,v),this.authority=o||i,this.path=b(this.scheme,l||i),this.query=u||i,this.fragment=d||i,P(this,v))}static isUri(n){return n instanceof E?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:l,path:u,query:d,fragment:v}=n;return o===void 0?o=this.scheme:o===null&&(o=i),l===void 0?l=this.authority:l===null&&(l=i),u===void 0?u=this.path:u===null&&(u=i),d===void 0?d=this.query:d===null&&(d=i),v===void 0?v=this.fragment:v===null&&(v=i),o===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&v===this.fragment?this:new S(o,l,u,d,v)}static parse(n,o=!1){const l=m.exec(n);return l?new S(l[2]||i,s(l[4]||i),s(l[5]||i),s(l[7]||i),s(l[9]||i),o):new S(i,i,i,i,i)}static file(n){let o=i;if(L.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const l=n.indexOf(I,2);l===-1?(o=n.substring(2),n=I):(o=n.substring(2,l),n=n.substring(l)||I)}return new S("file",o,n,i,i)}static from(n){const o=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&n.scheme==="file"?l=E.file(D.win32.join(y(n,!0),...o)).path:l=D.posix.join(n.path,...o),n.with({path:l})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof E)return n;{const o=new S(n);return o._formatted=n.external,o._fsPath=n._sep===h?n.fsPath:null,o}}else return n}}e.URI=E;const h=L.isWindows?1:void 0;class S extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,n){let o,l=-1;for(let u=0;u<r.length;u++){const d=r.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||n&&d===47)l!==-1&&(o+=encodeURIComponent(r.substring(l,u)),l=-1),o!==void 0&&(o+=r.charAt(u));else{o===void 0&&(o=r.substr(0,u));const v=f[d];v!==void 0?(l!==-1&&(o+=encodeURIComponent(r.substring(l,u)),l=-1),o+=v):l===-1&&(l=u)}}return l!==-1&&(o+=encodeURIComponent(r.substring(l))),o!==void 0?o:r}function g(r){let n;for(let o=0;o<r.length;o++){const l=r.charCodeAt(o);l===35||l===63?(n===void 0&&(n=r.substr(0,o)),n+=f[l]):n!==void 0&&(n+=r[o])}return n!==void 0?n:r}function y(r,n){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=y;function c(r,n){const o=n?g:p;let l="",{scheme:u,authority:d,path:v,query:T,fragment:_}=r;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=I,l+=I),d){let O=d.indexOf("@");if(O!==-1){const N=d.substr(0,O);d=d.substr(O+1),O=N.indexOf(":"),O===-1?l+=o(N,!1):(l+=o(N.substr(0,O),!1),l+=":",l+=o(N.substr(O+1),!1)),l+="@"}d=d.toLowerCase(),O=d.indexOf(":"),O===-1?l+=o(d,!1):(l+=o(d.substr(0,O),!1),l+=d.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}l+=o(v,!0)}return T&&(l+="?",l+=o(T,!1)),_&&(l+="#",l+=n?_:p(_,!1)),l}function a(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+a(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,n=>a(n)):r}}),define(te[104],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const i=b;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(b){const i=[];let I;try{const m=JSON.parse(b.arguments),E=m[m.length-1];E&&E.__$stack&&(m.pop(),I=E.__$stack),i.push(...m)}catch(m){i.push("Unable to log remote console arguments",b.arguments)}return{args:i,stack:I}}e.parse=R;function k(b){if(typeof b!="string")return k(R(b).stack);const i=b;if(i){const I=A(i),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function A(b){if(!b)return b;const i=b.indexOf(`
`);return i===-1?b:b.substring(0,i)}function P(b,i){const{args:I,stack:m}=R(b),E=typeof I[0]=="string"&&I.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let S=[];if(typeof I[0]=="string"?h&&E?S=[`%c[${i}] %c${I[0]} %c${h}`,w("blue"),w(""),w("grey")]:S=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:S=[`%c[${i}]%`,w("blue"),...I],h&&!E&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=P;function w(b){return`color: ${b}`}});var St=this&&this.__classPrivateFieldSet||function(J,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(J,D):R?R.value=D:e.set(J,D),D},Be=this&&this.__classPrivateFieldGet||function(J,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(J):L?L.value:e.get(J)};define(te[40],ne([0,1,17,25,7]),function(J,e,D,L,R){"use strict";var k,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function w(r,n,o){let l=r.get(n);return l===void 0&&(l=o,r.set(n,l)),l}e.getOrSet=w;function b(r){const n=[];return r.forEach((o,l)=>{n.push(`${l} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=b;function i(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=i;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=I;class m{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class E{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var h;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(h||(h={}));class S{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=S;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(p||(p={}));class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new S(n))}static forPaths(){return new g(new E)}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new m)}clear(){this._root=void 0}fill(n,o){if(o){const l=o.slice(0);(0,D.shuffle)(l);for(let u of l)this.set(u,n)}else{const l=n.slice(0);(0,D.shuffle)(l);for(let u of l)this.set(u[0],u[1])}}set(n,o){const l=this._iter.reset(n);let u;this._root||(this._root=new f,this._root.segment=l.value());const d=[];for(u=this._root;;){const T=l.cmp(u.segment);if(T>0)u.left||(u.left=new f,u.left.segment=l.value()),d.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new f,u.right.segment=l.value()),d.push([1,u]),u=u.right;else if(l.hasNext())l.next(),u.mid||(u.mid=new f,u.mid.segment=l.value()),d.push([0,u]),u=u.mid;else break}const v=u.value;u.value=o,u.key=n;for(let T=d.length-1;T>=0;T--){const _=d[T][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const N=d[T][0],C=d[T+1][0];if(N===1&&C===1)d[T][1]=_.rotateLeft();else if(N===-1&&C===-1)d[T][1]=_.rotateRight();else if(N===1&&C===-1)_.right=d[T+1][1]=d[T+1][1].rotateRight(),d[T][1]=_.rotateLeft();else if(N===-1&&C===1)_.left=d[T+1][1]=d[T+1][1].rotateLeft(),d[T][1]=_.rotateRight();else throw new Error;if(T>0)switch(d[T-1][0]){case-1:d[T-1][1].left=d[T][1];break;case 1:d[T-1][1].right=d[T][1];break;case 0:d[T-1][1].mid=d[T][1];break}else this._root=d[0][1]}}return v}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const l=this._iter.reset(n),u=[];let d=this._root;for(;d;){const v=l.cmp(d.segment);if(v>0)u.push([-1,d]),d=d.left;else if(v<0)u.push([1,d]),d=d.right;else if(l.hasNext())l.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const v=this._min(d.right),{key:T,value:_,segment:O}=v;this._delete(v.key,!1),d.key=T,d.value=_,d.segment=O}else{const v=d.left??d.right;if(u.length>0){const[T,_]=u[u.length-1];switch(T){case-1:_.left=v;break;case 0:_.mid=v;break;case 1:_.right=v;break}}else this._root=v}for(let v=u.length-1;v>=0;v--){const T=u[v][1];T.updateHeight();const _=T.balanceFactor();if(_>1?(T.right.balanceFactor()>=0||(T.right=u[v+1][1]=u[v+1][1].rotateRight()),u[v][1]=T.rotateLeft()):_<-1&&(T.left.balanceFactor()<=0||(T.left=u[v+1][1]=u[v+1][1].rotateLeft()),u[v][1]=T.rotateRight()),v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let l=this._root,u;for(;l;){const d=o.cmp(l.segment);if(d>0)l=l.left;else if(d<0)l=l.right;else if(o.hasNext())o.next(),u=l.value||u,l=l.mid;else break}return l&&l.value||u}findSuperstr(n){const o=this._iter.reset(n);let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(n){for(const[o,l]of this)n(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=g;class y{constructor(n,o){this[k]="ResourceMap",n instanceof y?(this.map=new Map(n.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=n??y.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),o),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[l,u]of this.map)n(u,R.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield R.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[R.URI.parse(n[0]),n[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[R.URI.parse(n[0]),n[1]]}}e.ResourceMap=y,y.defaultToKey=r=>r.toString();var c;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class a{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const l=this._map.get(n);if(!!l)return o!==0&&this.touch(l,o),l.value}set(n,o,l=0){let u=this._map.get(n);if(u)u.value=o,l!==0&&this.touch(u,l);else{switch(u={key:n,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const l=this._state;let u=this._head;for(;u;){if(o?n.bind(o)(u.value,u.key,this):n(u.value,u.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.key,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}values(){const n=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:l.value,done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}entries(){const n=this,o=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const d={value:[l.key,l.value],done:!1};return l=l.next,d}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>n;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,l=n.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const l=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(l.previous=u,u.next=l),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const l=n.next,u=n.previous;n===this._head?(l.previous=void 0,this._head=l):(l.previous=u,u.next=l),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,l)=>{n.push([l,o])}),n}fromJSON(n){this.clear();for(const[o,l]of n)this.set(o,l)}}e.LinkedMap=a;class t extends a{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(n){P.set(this,void 0),St(this,P,n,"f")}get size(){return Be(this,P,"f").size}forEach(n,o){Be(this,P,"f").forEach(n,o)}get(n){return Be(this,P,"f").get(n)}has(n){return Be(this,P,"f").has(n)}entries(){return Be(this,P,"f").entries()}keys(){return Be(this,P,"f").keys()}values(){return Be(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Be(this,P,"f").entries()}}e.ReadonlyMapView=s}),define(te[105],ne([0,1,22,25,7]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(i){return JSON.stringify(i,w)}e.stringify=k;function A(i){let I=JSON.parse(i);return I=b(I),I}e.parse=A;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function w(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function b(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let m=0;m<i.length;++m)i[m]=b(i[m],I+1);else for(const m in i)Object.hasOwnProperty.call(i,m)&&(i[m]=b(i[m],I+1))}return i}e.revive=b}),define(te[15],ne([0,1,4,7]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,b,i){this._hosts[w]=b,this._ports[w]=i}setConnectionToken(w,b){this._connectionTokens[w]=b}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let i=this._hosts[b];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[b],m=this._connectionTokens[b];let E=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(E+=`&tkn=${encodeURIComponent(m)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new k;class A{asBrowserUri(w,b){const i=this.toUri(w,b);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(w,b){const i=this.toUri(w,b);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,b){return L.URI.isUri(w)?w:L.URI.parse(b.toUrl(w))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[69],ne([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(b){return w(b,"NFC",L)}e.normalizeNFC=R;const k=new D.LRUCache(1e4);function A(b){return w(b,"NFD",k)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function w(b,i,I){if(!b)return b;const m=I.get(b);if(m)return m;let E;return P.test(b)?E=b.normalize(i):E=b,I.set(b,E),E}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(i){return A(i).replace(b,"")}}()}),define(te[16],ne([0,1,39,15,9,4,25,7]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(E){return(0,P.uriToFsPath)(E,!0)}e.originalFSPath=w;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,f=!1){return h===S?0:(0,A.compare)(this.getComparisonKey(h,f),this.getComparisonKey(S,f))}isEqual(h,S,f=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,f)===this.getComparisonKey(S,f)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,f=!1){if(h.scheme===S.scheme){if(h.scheme===L.Schemas.file)return D.isEqualOrParent(w(h),w(S),this._ignorePathCasing(h))&&h.query===S.query&&(f||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return D.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(f||h.fragment===S.fragment)}return!1}joinPath(h,...S){return P.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===L.Schemas.file?S=P.URI.file(R.dirname(w(h))).path:(S=R.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===L.Schemas.file?S=P.URI.file(R.normalize(w(h))).path:S=R.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===L.Schemas.file){const g=R.relative(w(h),w(S));return k.isWindows?D.toSlashes(g):g}let f=h.path||"/",p=S.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const y=Math.min(f.length,p.length);g<y&&!(f.charCodeAt(g)!==p.charCodeAt(g)&&f.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);f=p.substr(0,g)+f.substr(g)}return R.posix.relative(f,p)}resolvePath(h,S){if(h.scheme===L.Schemas.file){const f=P.URI.file(R.resolve(w(h),S));return h.with({authority:f.authority,path:f.path})}return S=D.toPosixPath(S),h.with({path:R.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||(0,A.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=R.sep){if(h.scheme===L.Schemas.file){const f=w(h);return f.length>D.getRoot(f).length&&f[f.length-1]===S}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=R.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=R.sep){let f=!1;if(h.scheme===L.Schemas.file){const p=w(h);f=p!==void 0&&p.length===D.getRoot(p).length&&p[p.length-1]===S}else{S="/";const p=h.path;f=p.length===1&&p.charCodeAt(p.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(E=>E.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new b(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(E,h){const S=[];for(let f=0;f<E.length;f++){const p=h(E[f]);E.some((g,y)=>y===f?!1:(0,e.isEqualOrParent)(p,h(g)))||S.push(E[f])}return S}e.distinctParents=i;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(S){const f=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(y=>{const[c,a]=y.split(":");c&&a&&f.set(c,a)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&f.set(E.META_DATA_MIME,g),f}E.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function m(E,h,S){if(h){let f=E.path;return f&&f[0]!==R.posix.sep&&(f=R.posix.sep+f),E.with({scheme:S,authority:h,path:f})}return E.with({scheme:S})}e.toLocalResource=m}),define(te[5],ne([0,1,27,8,3,2,16]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(j){return!!j&&typeof j.then=="function"}e.isThenable=P;function w(j){const q=new D.CancellationTokenSource,W=j(q.token),$=new Promise((G,M)=>{const B=q.token.onCancellationRequested(()=>{B.dispose(),q.dispose(),M((0,L.canceled)())});Promise.resolve(W).then(V=>{B.dispose(),q.dispose(),G(V)},V=>{B.dispose(),q.dispose(),M(V)})});return new class{cancel(){q.cancel()}then(G,M){return $.then(G,M)}catch(G){return this.then(void 0,G)}finally(G){return $.finally(G)}}}e.createCancelablePromise=w;function b(j,q,W){return Promise.race([j,new Promise($=>q.onCancellationRequested(()=>$(W)))])}e.raceCancellation=b;async function i(j){let q=-1;const W=j.map((G,M)=>G.then(B=>(q=M,B))),$=await Promise.race(W);return j.forEach((G,M)=>{M!==q&&G.cancel()}),$}e.raceCancellablePromises=i;function I(j,q,W){let $;const G=setTimeout(()=>{$?.(void 0),W?.()},q);return Promise.race([j.finally(()=>clearTimeout(G)),new Promise(M=>$=M)])}e.raceTimeout=I;function m(j){return new Promise((q,W)=>{const $=j();P($)?$.then(q,W):q($)})}e.asPromise=m;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(W,W).then($)})}return new Promise((W,$)=>{this.queuedPromise.then(W,$)})}return this.activePromise=q(),new Promise((W,$)=>{this.activePromise.then(G=>{this.activePromise=null,W(G)},G=>{this.activePromise=null,$(G)})})}}e.Throttler=E;class h{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(q,W){const G=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(q)===G&&this.promiseMap.delete(q)});return this.promiseMap.set(q,G),G}}e.SequencerByKey=S;class f{constructor(q){this.defaultDelay=q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,W=this.defaultDelay){return this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,G)=>{this.doResolve=$,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class p{constructor(q){this.delayer=new f(q),this.throttler=new E}trigger(q,W){return this.delayer.trigger(()=>this.throttler.queue(q),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class g{constructor(){this._isOpen=!1,this._promise=new Promise((q,W)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class y extends g{constructor(q){super();this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=y;function c(j,q){return q?new Promise((W,$)=>{const G=setTimeout(()=>{M.dispose(),W()},j),M=q.onCancellationRequested(()=>{clearTimeout(G),M.dispose(),$((0,L.canceled)())})}):w(W=>c(j,W))}e.timeout=c;function a(j,q=0){const W=setTimeout(j,q);return(0,k.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=a;function t(j){const q=[];let W=0;const $=j.length;function G(){return W<$?j[W++]():null}function M(B){B!=null&&q.push(B);const V=G();return V?V.then(M):Promise.resolve(q)}return Promise.resolve(null).then(M)}e.sequence=t;function s(j,q=$=>!!$,W=null){let $=0;const G=j.length,M=()=>{if($>=G)return Promise.resolve(W);const B=j[$++];return Promise.resolve(B()).then(Q=>q(Q)?Promise.resolve(Q):M())};return M()}e.first=s;function r(j,q=$=>!!$,W=null){if(j.length===0)return Promise.resolve(W);let $=j.length;const G=()=>{$=-1;for(const M of j)M.cancel?.()};return new Promise((M,B)=>{for(const V of j)V.then(Q=>{--$>=0&&q(Q)?(G(),M(Q)):$===0&&M(W)}).catch(Q=>{--$>=0&&(G(),B(Q))})})}e.firstParallel=r;class n{constructor(q){this._size=0,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(q){return this._size++,new Promise((W,$)=>{this.outstandingPromises.push({factory:q,c:W,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const W=q.factory();W.then(q.c,q.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class o extends n{constructor(){super(1)}}e.Queue=o;class l{constructor(){this.queues=new Map}queueFor(q,W=A.extUri){const $=W.getComparisonKey(q);let G=this.queues.get($);return G||(G=new o,R.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete($)}),this.queues.set($,G)),G}dispose(){this.queues.forEach(q=>q.dispose()),this.queues.clear()}}e.ResourceQueue=l;class u{constructor(q,W){this._token=-1,typeof q=="function"&&typeof W=="number"&&this.setIfNotSet(q,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},W)}setIfNotSet(q,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},W))}}e.TimeoutTimer=u;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(q,W){this.cancel(),this._token=setInterval(()=>{q()},W)}}e.IntervalTimer=d;class v{constructor(q,W){this.timeoutToken=-1,this.runner=q,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=v;class T{constructor(q,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=q,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(q=this.timeout){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends v{constructor(q,W){super(q,W);this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner&&this.runner(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class O extends k.Disposable{constructor(q,W,$,G){super();this.maxWorkChunkSize=q,this.maxPendingWork=W,this.throttleDelay=$,this.handler=G,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.maxPendingWork)return!1}else if(this.pending+q.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new v(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{const q=setTimeout(()=>{const $=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0,clearTimeout(q))}}}:e.runWhenIdle=(j,q)=>{const W=requestIdleCallback(j,typeof q=="number"?{timeout:q}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(W))}}}}();class N{constructor(q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function C(j,q,W){let $;for(let G=0;G<W;G++)try{return await j()}catch(M){$=M,await c(q)}throw $}e.retry=C;class F{hasPending(q){return this._pending?typeof q=="number"?this._pending.taskId===q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(q,W,$){return this._pending={taskId:q,cancel:()=>$?.(),promise:W},W.then(()=>this.donePending(q),()=>this.donePending(q)),W}donePending(q){this._pending&&q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const q=this._next;this._next=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this._next)this._next.run=q;else{let W,$;const G=new Promise((M,B)=>{W=M,$=B});this._next={run:q,promise:G,promiseResolve:W,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=F;class z{constructor(q){this.interval=q,this.lastIncrementTime=0,this.value=0}increment(){const q=Date.now();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((q,W)=>{this.completeCallback=q,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(q){return new Promise(W=>{this.completeCallback(q),this.resolved=!0,W()})}error(q){return new Promise(W=>{this.errorCallback(q),this.rejected=!0,W()})}cancel(){new Promise(q=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,q()})}}e.DeferredPromise=U;var x;(function(j){async function q($){let G;const M=await Promise.all($.map(B=>B.then(V=>V,V=>{G||(G=V)})));if(typeof G!="undefined")throw G;return M}j.settled=q;function W($){return new Promise(async(G,M)=>{try{await $(G,M)}catch(B){M(B)}})}j.withAsyncBody=W})(x=e.Promises||(e.Promises={}))}),define(te[106],ne([0,1,5,39,40,9,25]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const w="**",b="/",i="[/\\\\]",I="[^/\\\\]",m=/\//g;function E($){switch($){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h($,G){if(!$)return[];const M=[];let B=!1,V=!1,Q="";for(const Z of $){switch(Z){case G:if(!B&&!V){M.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&M.push(Q),M}e.splitGlobAware=h;function S($){if(!$)return"";let G="";const M=h($,b);if(M.every(B=>B===w))G=".*";else{let B=!1;M.forEach((V,Q)=>{if(V===w){B||(G+=E(2),B=!0);return}let Z=!1,K="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){K+=ie;continue}if(H&&(ie!=="]"||!re)){let ae;ie==="-"?ae=ie:(ie==="^"||ie==="!")&&!re?ae="^":ie===b?ae="":ae=A.escapeRegExpCharacters(ie),re+=ae;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":G+=`(?:${h(K,",").map(fe=>S(fe)).join("|")})`,Z=!1,K="";break;case"]":G+="["+re+"]",H=!1,re="";break;case"?":G+=I;continue;case"*":G+=E(1);continue;default:G+=A.escapeRegExpCharacters(ie)}}Q<M.length-1&&(M[Q+1]!==w||Q+2<M.length)&&(G+=i),B=!1})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),s=function(){return!1},r=function(){return null};function n($,G){if(!$)return r;let M;typeof $!="string"?M=$.pattern:M=$,M=M.trim();const B=`${M}_${!!G.trimForExclusions}`;let V=t.get(B);if(V)return o(V,$);let Q;if(f.test(M)){const Z=M.substr(4);V=function(K,H){return typeof K=="string"&&K.endsWith(Z)?M:null}}else(Q=p.exec(l(M,G)))?V=u(Q[1],M):(G.trimForExclusions?y:g).test(M)?V=d(M,G):(Q=c.exec(l(M,G)))?V=v(Q[1].substr(1),M,!0):(Q=a.exec(l(M,G)))?V=v(Q[1],M,!1):V=T(M);return t.set(B,V),o(V,$)}function o($,G){return typeof G=="string"?$:function(M,B){return L.isEqualOrParent(M,G.base)?$(k.relative(G.base,M),B):null}}function l($,G){return G.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function u($,G){const M=`/${$}`,B=`\\${$}`,V=function(Z,K){return typeof Z!="string"?null:K?K===$?G:null:Z===$||Z.endsWith(M)||Z.endsWith(B)?G:null},Q=[$];return V.basenames=Q,V.patterns=[G],V.allBasenames=Q,V}function d($,G){const M=W($.slice(1,-1).split(",").map(K=>n(K,G)).filter(K=>K!==r),$),B=M.length;if(!B)return r;if(B===1)return M[0];const V=function(K,H){for(let re=0,ie=M.length;re<ie;re++)if(M[re](K,H))return $;return null},Q=M.find(K=>!!K.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=M.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(V.allPaths=Z),V}function v($,G,M){const B=k.sep===k.posix.sep,V=B?$:$.replace(m,k.sep),Q=k.sep+V,Z=k.posix.sep+$,K=M?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!B&&(H===$||H.endsWith(Z)))?G:null}:function(H,re){return typeof H=="string"&&(H===V||!B&&H===$)?G:null};return K.allPaths=[(M?"*/":"./")+$],K}function T($){try{const G=new RegExp(`^${S($)}$`);return function(M){return G.lastIndex=0,typeof M=="string"&&G.test(M)?$:null}}catch(G){return r}}function _($,G,M){return!$||typeof G!="string"?!1:O($)(G,void 0,M)}e.match=_;function O($,G={}){if(!$)return s;if(typeof $=="string"||z($)){const M=n($,G);if(M===r)return s;const B=function(V,Q){return!!M(V,Q)};return M.allBasenames&&(B.allBasenames=M.allBasenames),M.allPaths&&(B.allPaths=M.allPaths),B}return j($,G)}e.parse=O;function N($){if(!$)return;let G;return M=>(G||(G=($()||Promise.resolve([])).then(B=>B?F(B):{})),G.then(B=>!!B[M]))}e.hasSiblingPromiseFn=N;function C($){if(!$)return;let G;return M=>{if(!G){const B=$();G=B?F(B):{}}return!!G[M]}}e.hasSiblingFn=C;function F($){const G={};for(const M of $)G[M]=!0;return G}function z($){const G=$;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function U($){return $.allBasenames||[]}e.getBasenameTerms=U;function x($){return $.allPaths||[]}e.getPathTerms=x;function j($,G){const M=W(Object.getOwnPropertyNames($).map(K=>q(K,$[K],G)).filter(K=>K!==r)),B=M.length;if(!B)return r;if(!M.some(K=>!!K.requiresSiblings)){if(B===1)return M[0];const K=function(ie,ae){for(let ue=0,fe=M.length;ue<fe;ue++){const de=M[ue](ie,ae);if(de)return de}return null},H=M.find(ie=>!!ie.allBasenames);H&&(K.allBasenames=H.allBasenames);const re=M.reduce((ie,ae)=>ae.allPaths?ie.concat(ae.allPaths):ie,[]);return re.length&&(K.allPaths=re),K}const V=function(K,H,re){let ie;for(let ae=0,ue=M.length;ae<ue;ae++){const fe=M[ae];fe.requiresSiblings&&re&&(H||(H=k.basename(K)),ie||(ie=H.substr(0,H.length-k.extname(K).length)));const de=fe(K,H,ie,re);if(de)return de}return null},Q=M.find(K=>!!K.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=M.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(V.allPaths=Z),V}function q($,G,M){if(G===!1)return r;const B=n($,M);if(B===r)return r;if(typeof G=="boolean")return B;if(G){const V=G.when;if(typeof V=="string"){const Q=(Z,K,H,re)=>{if(!re||!B(Z,K))return null;const ie=V.replace("$(basename)",H),ae=re(ie);return(0,D.isThenable)(ae)?ae.then(ue=>ue?$:null):ae?$:null};return Q.requiresSiblings=!0,Q}}return B}function W($,G){const M=$.filter(K=>!!K.basenames);if(M.length<2)return $;const B=M.reduce((K,H)=>{const re=H.basenames;return re?K.concat(re):K},[]);let V;if(G){V=[];for(let K=0,H=B.length;K<H;K++)V.push(G)}else V=M.reduce((K,H)=>{const re=H.patterns;return re?K.concat(re):K},[]);const Q=function(K,H){if(typeof K!="string")return null;if(!H){let ie;for(ie=K.length;ie>0;ie--){const ae=K.charCodeAt(ie-1);if(ae===47||ae===92)break}H=K.substr(ie)}const re=B.indexOf(H);return re!==-1?V[re]:null};Q.basenames=B,Q.patterns=V,Q.allBasenames=B;const Z=$.filter(K=>!K.basenames);return Z.push(Q),Z}}),define(te[107],ne([0,1,106,15,9,16,25]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let w=[],b=[],i=[];function I(n,o=!1){const l=m(n);w.push(l),l.userConfigured?i.push(l):b.push(l),o&&!l.userConfigured&&w.forEach(u=>{u.mime===l.mime||u.userConfigured||(l.extension&&u.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&u.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&u.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&u.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function m(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,D.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(R.posix.sep)>=0:!1}}function E(n){n?(w=w.filter(o=>!o.userConfigured),i=[]):(w=[],b=[],i=[])}e.clearTextMimes=E;function h(n,o){let l;if(n)switch(n.scheme){case L.Schemas.file:l=n.fsPath;break;case L.Schemas.data:l=k.DataUri.parseMetaData(n).get(k.DataUri.META_DATA_LABEL);break;default:l=n.path}if(!l)return[P.unknown];l=l.toLowerCase();const u=(0,R.basename)(l),d=S(l,u,i);if(d)return[d,P.text];const v=S(l,u,b);if(v)return[v,P.text];if(o){const T=f(o);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=h;function S(n,o,l){let u=null,d=null,v=null;for(let T=l.length-1;T>=0;T--){const _=l[T];if(o===_.filenameLowercase){u=_;break}if(_.filepattern&&(!d||_.filepattern.length>d.filepattern.length)){const O=_.filepatternOnPath?n:o;_.filepatternLowercase?.(O)&&(d=_)}_.extension&&(!v||_.extension.length>v.extension.length)&&o.endsWith(_.extensionLowercase)&&(v=_)}return u?u.mime:d?d.mime:v?v.mime:null}function f(n){if((0,A.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let o=w.length-1;o>=0;o--){const l=w[o];if(!l.firstline)continue;const u=n.match(l.firstline);if(u&&u.length>0)return l.mime}return null}function p(n){return n?typeof n=="string"?n===P.binary||n===P.text||n===P.unknown:n.length===1&&p(n[0]):!0}e.isUnspecific=p;const g={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(n){const o=(0,R.extname)(n),l=g[o.toLowerCase()];return l!==void 0?l:a(n)}e.getMediaOrTextMime=c;function a(n){const o=(0,R.extname)(n);return y[o.toLowerCase()]}e.getMediaMime=a;function t(n){for(const o in y)if(y[o]===n)return o}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(n,o){const l=s.exec(n);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:o?void 0:n}e.normalizeMimeType=r}),define(te[108],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(I){this._uriTransformer=I}transformIncoming(I){const m=this._uriTransformer.transformIncoming(I);return m===I?I:L(D.URI.from(m))}transformOutgoing(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:L(D.URI.from(m))}transformOutgoingURI(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:D.URI.from(m)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function k(i,I,m){if(!i||m>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return I.transformOutgoing(i);for(let E in i)if(Object.hasOwnProperty.call(i,E)){const h=k(i[E],I,m+1);h!==null&&(i[E]=h)}}return null}function A(i,I){const m=k(i,I,0);return m===null?i:m}e.transformOutgoingURIs=A;function P(i,I,m,E){if(!i||E>200)return null;if(typeof i=="object"){if(i.$mid===1)return m?D.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const S=P(i[h],I,m,E+1);S!==null&&(i[h]=S)}}return null}function w(i,I){const m=P(i,I,!1,0);return m===null?i:m}e.transformIncomingURIs=w;function b(i,I){const m=P(i,I,!0,0);return m===null?i:m}e.transformAndReviveIncomingURIs=b}),define(te[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return D.test(w)}e.isUUID=L;const R=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};function P(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,b="";return b+=k[R[w++]],b+=k[R[w++]],b+=k[R[w++]],b+=k[R[w++]],b+="-",b+=k[R[w++]],b+=k[R[w++]],b+="-",b+=k[R[w++]],b+=k[R[w++]],b+="-",b+=k[R[w++]],b+=k[R[w++]],b+="-",b+=k[R[w++]],b+=k[R[w++]],b+=k[R[w++]],b+=k[R[w++]],b+=k[R[w++]],b+=k[R[w++]],b}e.generateUuid=P}),define(te[109],ne([0,1,110]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new D.StringDecoder(k),this.remaining=null}write(k){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return A;let w=0,b,i=w;for(;i<P.length;)if(b=P.charCodeAt(i),b===13||b===10){if(A.push(P.substring(w,i)),i++,i<P.length){const I=b;b=P.charCodeAt(i),(I===13&&b===10||I===10&&b===13)&&i++}w=i}else i++;return this.remaining=w<P.length?P.substr(w):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(te[111],ne([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const w=P.replace(/\-/g,":").toLowerCase();return!L.has(w)}function k(){return new Promise(async(P,w)=>{const b=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(i){w(i)}finally{clearTimeout(b)}})}e.getMac=k;function A(){return new Promise((P,w)=>{try{const b=(0,D.networkInterfaces)();for(let i in b){const I=b[i];if(I){for(const{mac:m}of I)if(R(m))return P(m)}}w("Unable to retrieve mac address (unexpected format)")}catch(b){w(b)}})}}),define(te[112],ne([0,1,33,8,40,28,111]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const m=(0,D.networkInterfaces)();for(let E in m){const h=m[E];if(h)for(const{mac:S,internal:f}of h)f||(I+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let P;async function w(){return P||(P=(async()=>await b()||k.generateUuid())()),P}e.getMachineId=w;async function b(){try{const i=await new Promise((m,E)=>{J(["crypto"],m,E)}),I=await(0,A.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(te[19],ne([0,1,53,33,239,5,39,69,9,4,16,7,28]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(U,x=E.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return x===E.UNLINK?f(U):S(U)}async function S(U){try{const x=(0,w.join)((0,L.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(U,x)}catch(j){return f(U)}f(x).catch(j=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function f(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function p(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=p;async function g(U,x){return a(await(x?y(U):(0,R.promisify)(D.readdir)(U)))}async function y(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const x=[],j=await g(U);for(const q of j){let W=!1,$=!1,G=!1;try{const M=await e.Promises.lstat((0,w.join)(U,q));W=M.isFile(),$=M.isDirectory(),G=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}x.push({name:q,isFile:()=>W,isDirectory:()=>$,isSymbolicLink:()=>G})}return x}function c(U){return a(D.readdirSync(U))}e.readdirSync=c;function a(U){return U.map(x=>typeof x=="string"?b.isMacintosh?(0,P.normalizeNFC)(x):x:(x.name=b.isMacintosh?(0,P.normalizeNFC)(x.name):x.name,x))}async function t(U){const x=await g(U),j=[];for(const q of x)await r.existsDirectory((0,w.join)(U,q))&&j.push(q);return j}function s(U,x=1e3){return new Promise(j=>{let q=!1;const W=setInterval(()=>{q||(q=!0,D.access(U,$=>{q=!1,$&&(clearInterval(W),j(void 0))}))},x)})}e.whenDeleted=s;var r;(function(U){async function x(W){let $;try{if($=await e.Promises.lstat(W),!$.isSymbolicLink())return{stat:$}}catch(G){}try{return{stat:await e.Promises.stat(W),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(b.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw M}throw G}}U.stat=x;async function j(W){try{const{stat:$,symbolicLink:G}=await U.stat(W);return $.isFile()&&G?.dangling!==!0}catch($){}return!1}U.existsFile=j;async function q(W){try{const{stat:$,symbolicLink:G}=await U.stat(W);return $.isDirectory()&&G?.dangling!==!0}catch($){}return!1}U.existsDirectory=q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new k.ResourceQueue;function o(U,x,j){return n.queueFor(I.URI.file(U),i.extUriBiasedIgnorePathCase).queue(()=>{const q=v(j);return new Promise((W,$)=>u(U,x,q,G=>G?$(G):W()))})}let l=!0;function u(U,x,j,q){if(!l)return D.writeFile(U,x,{mode:j.mode,flag:j.flag},q);D.open(U,j.flag,j.mode,(W,$)=>{if(W)return q(W);D.writeFile($,x,G=>{if(G)return D.close($,()=>q(G));D.fdatasync($,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),l=!1),D.close($,B=>q(B))))})})}function d(U,x,j){const q=v(j);if(!l)return D.writeFileSync(U,x,{mode:q.mode,flag:q.flag});const W=D.openSync(U,q.flag,q.mode);try{D.writeFileSync(W,x);try{D.fdatasyncSync(W)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),l=!1}}finally{D.closeSync(W)}}e.writeFileSync=d;function v(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function T(U,x){if(U===x)return;async function j(q){try{const W=await e.Promises.lstat(q);if(W.isDirectory()||W.isSymbolicLink())return;await e.Promises.utimes(q,W.atime,new Date)}catch(W){}}try{await e.Promises.rename(U,x),await j(x)}catch(q){if(U.toLowerCase()!==x.toLowerCase()&&q.code==="EXDEV"||U.endsWith("."))await _(U,x,{preserveSymlinks:!1}),await h(U,E.MOVE),await j(x);else throw q}}async function _(U,x,j){return N(U,x,{root:{source:U,target:x},options:j,handledSourcePaths:new Set})}const O=511;async function N(U,x,j){if(j.handledSourcePaths.has(U))return;j.handledSourcePaths.add(U);const{stat:q,symbolicLink:W}=await r.stat(U);if(W){if(j.options.preserveSymlinks)try{return await z(U,x,j)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(W.dangling)return}return q.isDirectory()?C(U,x,q.mode&O,j):F(U,x,q.mode&O)}async function C(U,x,j,q){await e.Promises.mkdir(x,{recursive:!0,mode:j});const W=await g(U);for(const $ of W)await N((0,w.join)(U,$),(0,w.join)(x,$),q)}async function F(U,x,j){await e.Promises.copyFile(U,x),await e.Promises.chmod(x,j)}async function z(U,x,j){let q=await e.Promises.readlink(U);(0,A.isEqualOrParent)(q,j.root.source,!b.isLinux)&&(q=(0,w.join)(j.root.target,q.substr(j.root.source.length+1))),await e.Promises.symlink(q,x)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return h}get move(){return T}get copy(){return _}}}),define(te[113],ne([0,1,53,9,25,19]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const I=(0,L.dirname)(i);if(i===I)return i;const m=((0,L.basename)(i)||i).toLowerCase();try{const h=(0,k.readdirSync)(I).filter(S=>S.toLowerCase()===m);if(h.length===1){const S=A(I);if(S)return(0,L.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(m);if(S>=0){const f=A(I);if(f)return(0,L.join)(f,h[S])}}}catch(E){}return null}e.realcaseSync=A;async function P(i){try{return await k.Promises.realpath(i)}catch(I){const m=b(i);return await k.Promises.access(m,D.constants.R_OK),m}}e.realpath=P;function w(i){try{return D.realpathSync(i)}catch(I){const m=b(i);return D.accessSync(m,D.constants.R_OK),m}}e.realpathSync=w;function b(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(te[114],ne([0,1,57]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(P,w,b,i=1){let I=!1;return new Promise(m=>{const E=setTimeout(()=>{if(!I)return I=!0,m(0)},b);R(P,w,i,h=>{if(!I)return I=!0,clearTimeout(E),m(h)})})}e.findFreePort=L;function R(P,w,b,i){if(w===0)return i(0);const I=new D.Socket;I.once("connect",()=>(A(I),R(P+b,w-1,b,i))),I.once("data",()=>{}),I.once("error",m=>(A(I),m.code!=="ECONNREFUSED"?R(P+b,w-1,b,i):i(P))),I.connect(P,"127.0.0.1")}function k(P,w,b){let i=!1,I,m=1;const E=D.createServer({pauseOnConnect:!0});function h(S,f){i||(i=!0,E.removeAllListeners(),E.close(),I&&clearTimeout(I),f(S))}return new Promise(S=>{I=setTimeout(()=>{h(0,S)},b),E.on("listening",()=>{h(P,S)}),E.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&m<w?(P++,m++,E.listen(P,"127.0.0.1")):h(0,S)}),E.on("close",()=>{h(0,S)}),E.listen(P,"127.0.0.1")})}e.findFreePortFaster=k;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(te[70],ne([0,1,33,9,19]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:a=!1}={}){const t=m({useAlternateBitness:c});if(!t)return null;const s=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let r=-1,n=null;for(const u of await R.Promises.readdir(s)){let d=-1;if(a){const T=u.indexOf("-");if(T<0)continue;const _=u.substring(0,T);if(!k.test(_)||u.substring(T+1)!=="preview")continue;d=parseInt(_,10)}else{if(!k.test(u))continue;d=parseInt(u,10)}if(d<=r)continue;const v=L.join(s,u,"pwsh.exe");!await R.SymlinkSupport.existsFile(v)||(n=v,r=d)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new I(n,`PowerShell${l}${o}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await R.Promises.readdir(a))if(t.test(r)){const n=L.join(a,r,"pwsh.exe");return new I(n,s)}return null}function S(){const c=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function f(){const c=L.join(process.env.windir,b===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}async function*p(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=S(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=f(),c&&(yield c)}async function*g(){for await(const c of p())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=g;async function y(){for await(const c of g())return c;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[115],ne([0,1,41,15]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(A){return new Promise((P,w)=>{let b;const i=new Map;function I(E,h,S,f,p){const g=i.get(h);if(E===A||g){const y={name:m(S),cmd:S,pid:E,ppid:h,load:f,mem:p};i.set(E,y),E===A&&(b=y),g&&(g.children||(g.children=[]),g.children.push(y),g.children.length>1&&(g.children=g.children.sort((c,a)=>c.pid-a.pid)))}}function m(E){const h=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,p=/\\pipe\\winpty-control/,g=/conhost\.exe/,y=/--type=([a-zA-Z-]+)/;if(S.exec(E))return"watcherService ";if(f.exec(E))return"electron-crash-reporter";if(p.exec(E))return"winpty-process";if(g.exec(E))return"console-window-host (Windows internal process)";let c=y.exec(E);if(c&&c.length===2)return c[1]==="renderer"?h.exec(E)?"shared-process":"window":c[1];const a=/[a-zA-Z-]+\.js/g;let t="";do c=a.exec(E),c&&(t+=c+" ");while(c);return t&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${t}`:E}if(process.platform==="win32"){const E=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{J(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(A,S=>{h.getProcessCpuUsage(S,f=>{const p=new Map;f.forEach(g=>{const y=E(g.commandLine||"");p.set(g.pid,{name:m(y),cmd:y,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),b=p.get(A),b?(p.forEach(g=>{const y=p.get(g.ppid);y&&(y.children||(y.children=[]),y.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((y,c)=>y.pid-c.pid))}),P(b)):w(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let E=function(){let h=[b];const S=[];for(;h.length;){const p=h.shift();p&&(S.push(p.pid),p.children&&(h=h.concat(p.children)))}let f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+S.join(" "),(0,D.exec)(f,{},(p,g,y)=>{if(p||y)w(p||new Error(y.toString()));else{const c=g.toString().split(`
`);for(let a=0;a<S.length;a++){const t=i.get(S[a]);t.load=parseFloat(c[a])}if(!b){w(new Error(`Root process ${A} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(h,S,f)=>{if(h||f)if(process.platform!=="linux")w(h||new Error(f.toString()));else{const p=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(p,{},(g,y,c)=>{g||c?w(g||new Error(c.toString())):(k(y,I),E())})}else{const p=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,c,a)=>{y||a&&!a.includes("screen size is bogus")?w(y||new Error(a.toString())):(k(c,I),process.platform==="linux"?E():b?P(b):w(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=R;function k(A,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=A.toString().split(`
`);for(const i of b){const I=w.exec(i.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[116],ne([0,1,53,27,39,2,69,9,4,19]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(h,S,f){return m({path:h,isDirectory:!1},S,f)}e.watchFile=i;function I(h,S,f){return m({path:h,isDirectory:!0},S,f)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function m(h,S,f){if(w.isMacintosh&&(0,R.isEqualOrParent)(h.path,"/Volumes/"))return f(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const p=(0,P.basename)(h.path),g=new Map;let y=!1,c=[(0,k.toDisposable)(()=>{g.forEach(a=>(0,k.dispose)(a)),g.clear()})];try{const a=(0,D.watch)(h.path);c.push((0,k.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const t=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(s=>s.forEach(r=>t.add(r))),a.on("error",(s,r)=>{y||f(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),a.on("change",(s,r)=>{if(y)return;let n="";if(r&&(n=r.toString(),w.isMacintosh&&(n=(0,A.normalizeNFC)(n))),!n||s!=="change"&&s!=="rename")return;const o=h.isDirectory?(0,P.join)(h.path,n):h.path;if(h.isDirectory)if(s==="rename"){const l=g.get(o);l&&(0,k.dispose)(l);const u=setTimeout(async()=>{g.delete(o);const d=await b.Promises.exists(o);if(y)return;let v;d?t.has(n)?v="changed":(v="added",t.add(n)):(t.delete(n),v="deleted"),S(v,o)},e.CHANGE_BUFFER_DELAY);g.set(o,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let l;t.has(n)?l="changed":(l="added",t.add(n)),S(l,o)}else if(s==="rename"||n!==p){const l=setTimeout(async()=>{const u=await b.Promises.exists(o);y||(u?(S("changed",o),c=[m(h,S,f)]):S("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(c),c=[(0,k.toDisposable)(()=>clearTimeout(l))]}else S("changed",o)})}catch(a){b.Promises.exists(h.path).then(t=>{t&&!y&&f(`Failed to watch ${h.path} for changes using fs.watch() (${a.toString()})`)})}return(0,k.toDisposable)(()=>{y=!0,c=(0,k.dispose)(c)})}async function E(h,S,f,p=512){const g=await b.Promises.open(h,"r"),y=Buffer.allocUnsafe(p),c=new L.CancellationTokenSource(f);let a,t=!1;const s=i(h,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:n}=await b.Promises.read(g,y,0,p,null);if(!n||c.token.isCancellationRequested)break;S(y.slice(0,n))}}catch(n){a=new Error(n),c.dispose(!0)}finally{t=!1}}},r=>{a=new Error(r),c.dispose(!0)});return new Promise((r,n)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(g),a?n(a):r()})})}e.watchFileContents=E});var he=this&&this.__decorate||function(J,e,D,L){var R=arguments.length,k=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,D,L);else for(var P=J.length-1;P>=0;P--)(A=J[P])&&(k=(R<3?A(k):R>3?A(e,D,k):A(e,D))||k);return R>3&&k&&Object.defineProperty(e,D,k),k};define(te[32],ne([0,1,17,5,22,27,67,8,3,2,105,25,18]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function f(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(p||(p={}));class g{constructor($){this.buffer=$,this.pos=0}read($){const G=this.buffer.slice(this.pos,this.pos+$);return this.pos+=G.byteLength,G}}class y{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var c;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(c||(c={}));function a(W){const $=R.VSBuffer.alloc(4);return $.writeUInt32BE(W,0),$}function t(W){return W.read(4).readUInt32BE(0)}function s(W){const $=R.VSBuffer.alloc(1);return $.writeUInt8(W,0),$}const r={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},n=typeof Buffer!="undefined";function o(W,$){if(typeof $=="undefined")W.write(r.Undefined);else if(typeof $=="string"){const G=R.VSBuffer.fromString($);W.write(r.String),W.write(a(G.byteLength)),W.write(G)}else if(n&&Buffer.isBuffer($)){const G=R.VSBuffer.wrap($);W.write(r.Buffer),W.write(a(G.byteLength)),W.write(G)}else if($ instanceof R.VSBuffer)W.write(r.VSBuffer),W.write(a($.byteLength)),W.write($);else if(Array.isArray($)){W.write(r.Array),W.write(a($.length));for(const G of $)o(W,G)}else{const G=R.VSBuffer.fromString(JSON.stringify($));W.write(r.Object),W.write(a(G.byteLength)),W.write(G)}}function l(W){switch(W.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return W.read(t(W)).toString();case c.Buffer:return W.read(t(W)).buffer;case c.VSBuffer:return W.read(t(W));case c.Array:{const G=t(W),M=[];for(let B=0;B<G;B++)M.push(l(W));return M}case c.Object:return JSON.parse(W.read(t(W)).toString())}}class u{constructor($,G,M=null,B=1e3){this.protocol=$,this.ctx=G,this.logger=M,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel($,G){this.channels.set($,G),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const G=this.send([$.type]);this.logger&&this.logger.logOutgoing(G,0,1,f($.type));return}case 201:case 202:case 204:case 203:{const G=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(G,$.id,1,f($.type),$.data);return}}}send($,G=void 0){const M=new y;return o(M,$),o(M,G),this.sendBuffer(M.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(G){return 0}}onRawMessage($){const G=new g($),M=l(G),B=l(G),V=M[0];switch(V){case 100:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}: ${M[2]}.${M[3]}`,B),this.onPromise({type:V,id:M[1],channelName:M[2],name:M[3],arg:B});case 102:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}: ${M[2]}.${M[3]}`,B),this.onEventListen({type:V,id:M[1],channelName:M[2],name:M[3],arg:B});case 101:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:M[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:M[1]})}}onPromise($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const M=new k.CancellationTokenSource;let B;try{B=G.call(this.ctx,$.name,$.arg,M.token)}catch(Z){B=Promise.reject(Z)}const V=$.id;B.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete($.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete($.id)});const Q=(0,b.toDisposable)(()=>M.cancel());this.activeRequests.set($.id,Q)}onEventListen($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const M=$.id,V=G.listen(this.ctx,$.name,$.arg)(Q=>this.sendResponse({id:M,data:Q,type:204}));this.activeRequests.set($.id,V)}disposeActiveRequest($){const G=this.activeRequests.get($.id);G&&(G.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let G=this.pendingRequests.get($.channelName);G||(G=[],this.pendingRequests.set($.channelName,G));const M=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:$,timeoutTimer:M})}flushPendingRequests($){const G=this.pendingRequests.get($);if(G){for(const M of G)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor($,G=null){this.protocol=$,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=G}getChannel($){const G=this;return{call(M,B,V){return G.isDisposed?Promise.reject(P.canceled()):G.requestPromise($,M,B,V)},listen(M,B){return G.isDisposed?Promise.reject(P.canceled()):G.requestEvent($,M,B)}}}requestPromise($,G,M,B=k.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:$,name:G,arg:M};if(B.isCancellationRequested)return Promise.reject(P.canceled());let K;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(P.canceled());const ae=()=>{const Ie=Ce=>{switch(Ce.type){case 201:this.handlers.delete(V),re(Ce.data);break;case 202:this.handlers.delete(V);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(V),ie(Ce.data);break}};this.handlers.set(V,Ie),this.sendRequest(Z)};let ue=null;this.state===p.Idle?ae():(ue=(0,L.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const fe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:V,type:101}),ie(P.canceled())},de=B.onCancellationRequested(fe);K=(0,b.combinedDisposable)((0,b.toDisposable)(fe),de),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent($,G,M){const B=this.lastRequestId++,Q={id:B,type:102,channelName:$,name:G,arg:M};let Z=null;const K=new w.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(K),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(K),this.sendRequest({id:B,type:103}))}}),H=re=>K.fire(re.data);return this.handlers.set(B,H),K.event}sendRequest($){switch($.type){case 100:case 102:{const G=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(G,$.id,0,`${h($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const G=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(G,$.id,0,h($.type));return}}}send($,G=void 0){const M=new y;return o(M,$),o(M,G),this.sendBuffer(M.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(G){return 0}}onBuffer($){const G=new g($),M=l(G),B=l(G),V=M[0];switch(V){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,f(V)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,M[1],0,f(V),B),this.onResponse({type:M[0],id:M[1],data:B})}}onResponse($){if($.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get($.id);G&&G($)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}he([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class T{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:G,onDidClientDisconnect:M})=>{w.Event.once(G.onMessage)(V=>{const Q=new g(V),Z=l(Q),K=new u(G,Z),H=new v(G);this.channels.forEach((ie,ae)=>K.registerChannel(ae,ie));const re={channelServer:K,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),M(()=>{K.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const $=[];return this._connections.forEach(G=>$.push(G)),$}getChannel($,G){const M=this;return{call(B,V,Q){let Z;if((0,m.isFunction)(G)){let H=(0,D.getRandomElement)(M.connections.filter(G));Z=H?Promise.resolve(H):w.Event.toPromise(w.Event.filter(M.onDidAddConnection,G))}else Z=G.routeCall(M,B,V);const K=Z.then(H=>H.channelClient.getChannel($));return O(K).call(B,V,Q)},listen(B,V){if((0,m.isFunction)(G))return M.getMulticastEvent($,G,B,V);const Q=G.routeEvent(M,B,V).then(Z=>Z.channelClient.getChannel($));return O(Q).listen(B,V)}}}getMulticastEvent($,G,M,B){const V=this;let Q=new b.DisposableStore;const Z=new w.Emitter({onFirstListenerAdd:()=>{Q=new b.DisposableStore;const K=new w.EventMultiplexer,H=new Map,re=ae=>{const fe=ae.channelClient.getChannel($).listen(M,B),de=K.add(fe);H.set(ae,de)},ie=ae=>{const ue=H.get(ae);!ue||(ue.dispose(),H.delete(ae))};V.connections.filter(G).forEach(re),w.Event.filter(V.onDidAddConnection,G)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),K.event(Z.fire,Z,Q),Q.add(K)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel($,G){this.channels.set($,G),this._connections.forEach(M=>{M.channelServer.registerChannel($,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class _{constructor($,G,M=null){const B=new y;o(B,G),$.send(B.buffer),this.channelClient=new v($,M),this.channelServer=new u($,G,M)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,G){this.channelServer.registerChannel($,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(W){return{call($,G,M){return W.then(B=>B.call($,G,M))},listen($,G){const M=new w.Relay;return W.then(B=>M.input=B.listen($,G)),M.event}}}e.getDelayedChannel=O;function N(W){let $=!1;return{call(G,M,B){return $?W.call(G,M,B):(0,L.timeout)(0).then(()=>$=!0).then(()=>W.call(G,M,B))},listen(G,M){if($)return W.listen(G,M);const B=new w.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>B.input=W.listen(G,M)),B.event}}}e.getNextTickChannel=N;class C{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const G of $.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await w.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=C;var F;(function(W){function $(V,Q){const Z=V,K=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)M(re)&&H.set(re,w.Event.buffer(Z[re],!0));return new class{listen(re,ie,ae){const ue=H.get(ie);if(ue)return ue;if(B(ie)){const fe=Z[ie];if(typeof fe=="function")return fe.call(Z,ae)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ae){const ue=Z[ie];if(typeof ue=="function"){if(!K&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,i.revive)(ae[fe]);return ue.apply(Z,ae)}throw new Error(`Method not found: ${ie}`)}}}W.fromService=$;function G(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(K,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return V.listen(H,re)}:M(H)?V.listen(H):async function(...re){let ie;Q&&!(0,m.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ae=await V.call(H,ie);return Z?ae:(0,i.revive)(ae)};throw new Error(`Property not found: ${String(H)}`)}})}W.toService=G;function M(V){return V[0]==="o"&&V[1]==="n"&&I.isUpperAsciiLetter(V.charCodeAt(2))}function B(V){return/^onDynamic/.test(V)&&I.isUpperAsciiLetter(V.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let $=W.toString();if($!=="[object Object]")return $}return W}function x(W){return Array.isArray(W)?W.map(U):U(W)}function j(W,$,G,M,B,V,Q){Q=x(Q);const Z=z[B],K=Z[M%Z.length];let H=[`%c[${W}]%c[${String($).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=j;class q{constructor($,G){this._outgoingPrefix=$,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,G,M,B,V){this._totalOutgoing+=$,j(this._outgoingPrefix,this._totalOutgoing,$,G,M,B,V)}logIncoming($,G,M,B,V){this._totalIncoming+=$,j(this._incomingPrefix,this._totalIncoming,$,G,M,B,V)}}e.IPCLogger=q}),define(te[117],ne([0,1,22,3,32]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(w){this.port=w,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends R.IPCClient{constructor(w,b){const i=new k(w);super(i,b);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[71],ne([0,1,22,3,2,4,31,32]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function i(){return b||(b=D.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const v=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),v}if(this._chunks[0].byteLength>n){const v=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),v}let l=D.VSBuffer.alloc(n),u=0,d=0;for(;n>0;){const v=this._chunks[d];if(v.byteLength>n){const T=v.slice(0,n);l.set(T,u),u+=n,o&&(this._chunks[d]=v.slice(n),this._totalLength-=n),n-=n}else l.set(v,u),u+=v.byteLength,o?(this._chunks.shift(),this._totalLength-=v.byteLength):d++,n-=v.byteLength}return l}}e.ChunkStream=I;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(m||(m={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(n,o,l,u){this.type=n,this.id=o,this.ack=l,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends R.Disposable{constructor(n){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const l=this._state.messageType,u=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,u,d,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const l=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,l}_bufferTake(){const n=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends R.Disposable{constructor(n){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new S(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new h(1,0,0,n))}}e.Protocol=p;class g extends P.IPCClient{constructor(n,o,l=null){super(n,o,l);this.protocol=n}static fromSocket(n,o){return new g(new p(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=g;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class c{constructor(n){this.data=n,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,l=this._first;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new c(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let u=0;u<t._HISTORY_LENGTH;u++)n-this.lastRuns[u]<=o&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,o=null,l=t.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new h(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new h(4,0,0,i());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new S(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,l=n.length;o<l;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let l=0,u=o.length;l<u;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(n){const o=new h(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new h(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(te[118],ne([0,1,72,3,32,117]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends R.IPCServer{static getOnDidClientConnect(){const w=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,i)=>i);return L.Event.map(w,b=>{const{port1:i,port2:I}=new MessageChannel,E={protocol:new k.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[I]),E})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[119],ne([0,1,22,8]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,w){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((i,I)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(b,P),b.responseType="arraybuffer",b.onerror=m=>I(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=m=>{i({res:{statusCode:b.status,headers:A(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=m=>I(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),w.onCancellationRequested(()=>{b.abort(),I((0,L.canceled)())})})}e.request=R;function k(P,w){if(w.headers){e:for(let b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,w.headers[b])}}}function A(P){const w=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const i=b.indexOf(":");w[b.substr(0,i).trim().toLowerCase()]=b.substr(i+1).trim()}return w}}),define(te[73],ne([0,1,5,3,2,18]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(I){const m=I;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(w||(w={}));class b extends R.Disposable{constructor(m,E=Object.create(null)){super();this.database=m,this.options=E,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((E,h)=>this.accept(h,E)),m.deleted?.forEach(E=>this.accept(E,void 0))}accept(m,E){if(this.state===w.Closed)return;let h=!1;(0,k.isUndefinedOrNull)(E)?h=this.cache.delete(m):this.cache.get(m)!==E&&(this.cache.set(m,E),h=!0),h&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,E){const h=this.cache.get(m);return(0,k.isUndefinedOrNull)(h)?E:h}getBoolean(m,E){const h=this.get(m);return(0,k.isUndefinedOrNull)(h)?E:h==="true"}getNumber(m,E){const h=this.get(m);return(0,k.isUndefinedOrNull)(h)?E:parseInt(h,10)}async set(m,E){if(this.state===w.Closed)return;if((0,k.isUndefinedOrNull)(E))return this.delete(m);const h=String(E);if(this.cache.get(m)!==h)return this.cache.set(m,h),this.pendingInserts.set(m,h),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===w.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((E,h)=>this.items.set(h,E)),m.delete&&m.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[58],ne([0,1,120]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,k=R*24,A=k*7,P=k*30,w=k*365;function b(I,m){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,D.localize)(0,null,b(new Date().getTime()+E*1e3,!1));if(E<30)return(0,D.localize)(1,null);let h;return E<L?(h=E,m?h===1?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):h===1?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h)):E<R?(h=Math.floor(E/L),m?h===1?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):h===1?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):E<k?(h=Math.floor(E/R),m?h===1?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):h===1?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h)):E<A?(h=Math.floor(E/k),m?h===1?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):h===1?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):E<P?(h=Math.floor(E/A),m?h===1?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):h===1?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h)):E<w?(h=Math.floor(E/P),m?h===1?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):h===1?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):(h=Math.floor(E/w),m?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h))}e.fromNow=b;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[121],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,17,18,121]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(b,i){return i&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),A(b.stack)||A(b.stacktrace)):P(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function w(b=null,i=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const I=D.coalesce(b),m=w(I[0],i);return I.length>1?R.localize(4,null,m,I.length):m}if(L.isString(b))return b;if(b.detail){const I=b.detail;if(I.error)return k(I.error,i);if(I.exception)return k(I.exception,i)}return b.stack?k(b,i):b.message?b.message:R.localize(5,null)}e.toErrorMessage=w}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,41,39,15,26,9,4,31,101,18,109,19,122]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(t,s){if(P.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const n=D.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],r);return new Promise(o=>{n.once("error",l=>{o({success:!1,error:l})}),n.once("exit",(l,u)=>{o(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(P.isLinux||P.isMacintosh)try{const r=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(n=>{D.execFile(r,[t.pid.toString()],{encoding:"utf8",shell:!0},(o,l,u)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function f(t){!t||(delete t.DEBUG,P.isMacintosh&&delete t.DYLD_LIBRARY_PATH,P.isLinux&&delete t.LD_PRELOAD)}e.removeDangerousEnvVariables=f;function p(t=w.env){return t.comspec||"cmd.exe"}e.getWindowsShell=p;class g{constructor(s,r,n,o){if(r!==void 0&&n!==void 0&&o!==void 0)this.cmd=s,this.args=r,this.shell=n,this.options=o;else{const l=s;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(w.env).forEach(u=>{l[u]=w.env[u]}),Object.keys(this.options.env).forEach(u=>{l[u]=this.options.env[u]}),this.options.env=l}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(A.sep);return r!==-1&&(s=s.substring(r+1)),g.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(w.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(r=>{let n,o;const l=new Promise((u,d)=>{n=u,o=d});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(d,v,T)=>{this.childProcess=null;const _=d;_&&_.killed?o({killed:this.terminateRequested,stdout:v.toString(),stderr:T.toString()}):this.handleExec(n,s,d,v,T)})}else{let u=null;const d=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,n,s,o);const T={terminated:this.terminateRequested};i.isNumber(v)&&(T.cmdCode=v),n(T)};if(this.shell&&P.isWindows){const v=k.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let T=!1,_=!1;const O=[];let N=this.ensureQuotes(this.cmd);O.push(N.value),T=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),O.push(N.value),_=_&&N.quoted});const C=["/s","/c"];T?_?C.push('"'+O.join(" ")+'"'):O.length>1?C.push('"'+O[0]+'" '+O.slice(1).join(" ")):C.push('"'+O[0]+'"'):C.push(O.join(" ")),u=D.spawn(p(),C,v)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(i.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",v=>{this.childProcess=null,o({terminated:this.terminateRequested,error:v})}),u.pid&&(this.childProcess.on("close",d),this.handleSpawn(u,n,s,o,!0)))}return l})}handleClose(s,r,n,o){}ensureQuotes(s){return g.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,S(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const r=D.spawn(p(),["/s","/c"]);r.on("error",n=>s(!0)),r.on("exit",n=>s(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class y extends g{constructor(s,r,n,o){super(s,r,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,n,o,l){[o,l].forEach((u,d)=>{const v=new I.LineDecoder;v.write(u).forEach(O=>{r({line:O,source:d===0?0:1})});const _=v.end();_&&r({line:_,source:d===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,r,n,o,l){const u=new I.LineDecoder,d=new I.LineDecoder;s.stdout.on("data",v=>{u.write(v).forEach(_=>n({line:_,source:0}))}),s.stderr.on("data",v=>{d.write(v).forEach(_=>n({line:_,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=d}handleClose(s,r,n,o){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}e.LineProcess=y;function c(t){let s=[],r=!1;const n=function(o){if(r){s.push(o);return}(!t.send(o,u=>{if(u&&console.error(u),r=!1,s.length>0){const d=s.slice(0);s=[],d.forEach(v=>n(v))}})||P.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=c;var a;(function(t){async function s(r,n,o){if(A.isAbsolute(r))return r;if(n===void 0&&(n=w.cwd()),A.dirname(r)!=="."||(o===void 0&&i.isString(w.env.PATH)&&(o=w.env.PATH.split(A.delimiter)),o===void 0||o.length===0))return A.join(n,r);async function u(d){if(await m.Promises.exists(d)){let v;try{v=await m.Promises.stat(d)}catch(T){T.message.startsWith("EACCES")&&(v=await m.Promises.lstat(d))}return v?!v.isDirectory():!1}return!1}for(let d of o){let v;if(A.isAbsolute(d)?v=A.join(d,r):v=A.join(n,d,r),await u(v))return v;let T=v+".com";if(await u(T)||(T=v+".exe",await u(T)))return T}return A.join(n,r)}t.findExecutable=s})(a=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,70,74]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(E,h){return E===1?L.isWindows?I():k.getWindowsShell(h):b(E,h)}e.getSystemShell=A;function P(E,h){return E===1?L.isWindows?m(h):k.getWindowsShell(h):b(E,h)}e.getSystemShellSync=P;let w=null;function b(E,h){if(L.isLinux&&E===2||L.isMacintosh&&E===3)return"/bin/bash";if(!w){let S;if(L.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,D.userInfo)().shell}catch(f){}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}w=S}return w}let i=null;async function I(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function m(E){if(i)return i;const h=L.isWindows&&parseFloat((0,D.release)())>=10,S=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${E.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?f:k.getWindowsShell(E)}}),define(te[45],ne([0,1,41,5,22,27,104,8,3,2,26,74,32]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends m.ChannelServer{constructor(f){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch(g){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",p=>R.VSBuffer.wrap(Buffer.from(p,"base64")))},f);process.once("disconnect",()=>this.dispose())}}e.Server=E;class h{constructor(f,p){this.modulePath=f,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new L.Delayer(g),this.child=null,this._client=null}getChannel(f){const p=this;return{call(g,y,c){return p.requestPromise(f,g,y,c)},listen(g,y){return p.requestEvent(f,g,y)}}}requestPromise(f,p,g,y=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(f),a=(0,L.createCancelablePromise)(r=>c.call(p,g,r)),t=y.onCancellationRequested(()=>a.cancel()),s=(0,b.toDisposable)(()=>a.cancel());return this.activeRequests.add(s),a.finally(()=>{t.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(f,p,g){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let y;const c=new w.Emitter({onFirstListenerAdd:()=>{y=this.getCachedChannel(f).listen(p,g)(c.fire,c),this.activeRequests.add(y)},onLastListenerRemove:()=>{this.activeRequests.delete(y),y.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,I.removeDangerousEnvVariables)(p.env),this.child=(0,D.fork)(this.modulePath,f,p);const g=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,A.isRemoteConsoleLog)(n)){(0,A.log)(n,`IPC Library: ${this.options.serverName}`);return}g.fire(R.VSBuffer.wrap(Buffer.from(n,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,a=n=>this.child&&this.child.connected&&c.send(n.buffer.toString("base64")),t=g.event,s={send:a,onMessage:t};this._client=new m.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(l=>(0,b.dispose)(l)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(f){let p=this.channels.get(f);return p||(p=this.client.getChannel(f),this.channels.set(f,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,58,67,15,9,31,16,7]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,f,p){this._args=S,this.paths=f,this.productService=p}get appRoot(){return(0,k.dirname)(R.FileAccess.asFileUri("",J).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?w.URI.file((0,k.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,k.resolve)(S):(0,k.normalize)((0,k.join)(R.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,k.resolve)(S):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,k.resolve)(S);const f=A.env.VSCODE_EXTENSIONS;if(f)return f;const p=A.env.VSCODE_PORTABLE;return p?(0,k.join)(p,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(f=>/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,k.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?w.URI.parse(S):w.URI.file((0,k.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],b.prototype,"appRoot",null),he([L.memoize],b.prototype,"userHome",null),he([L.memoize],b.prototype,"userDataPath",null),he([L.memoize],b.prototype,"appSettingsHome",null),he([L.memoize],b.prototype,"tmpDir",null),he([L.memoize],b.prototype,"userRoamingDataHome",null),he([L.memoize],b.prototype,"settingsResource",null),he([L.memoize],b.prototype,"userDataSyncHome",null),he([L.memoize],b.prototype,"userDataSyncLogResource",null),he([L.memoize],b.prototype,"sync",null),he([L.memoize],b.prototype,"machineSettingsResource",null),he([L.memoize],b.prototype,"globalStorageHome",null),he([L.memoize],b.prototype,"workspaceStorageHome",null),he([L.memoize],b.prototype,"keybindingsResource",null),he([L.memoize],b.prototype,"keyboardLayoutResource",null),he([L.memoize],b.prototype,"argvResource",null),he([L.memoize],b.prototype,"snippetsHome",null),he([L.memoize],b.prototype,"isExtensionDevelopment",null),he([L.memoize],b.prototype,"untitledWorkspacesHome",null),he([L.memoize],b.prototype,"installSourcePath",null),he([L.memoize],b.prototype,"builtinExtensionsPath",null),he([L.memoize],b.prototype,"extensionsPath",null),he([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],b.prototype,"extensionDevelopmentKind",null),he([L.memoize],b.prototype,"extensionTestsLocationURI",null),he([L.memoize],b.prototype,"debugExtensionHost",null),he([L.memoize],b.prototype,"serviceMachineIdResource",null),he([L.memoize],b.prototype,"telemetryLogResource",null),he([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function i(h,S){return E(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=i;function I(h,S){return E(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=I;function m(h,S){return E(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=m;function E(h,S,f,p,g,y){const a=Number(S||h)||(p?null:f),t=a?Boolean(!!S):!1;let s;if(y)try{s=JSON.parse(y)}catch{}return{port:a,break:t,debugId:g,env:s}}}),define(te[149],ne([0,1,240,4,126]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,S,f=A){const p={},g=[],y=[];for(let s in S){const r=S[s];r.alias&&(p[s]=r.alias),r.type==="string"||r.type==="string[]"?(g.push(s),r.deprecates&&g.push(r.deprecates)):r.type==="boolean"&&(y.push(s),r.deprecates&&y.push(r.deprecates))}const c=D(h,{string:g,boolean:y,alias:p}),a={},t=c;a._=c._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in S){const r=S[s];r.alias&&delete t[r.alias];let n=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(n||(n=t[r.deprecates]),delete t[r.deprecates]),typeof n!="undefined"&&(r.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):r.type==="string"&&Array.isArray(n)&&(n=n.pop(),f.onMultipleValues(s,n)),a[s]=n),delete t[s]}for(let s in t)f.onUnknownOption(s);return a}e.parseArgs=P;function w(h,S){let f="";return S.args&&(Array.isArray(S.args)?f=` <${S.args.join("> <")}>`:f=` <${S.args}>`),S.alias?`-${S.alias} --${h}${f}`:`--${h}${f}`}function b(h,S){let f=0,p=[];for(const a in h){const t=h[a],s=w(a,t);f=Math.max(f,s.length),p.push([s,t.description])}let g=f+2+1;if(S-g<25)return p.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let y=S-g-1,c=[];for(const a of p){let t=a[0],s=I(a[1],y),r=i(g-t.length-2);c.push("  "+t+r+s[0]);for(let n=1;n<s.length;n++)c.push(i(g)+s[n])}return c}e.formatOptions=b;function i(h){return" ".repeat(h)}function I(h,S){let f=[];for(;h.length;){let p=h.length<S?h.length:h.lastIndexOf(" ",S),g=h.slice(0,p).trim();h=h.slice(p),f.push(g)}return f}function m(h,S,f,p,g=!0){const y=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${f}`];c.push(""),c.push(`${(0,R.localize)(32,null)}: ${S} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),c.push(""),g&&(L.isWindows?c.push((0,R.localize)(35,null,S)):c.push((0,R.localize)(36,null,S)),c.push(""));const a={};for(const t in p){const s=p[t];if(s.description&&s.cat){let r=a[s.cat];r||(a[s.cat]=r={}),r[t]=s}}for(let t in a){const s=t;let r=a[s];r&&(c.push(k[s]),c.push(...b(r,y)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=m;function E(h,S){return`${h||(0,R.localize)(37,null)}
${S||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function J(e,D,L,R){function k(P){const w=A(P),b=[w];return e.isAbsolute(w)||b.unshift(R),e.resolve(...b)}function A(P){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[150],ne([0,241,33,15,16,31]),function(e,D,L,R,k,A){const P=k.dirname(R.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return J(D,L,w.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=J(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[151],ne([0,1,33,75,150]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},w)}}e.NativeEnvironmentService=k}),define(te[152],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(f){const p=f.match(A);return p?p[1]:null}function i(f){if(f.indexOf("://")===-1){const p=f.match(L);return p?b(p[2]):null}try{const p=D.URI.parse(f);if(p.authority)return b(p.authority)}catch(p){}return null}function I(f,p){const g=new Set;let y;for(;y=P.exec(f);){const a=i(y[1]);a&&g.add(a)}const c=new Set(p);return Array.from(g).map(a=>c.has(a)?a:a.replace(w,"a"))}e.getDomainsOfRemotes=I;function m(f){const p=f.match(k);return p?p[2]:null}function E(f,p,g){return f&&p?(g&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${f}${p}`:`${f}/${p}`):null}function h(f,p){if(f.indexOf("://")===-1){const g=f.match(R);if(g)return E(g[2],g[3],p)}try{const g=D.URI.parse(f);if(g.authority)return E(m(g.authority),g.path,p)}catch(g){}return null}function S(f,p=!1){const g=[];let y;for(;y=P.exec(f);){const c=h(y[1],p);c&&g.push(c)}return g}e.getRemotes=S}),define(te[153],ne([0,1,26]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(k,A){const P=w=>{if(typeof w!="string")return;const b=L.exec(w);if(!b)return;const i=A[b[1]]??w;return typeof i=="string"?i:typeof i.message=="string"?i.message:w};return(0,D.cloneAndChange)(k,P)}e.localizeManifest=R}),define(te[154],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,P,w){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,P,w])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,135]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=k;function A(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=m.match(L);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=A;function P(m){if(!m)return null;let E=m.majorBase,h=m.majorMustEqual,S=m.minorBase,f=m.minorMustEqual,p=m.patchBase,g=m.patchMustEqual;m.hasCaret&&(E===0||(f=!1),g=!1);let y=0;if(m.preRelease){const c=R.exec(m.preRelease);if(c){const[,a,t,s]=c;y=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:E,majorMustEqual:h,minorBase:S,minorMustEqual:f,patchBase:p,patchMustEqual:g,isMinimum:m.hasGreaterEquals,notBefore:y}}e.normalizeVersion=P;function w(m,E,h){let S;typeof m=="string"?S=P(A(m)):S=m;let f;E instanceof Date?f=E.getTime():typeof E=="string"&&(f=new Date(E).getTime());let p;if(typeof h=="string"?p=P(A(h)):p=h,!S||!p)return!1;let g=S.majorBase,y=S.minorBase,c=S.patchBase,a=p.majorBase,t=p.minorBase,s=p.patchBase,r=p.notBefore,n=p.majorMustEqual,o=p.minorMustEqual,l=p.patchMustEqual;return p.isMinimum?g>a?!0:g<a?!1:y>t?!0:y<t||f&&f<r?!1:c>=s:(g===1&&a===0&&(!n||!o||!l)&&(a=1,t=0,s=0,n=!0,o=!1,l=!1),g<a?!1:g>a?!n:y<t?!1:y>t?!o:c<s?!1:c>s?!l:!(f&&f<r))}e.isValidVersion=w;function b(m,E,h,S){return h.isBuiltin||typeof h.main=="undefined"?!0:I(m,E,h.engines.vscode,S)}e.isValidExtensionVersion=b;function i(m,E,h){return m==="*"||I(E,h,m)}e.isEngineValid=i;function I(m,E,h,S=[]){let f=P(A(h));if(!f)return S.push(D.localize(0,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return S.push(D.localize(1,null,h)),!1}else if(!f.majorMustEqual)return S.push(D.localize(2,null,h)),!1;return w(m,E,f)?!0:(S.push(D.localize(3,null,m,h)),!1)}}),define(te[54],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,k=[],A=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(te[77],ne([0,1,54]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(A,P,w){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],w)),L.push([A,P])}e.registerSingleton=R;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[155],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=D;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const P=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),w),w.incoming.set(this._hashFn(k),P)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let P=this._nodes.get(A);return P||(P=new D(k),this._nodes.set(A,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,P]of this._nodes)k.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const P=new Set([k]),w=this._findCycle(A,P);if(w)return w}}_findCycle(k,A){for(let[P,w]of k.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const b=this._findCycle(w,A);if(b)return b;A.delete(P)}}}e.Graph=L}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=w})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,w,b,i){w[D.DI_TARGET]===w?w[D.DI_DEPENDENCIES].push({id:P,index:b,optional:i}):(w[D.DI_DEPENDENCIES]=[{id:P,index:b,optional:i}],w[D.DI_TARGET]=w)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const w=function(b,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,b,I,!1)};return w.toString=()=>P,D.serviceIds.set(P,w),w}e.createDecorator=R;function k(P){return P}e.refineServiceDecorator=k;function A(P){return function(w,b,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,w,i,!0)}}e.optional=A}),define(te[156],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[157],ne([0,1,4,25,6]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=D.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var w;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return m.INSTANCE}static true(){return E.INSTANCE}static has(C){return h.create(C)}static equals(C,F){return S.create(C,F)}static notEquals(C,F){return g.create(C,F)}static regex(C,F){return r.create(C,F)}static in(C,F){return f.create(C,F)}static not(C){return y.create(C)}static and(...C){return l.create(C,null)}static or(...C){return u.create(C,null,!0)}static greater(C,F){return c.create(C,F)}static less(C,F){return t.create(C,F)}static deserialize(C,F=!1){if(!!C)return this._deserializeOrExpression(C,F)}static _deserializeOrExpression(C,F){let z=C.split("||");return u.create(z.map(U=>this._deserializeAndExpression(U,F)),null,!0)}static _deserializeAndExpression(C,F){let z=C.split("&&");return l.create(z.map(U=>this._deserializeOne(U,F)),null)}static _deserializeOne(C,F){if(C=C.trim(),C.indexOf("!=")>=0){let z=C.split("!=");return g.create(z[0].trim(),this._deserializeValue(z[1],F))}if(C.indexOf("==")>=0){let z=C.split("==");return S.create(z[0].trim(),this._deserializeValue(z[1],F))}if(C.indexOf("=~")>=0){let z=C.split("=~");return r.create(z[0].trim(),this._deserializeRegexValue(z[1],F))}if(C.indexOf(" in ")>=0){let z=C.split(" in ");return f.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const z=C.split(">=");return a.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const z=C.split(">");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const z=C.split("<=");return s.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const z=C.split("<");return t.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(C)?y.create(C.substr(1).trim()):h.create(C)}static _deserializeValue(C,F){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;let z=/^'([^']*)'$/.exec(C);return z?z[1].trim():C}static _deserializeRegexValue(C,F){if((0,L.isFalsyOrWhitespace)(C)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=C.indexOf("/"),U=C.lastIndexOf("/");if(z===U||z<0){if(F)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}let x=C.slice(z+1,U),j=C[U+1]==="i"?"i":"";try{return new RegExp(x,j)}catch(q){if(F)throw new Error(`bad regexp-value '${C}', parse error: ${q}`);return console.warn(`bad regexp-value '${C}', parse error: ${q}`),null}}}e.ContextKeyExpr=b;function i(N,C){const F=N?N.substituteConstants():void 0,z=C?C.substituteConstants():void 0;return!F&&!z?!0:!F||!z?!1:F.equals(z)}e.expressionsAreEqualWithConstantSubstitution=i;function I(N,C){return N.cmp(C)}class m{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class E{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(C,F){this.key=C,this.negated=F,this.type=2}static create(C,F=null){const z=A.get(C);return typeof z=="boolean"?z?E.INSTANCE:m.INSTANCE:new h(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:v(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=A.get(this.key);return typeof C=="boolean"?C?E.INSTANCE:m.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class S{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=4}static create(C,F,z=null){if(typeof F=="boolean")return F?h.create(C,z):y.create(C,z);const U=A.get(C);return typeof U=="boolean"?F===(U?"true":"false")?E.INSTANCE:m.INSTANCE:new S(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=A.get(this.key);if(typeof C=="boolean"){const F=C?"true":"false";return this.value===F?E.INSTANCE:m.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=S;class f{constructor(C,F){this.key=C,this.valueKey=F,this.type=10,this.negated=null}static create(C,F){return new f(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const F=C.getValue(this.valueKey),z=C.getValue(this.key);return Array.isArray(F)?F.indexOf(z)>=0:typeof z=="string"&&typeof F=="object"&&F!==null?P.call(F,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=f;class p{constructor(C){this._actual=C,this.type=11}static create(C){return new p(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new p(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class g{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=5}static create(C,F,z=null){if(typeof F=="boolean")return F?y.create(C,z):h.create(C,z);const U=A.get(C);return typeof U=="boolean"?F===(U?"true":"false")?m.INSTANCE:E.INSTANCE:new g(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=A.get(this.key);if(typeof C=="boolean"){const F=C?"true":"false";return this.value===F?m.INSTANCE:E.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class y{constructor(C,F){this.key=C,this.negated=F,this.type=3}static create(C,F=null){const z=A.get(C);return typeof z=="boolean"?z?m.INSTANCE:E.INSTANCE:new y(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:v(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=A.get(this.key);return typeof C=="boolean"?C?m.INSTANCE:E.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class c{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=12}static create(C,F,z=null){return new c(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class a{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=13}static create(C,F,z=null){return new a(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class t{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=14}static create(C,F,z=null){return new t(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class s{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=15}static create(C,F,z=null){return new s(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class r{constructor(C,F){this.key=C,this.regexp=F,this.type=7,this.negated=null}static create(C,F){return new r(C,F)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const F=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return F<z?-1:F>z?1:0}equals(C){if(C.type===this.type){const F=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return this.key===C.key&&F===z}return!1}substituteConstants(){return this}evaluate(C){let F=C.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(C){this._actual=C,this.type=8}static create(C){return new n(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new n(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(N){let C=null;for(let F=0,z=N.length;F<z;F++){const U=N[F].substituteConstants();if(N[F]!==U&&C===null){C=[];for(let x=0;x<F;x++)C[x]=N[x]}C!==null&&(C[F]=U)}return C===null?N:C}class l{constructor(C,F){this.expr=C,this.negated=F,this.type=6}static create(C,F){return l._normalizeArr(C,F)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const U=I(this.expr[F],C.expr[F]);if(U!==0)return U}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=o(this.expr);return C===this.expr?this:l.create(C,this.negated)}evaluate(C){for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].evaluate(C))return!1;return!0}static _normalizeArr(C,F){const z=[];let U=!1;for(const x of C)if(!!x){if(x.type===1){U=!0;continue}if(x.type===0)return m.INSTANCE;if(x.type===6){z.push(...x.expr);continue}z.push(x)}if(z.length===0&&U)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(I);for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];for(;z.length>1;){const x=z[z.length-1];if(x.type!==9)break;z.pop();const j=z.pop(),q=z.length===0,W=u.create(x.expr.map($=>l.create([$,j],null)),null,q);W&&(z.push(W),z.sort(I))}return z.length===1?z[0]:new l(z,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(let F of this.expr)C.push(...F.keys());return C}map(C){return new l(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.negated){const C=[];for(let F of this.expr)C.push(F.negate());this.negated=u.create(C,this,!0)}return this.negated}}class u{constructor(C,F){this.expr=C,this.negated=F,this.type=9}static create(C,F,z){return u._normalizeArr(C,F,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const U=I(this.expr[F],C.expr[F]);if(U!==0)return U}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=o(this.expr);return C===this.expr?this:u.create(C,this.negated,!1)}evaluate(C){for(let F=0,z=this.expr.length;F<z;F++)if(this.expr[F].evaluate(C))return!0;return!1}static _normalizeArr(C,F,z){let U=[],x=!1;if(C){for(let j=0,q=C.length;j<q;j++){const W=C[j];if(!!W){if(W.type===0){x=!0;continue}if(W.type===1)return E.INSTANCE;if(W.type===9){U=U.concat(W.expr);continue}U.push(W)}}if(U.length===0&&x)return m.INSTANCE;U.sort(I)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(z){for(let j=0;j<U.length;j++)for(let q=j+1;q<U.length;q++)_(U[j],U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0]}return new u(U,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(let F of this.expr)C.push(...F.keys());return C}map(C){return new u(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.negated){let C=[];for(let F of this.expr)C.push(F.negate());for(;C.length>1;){const F=C.shift(),z=C.shift(),U=[];for(const j of O(F))for(const q of O(z))U.push(l.create([j,q],null));const x=C.length===0;C.unshift(u.create(U,null,x))}this.negated=C[0]}return this.negated}}class d extends h{constructor(C,F,z){super(C,null);this._defaultValue=F,typeof z=="object"?d._info.push({...z,key:C}):z!==!0&&d._info.push({key:C,description:z,type:F!=null?typeof F:void 0})}static all(){return d._info.values()}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return S.create(this.key,C)}notEqualsTo(C){return g.create(this.key,C)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(N,C){return N<C?-1:N>C?1:0}function T(N,C,F,z){return N<F?-1:N>F?1:C<z?-1:C>z?1:0}function _(N,C){if(C.type===6&&N.type!==9&&N.type!==6){for(const U of C.expr)if(N.equals(U))return!0}const F=N.negate(),z=O(F).concat(O(C));z.sort(I);for(let U=0;U<z.length;U++){const j=z[U].negate();for(let q=U+1;q<z.length;q++){const W=z[q];if(j.equals(W))return!0}}return!1}e.implies=_;function O(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[29],ne([0,1,15,130,6]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function A(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function P(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function w(g,y){switch(g){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function b(g,y){return y==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function i(g,y,c){return b(y,c)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===c?!0:I(c).includes(g)}e.isTargetPlatformCompatible=i;function I(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function m(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=m;var E;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var S;(function(g){g.Install="install",g.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var f;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class p extends Error{constructor(y,c){super(y);this.code=c,this.name=c}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(D,L){e(D,L,J)}};define(te[158],ne([0,1,2,29]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=he([X(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[159],ne([0,1,3,2,26,7,108,29]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(S,f){return k.URI.revive(f?f.transformIncoming(S):S)}function b(S,f){return f?f.transformOutgoingURI(S):S}function i(S,f){f=f||A.DefaultURITransformer;const p=S.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...S,manifest:void 0},f),manifest:p}}function I(S,f){return f?(0,R.cloneAndChange)(S,p=>p instanceof k.URI?f.transformOutgoingURI(p):void 0):S}class m{constructor(f,p){this.service=f,this.getUriTransformer=p,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,p){const g=this.getUriTransformer(f);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,y=>y.map(c=>({...c,local:c.local?I(c.local,g):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,p,g){const y=this.getUriTransformer(f);switch(p){case"zip":return this.service.zip(i(g[0],y)).then(c=>b(c,y));case"unzip":return this.service.unzip(w(g[0],y));case"install":return this.service.install(w(g[0],y),g[1]);case"getManifest":return this.service.getManifest(w(g[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],g[1]);case"uninstall":return this.service.uninstall(i(g[0],y),g[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(i(g[0],y));case"getInstalled":return this.service.getInstalled(g[0]).then(c=>c.map(a=>I(a,y)));case"updateMetadata":return this.service.updateMetadata(i(g[0],y),g[1]).then(c=>I(c,y));case"updateExtensionScope":return this.service.updateExtensionScope(i(g[0],y),g[1]).then(c=>I(c,y));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class E extends L.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire({identifier:p.identifier,source:this.isUriComponents(p.source)?k.URI.revive(p.source):p.source}))),this._register(this.channel.listen("onDidInstallExtensions")(p=>this._onDidInstallExtensions.fire(p.map(g=>({...g,local:g.local?i(g.local,null):g.local,source:this.isUriComponents(g.source)?k.URI.revive(g.source):g.source}))))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire(p))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire(p)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const p=await this.getTargetPlatform();return f.allTargetPlatforms.some(g=>(0,P.isTargetPlatformCompatible)(g,f.allTargetPlatforms,p))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(p=>k.URI.revive(p)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,p){return Promise.resolve(this.channel.call("install",[f,p])).then(g=>i(g,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,p){return Promise.resolve(this.channel.call("installFromGallery",[f,p])).then(g=>i(g,null))}uninstall(f,p){return Promise.resolve(this.channel.call("uninstall",[f,p]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(p=>p.map(g=>i(g,null)))}updateMetadata(f,p){return Promise.resolve(this.channel.call("updateMetadata",[f,p])).then(g=>i(g,null))}updateExtensionScope(f,p){return Promise.resolve(this.channel.call("updateExtensionScope",[f,p])).then(g=>i(g,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class h{constructor(f){this.service=f}listen(f,p){throw new Error("Invalid listen")}call(f,p,g){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,D.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,40,9,25,18,7,137,6]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function b(U){return U.create===!0}e.isFileOpenForWriteOptions=b;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var m;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=E;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;var p;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(x,j){super(x);this.code=j}}e.FileSystemProviderError=g;function y(U,x){const j=new g(U.toString(),x);return a(j,x),j}e.createFileSystemProviderError=y;function c(U){return U||y((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=c;function a(U,x){return U.name=x?`${x} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function t(U){if(!U)return p.Unknown;if(U instanceof g)return U.code;const x=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!x)return p.Unknown;switch(x[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof d)return U.fileOperationResult;switch(t(U)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(x,j,q){this.resource=x,this.operation=j,this.target=q}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const W of x){const $=q.get(W.type);$?$.push([W.resource,W]):q.set(W.type,[[W.resource,W]])}for(const[W,$]of q)switch(W){case 1:this.added=D.TernarySearchTree.forUris(()=>j),this.added.fill($);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>j),this.updated.fill($);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>j),this.deleted.fill($);break}}contains(x,...j){return this.doContains(x,{includeChildren:!1},...j)}affects(x,...j){return this.doContains(x,{includeChildren:!0},...j)}doContains(x,j,...q){if(!x)return!1;const W=q.length>0;return!!((!W||q.includes(1))&&(this.added?.get(x)||j.includeChildren&&this.added?.findSuperstr(x))||(!W||q.includes(0))&&(this.updated?.get(x)||j.includeChildren&&this.updated?.findSuperstr(x))||(!W||q.includes(2))&&(this.deleted?.findSubstr(x)||j.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function u(U,x,j){return!U||!x||U===x||x.length>U.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),j?(0,R.startsWithIgnoreCase)(U,x):U.indexOf(x)===0)}e.isParent=u;class d extends Error{constructor(x,j,q){super(x);this.fileOperationResult=j,this.options=q}}e.FileOperationError=d;class v extends d{constructor(x,j,q){super(x,2,q);this.stat=j}}e.NotModifiedSinceFileOperationError=v;var T;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function N(U,x){if(!x.hasProvider(A.URI.from({scheme:U.scheme})))return new Promise(j=>{const q=x.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===U.scheme&&W.added&&(q.dispose(),j())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class C{static formatSize(x){return(0,k.isNumber)(x)||(x=0),x<C.KB?(0,P.localize)(1,null,x.toFixed(0)):x<C.MB?(0,P.localize)(2,null,(x/C.KB).toFixed(2)):x<C.GB?(0,P.localize)(3,null,(x/C.MB).toFixed(2)):x<C.TB?(0,P.localize)(4,null,(x/C.GB).toFixed(2)):(0,P.localize)(5,null,(x/C.TB).toFixed(2))}}e.ByteSize=C,C.KB=1024,C.MB=C.KB*C.KB,C.GB=C.MB*C.KB,C.TB=C.GB*C.KB;var F;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*C.MB:16*C.GB,maxHeapSize:U===0?700*C.MB:2*700*C.MB}}e.getPlatformLimits=z}),define(te[160],ne([0,1,82,52,14]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}async checksum(P){const w=(await this.fileService.readFileStream(P)).value;return new Promise((b,i)=>{const I=(0,D.createHash)("md5");(0,L.listenStream)(w,{onData:m=>I.update(m.buffer),onError:m=>i(m),onEnd:()=>b(I.digest("base64").replace(/=+$/,""))})})}};k=he([X(0,R.IFileService)],k),e.ChecksumService=k}),define(te[161],ne([0,1,242,127,149,14]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(m,E){const h={onUnknownOption:f=>{console.warn((0,L.localize)(0,null,f))},onMultipleValues:(f,p)=>{console.warn((0,L.localize)(1,null,f,p))}},S=(0,R.parseArgs)(m,R.OPTIONS,E?h:void 0);return S.goto&&S._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(2,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),S}function P(m){const E=m.findIndex(h=>!/^-/.test(h));if(E>-1)return[...m.slice(0,E),...m.slice(E+1)]}function w(m){let[,...E]=m;process.env.VSCODE_DEV&&(E=P(E)||[]);const h=!I(process.env);return A(E,h)}e.parseMainProcessArgv=w;function b(m){const[,,...E]=m;return A(E,!0)}e.parseCLIProcessArgv=b;function i(m,...E){const h=m.indexOf("--");return h===-1?m.push(...E):m.splice(h,0,...E),m}e.addArg=i;function I(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[162],ne([0,1,41,9,128,27,37,8,4,28,123,161,5]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const E=1e4;let h;async function S(p,g,y){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(y)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(y)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(c,a)=>{const t=new k.CancellationTokenSource,s=setTimeout(()=>{t.dispose(!0),a(new Error((0,R.localize)(0,null)))},E);try{c(await f(p,t.token))}catch(r){!(0,P.isPromiseCanceledError)(r)&&!t.token.isCancellationRequested?a(new Error((0,R.localize)(1,null,(0,A.toErrorMessage)(r)))):c({})}finally{clearTimeout(s),t.dispose()}})),h)}e.resolveShellEnv=S;async function f(p,g){const y=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",y);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",c);const a=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const r=await(0,i.getSystemShell)(w.OS,s);return p.trace("getUnixShellEnvironment#shell",r),new Promise((n,o)=>{if(g.isCancellationRequested)return o((0,P.canceled)());const l=(0,L.basename)(r);let u,d;/^pwsh(-preview)?$/.test(l)?(u=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,d=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const v=(0,D.spawn)(r,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(v.kill(),o((0,P.canceled)()))),v.on("error",O=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(O)),o(O)});const T=[];v.stdout.on("data",O=>T.push(O));const _=[];v.stderr.on("data",O=>_.push(O)),v.on("close",(O,N)=>{const C=Buffer.concat(T).toString("utf8");p.trace("getUnixShellEnvironment#raw",C);const F=Buffer.concat(_).toString("utf8");if(F.trim()&&p.trace("getUnixShellEnvironment#stderr",F),O||N)return o(new Error((0,R.localize)(2,null,O,N)));const z=t.exec(C),U=z?z[1]:"{}";try{const x=JSON.parse(U);y?x.ELECTRON_RUN_AS_NODE=y:delete x.ELECTRON_RUN_AS_NODE,c?x.ELECTRON_NO_ATTACH_CONSOLE=c:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",x),n(x)}catch(x){p.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(x)),o(x)}})})}}),define(te[46],ne([0,1,2,4,7,14]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class A extends D.Disposable{}e.WatcherService=A;function P(i){return i.map(I=>({type:I.type,resource:R.URI.file(I.path)}))}e.toFileChanges=P;function w(i){const I=new b;for(const m of i)I.processEvent(m);return I.normalize()}e.normalizeFileChanges=w;class b{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return L.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const m=this.mapPathToChange.get(this.toKey(I));let E=!1;if(m){const h=m.type,S=I.type;m.path!==I.path&&I.type===2?E=!0:h===1&&S===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(m)):h===2&&S===1?m.type=0:h===1&&S===0||(m.type=S)}else E=!0;E&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],m=[];return Array.from(this.normalized).filter(E=>E.type!==2?(I.push(E),!1):!0).sort((E,h)=>E.path.length-h.path.length).filter(E=>m.some(h=>(0,k.isParent)(E.path,h,!L.isLinux))?!1:(m.push(E.path),!0)).concat(I)}}}),define(te[163],ne([0,1,5,2,9,113,19,116,46]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(I,m,E,h){super();this.path=I,this.onDidFilesChange=m,this.onLogMessage=E,this.verboseLogging=h,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:m}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(m)try{E=await(0,k.realpath)(E)}catch(h){if(this.onError(h),m.dangling)return}I.isDirectory()?this._register((0,P.watchFolder)(E,(h,S)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(S))})},h=>this.onError(h))):this._register((0,P.watchFile)(E,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,w.normalizeFileChanges)(m);if(this.verboseLogging)for(const h of E)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[164],ne([0,1,15,32,45,46]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends k.WatcherService{constructor(w,b,i,I){super();this.requests=w,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.watch(this.requests)}setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}watch(w){this.requests=w,this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[165],ne([0,1,15,32,45,46]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends k.WatcherService{constructor(w,b,i,I){super();this.requests=w,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.watch(this.requests)}setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${w}`})}watch(w){this.requests=w,this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[166],ne([0,1,15,32,45,46]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends k.WatcherService{constructor(w,b,i,I,m={}){super();this.requests=w,this.onDidFilesChange=b,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.watch(this.requests)}setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}watch(w){this.requests=w,this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[k,A]of R)this.set(k,A)}set(R,k){const A=this._entries.get(R);return this._entries.set(R,k),A}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[167],ne([0,1,5,8,54,155,6,83]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new P.ServiceCollection,S=!1,f){this._activeInstantiations=new Set,this._services=h,this._strict=S,this._parent=f,this._services.set(A.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...S){let f=m.traceInvocation(h),p=!1;try{return h({get:(y,c)=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(y,f);if(!a&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${y}'`);return a}},...S)}finally{p=!0,f.stop()}}createInstance(h,...S){let f,p;return h instanceof R.SyncDescriptor?(f=m.traceCreation(h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(S),f)):(f=m.traceCreation(h),p=this._createInstance(h,S,f)),f.stop(),p}_createInstance(h,S=[],f){let p=A._util.getServiceDependencies(h).sort((c,a)=>c.index-a.index),g=[];for(const c of p){let a=this._getOrCreateServiceInstance(c.id,f);if(!a&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);g.push(a)}let y=p.length>0?p[0].index:S.length;if(S.length!==y){console.warn(`[createInstance] First service dependency of ${h.name} at position ${y+1} conflicts with ${S.length} static arguments`);let c=y-S.length;c>0?S=S.concat(new Array(c)):S=S.slice(0,y)}return new h(...[...S,...g])}_setServiceInstance(h,S){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){let f=this._getServiceInstanceOrDescriptor(h);return f instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,S.branch(h,!0)):(S.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,S,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,f){const p=new k.Graph(c=>c.id.toString());let g=0;const y=[{id:h,desc:S,_trace:f}];for(;y.length;){const c=y.pop();if(p.lookupOrInsertNode(c),g++>1e3)throw new b(p);for(let a of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const s={id:a.id,desc:t,_trace:c._trace.branch(a.id,!0)};p.insertEdge(c,s),y.push(s)}}}for(;;){const c=p.roots();if(c.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:a}of c){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,f=[],p,g){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(S,f,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,f,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S=[],f,p){if(f){const g=new D.IdleValue(()=>this._createInstance(h,S,p));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];let a=g.value,t=a[c];return typeof t!="function"||(t=t.bind(a),y[c]=t),t},set(y,c,a){return g.value[c]=a,!0}})}else return this._createInstance(h,S,p)}}e.InstantiationService=i;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class m{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return w?new m(0,h.name):m._None}branch(h,S){let f=new m(2,h.toString());return this._dep.push([h,S,f]),f}stop(){let h=Date.now()-this._start;m._totals+=h;let S=!1;function f(g,y){let c=[],a=new Array(g+1).join("	");for(const[t,s,r]of y._dep)if(s&&r){S=!0,c.push(`${a}CREATES -> ${t}`);let n=f(g+1,r);n&&c.push(n)}else c.push(`${a}uses -> ${t}`);return c.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||S)&&console.log(p.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(te[168],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,k){this.server=R,this.router=k}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,k){this.server.registerChannel(R,k)}}e.MessagePortMainProcessService=D}),define(te[169],ne([0,1,32,54,77,6]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(E,h,S){const f=S.getChannel(E);return P(h)?new h.channelClientCtor(f):D.ProxyChannel.toService(f,h?.proxyOptions)}}function P(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let w=class extends A{constructor(E,h,S){super(E,h,S)}};w=he([X(2,e.IMainProcessService)],w);function b(m,E,h){(0,R.registerSingleton)(m,new L.SyncDescriptor(w,[E,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let i=class extends A{constructor(E,h,S){super(E,h,S)}};i=he([X(2,e.ISharedProcessService)],i);function I(m,E,h){(0,R.registerSingleton)(m,new L.SyncDescriptor(i,[E,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[59],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const k of R.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[170],ne([0,1,2,59]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=he([X(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[10],ne([0,1,37,3,2,4,6]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class b extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class i extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(w.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(w.Error,this.format(r))}else this.log(w.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(o){}s+=(r>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class I extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}debug(t,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}info(t,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...s):console.log(`[main ${P()}]`,t,...s))}warn(t,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...s):console.warn(`[main ${P()}]`,t,...s))}error(t,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}critical(t,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...s):console.error(`[main ${P()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class m extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=m;class E extends b{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class h extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class S extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=S;class f extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?w.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class p{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=p;function g(a){if(a.verbose)return w.Trace;if(typeof a.logLevel=="string"){const t=y(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function y(a){switch(a){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=y;function c(a){switch(a){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=c}),define(te[171],ne([0,1,5,8,2,9,19,13,10]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(I,m){super();this.environmentService=I,this.logService=m,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,k.basename)(this.environmentService.logsPath),m=(0,k.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(m)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==I),f=S.slice(0,Math.max(0,S.length-9));f.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(p=>A.Promises.rm((0,k.join)(m,p)))))}catch(I){(0,L.onUnexpectedError)(I)}}};b=he([X(0,P.IEnvironmentService),X(1,w.ILogService)],b),e.LogsDataCleaner=b}),define(te[172],ne([0,1,5,8,2,9,19,13,10]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class vt extends R.Disposable{constructor(I,m,E){super();this.backupWorkspacesPath=I,this.environmentService=m,this.logService=E,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const I=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(I).emptyWorkspaceInfos.map(S=>S.backupFolder),h=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async S=>{S.length!==vt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(S)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${S}.`),await A.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(I){(0,L.onUnexpectedError)(I)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=he([X(1,P.INativeEnvironmentService),X(2,w.ILogService)],b),e.StorageDataCleaner=b}),define(te[173],ne([0,1,41,5,37,3,2,15,9,19,13,10]),function(J,e,D,L,R,k,A,P,w,b,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends A.Disposable{constructor(h,S){super();this.environmentService=h,this.logService=S,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(h,S){const f=`vscode:${S}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const p=h.manifest.scripts[f].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(h,S,f,p,g){return new Promise((y,c)=>{const a=this.start(h,S,f,g);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?c(r):y(void 0)};a.on("error",r=>{s((0,R.toErrorMessage)(r)||"Unknown")}),a.on("exit",(r,n)=>{s(r?`post-${S} process exited with code ${r}`:void 0)}),p&&(t=setTimeout(()=>{t=null,a.kill(),c("timed out")},5e3))})}start(h,S,f,p){const g={silent:!0,execArgv:void 0},y=(0,D.fork)(h,[`--type=extension-post-${S}`,...f],g);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=k.Event.fromNodeEventEmitter(y.stdout,"data"),a=k.Event.fromNodeEventEmitter(y.stderr,"data");c(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${S}`,r)),a(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${S}`,r));const t=k.Event.any(k.Event.map(c,r=>({data:`%c${r}`,format:[""]})),k.Event.map(a,r=>({data:`%c${r}`,format:["color: red"]})));return k.Event.debounce(t,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),y}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=he([X(0,i.IEnvironmentService),X(1,I.ILogService)],m),e.ExtensionsLifecycle=m}),define(te[174],ne([0,1,8,2,81,3,41,15,110,4,10,77,26,31]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let h=class extends L.Disposable{constructor(p,g){super();this.id=p,this._logService=g,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null}register(p){this._register(p)}start(p){this._process=(0,A.fork)(P.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,m.mixin)({cwd:(0,E.cwd)()},p));const g=this._process.pid;this._logService.info(`Starting extension host with pid ${g}.`);const y=new w.StringDecoder("utf-8");this._process.stdout?.on("data",a=>{const t=typeof a=="string"?a:y.write(a);this._onStdout.fire(t)});const c=new w.StringDecoder("utf-8");return this._process.stderr?.on("data",a=>{const t=typeof a=="string"?a:c.write(a);this._onStderr.fire(t)}),this._process.on("message",a=>{this._onMessage.fire(a)}),this._process.on("error",a=>{this._onError.fire({error:(0,D.transformErrorForSerialization)(a)})}),this._process.on("exit",(a,t)=>{this._onExit.fire({pid:g,code:a,signal:t})}),{pid:g}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):b.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};h=he([X(1,i.ILogService)],h);let S=class pt{constructor(p){this._logService=p,this._extHosts=new Map}dispose(){}_getExtHost(p){const g=this._extHosts.get(p);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(p){return this._getExtHost(p).onStdout}onDynamicStderr(p){return this._getExtHost(p).onStderr}onDynamicMessage(p){return this._getExtHost(p).onMessage}onDynamicError(p){return this._getExtHost(p).onError}onDynamicExit(p){return this._getExtHost(p).onExit}async createExtensionHost(){const p=String(++pt._lastId),g=new h(p,this._logService);return this._extHosts.set(p,g),g.onExit(({pid:y,code:c,signal:a})=>{this._logService.info(`Extension host with pid ${y} exited with code: ${c}, signal: ${a}.`),setTimeout(()=>{g.dispose(),this._extHosts.delete(p)})}),{id:p}}async start(p,g){return this._getExtHost(p).start(g)}async enableInspectPort(p){const g=this._extHosts.get(p);return g?g.enableInspectPort():!1}async kill(p){const g=this._extHosts.get(p);!g||g.kill()}};S._lastId=0,S=he([X(0,i.ILogService)],S),e.ExtensionHostStarter=S,(0,I.registerSingleton)(R.IExtensionHostStarter,S,!0)}),define(te[84],ne([0,1,3,7,10]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=D.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=k;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,E){return m.call("setLevel",E)}}e.LogLevelChannelClient=A;class P{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,E){throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${E}`)}createLogger(m,E){this.loggers.set(m.toString(),this.loggerService.createLogger(m,E))}consoleLog(m,E){let h=console.log;switch(m){case R.LogLevel.Error:h=console.error;break;case R.LogLevel.Warning:h=console.warn;break;case R.LogLevel.Info:h=console.info;break}h.call(console,...E)}log(m,E){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,f]of E)switch(S){case R.LogLevel.Trace:h.trace(f);break;case R.LogLevel.Debug:h.debug(f);break;case R.LogLevel.Info:h.info(f);break;case R.LogLevel.Warning:h.warn(f);break;case R.LogLevel.Error:h.error(f);break;case R.LogLevel.Critical:h.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class w extends R.AbstractLoggerService{constructor(m,E,h){super(m,E);this.channel=h}createConsoleMainLogger(){return new R.AdapterLogger({log:(m,E)=>{this.channel.call("consoleLog",[m,E])}})}doCreateLogger(m,E,h){return new b(this.channel,m,E,h)}}e.LoggerChannelClient=w;class b extends R.AbstractMessageLogger{constructor(m,E,h,S){super(S?.always);this.channel=m,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[E,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,E){const h=[[m,E]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class i extends R.LogService{constructor(m,E){super(E);this.parent=m,this._register(m.onDidChangeLogLevel(h=>E.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=i}),define(te[60],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,k.dirname)(D.FileAccess.asFileUri("",J));A=J.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const w=J.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:w.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[85],ne([0,1,22,8,138,14,42]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(I,m,E,h,S,f){let p;try{await w(I,m,E,h,S,f)}catch(g){p=g}finally{p&&S.errorTransformer&&(p=S.errorTransformer(p)),typeof p!="undefined"&&E.error(p),E.end()}}e.readFileIntoStream=P;async function w(I,m,E,h,S,f){b(f);const p=await I.open(m,{create:!1});try{b(f);let g=0,y=0,c=S&&typeof S.length=="number"?S.length:void 0,a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof c=="number"?c:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,s=0;do y=await I.read(p,t,a.buffer,s,a.byteLength-s),t+=y,s+=y,g+=y,typeof c=="number"&&(c-=y),s===a.byteLength&&(await E.write(h(a)),a=D.VSBuffer.alloc(Math.min(S.bufferSize,typeof c=="number"?c:S.bufferSize)),s=0);while(y>0&&(typeof c!="number"||c>0)&&b(f)&&i(g,S));if(s>0){let r=s;typeof c=="number"&&(r=Math.min(s,c)),E.write(h(a.slice(0,r)))}}catch(g){throw(0,k.ensureFileSystemProviderError)(g)}finally{await I.close(p)}}function b(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function i(I,m){if(m?.limits){if(typeof m.limits.memory=="number"&&I>m.limits.memory)throw(0,k.createFileSystemProviderError)((0,R.localize)(0,null,A.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&I>m.limits.size)throw(0,k.createFileSystemProviderError)((0,R.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[175],ne([0,1,17,5,22,27,3,56,2,40,15,176,16,52,136,14,85,10]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class Ge extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ge.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ge.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ge.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ge.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ge.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ge.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new S.FileChangesEvent(a,!0)))),this.watchedResources=b.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a});const t=new w.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,w.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){a.push(t)}}),!this.provider.has(c)&&await L.Promises.settled(a)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,a){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,m.isAbsolutePath)(c))throw new S.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,h.localize)(1,null,c.toString()),t}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a)||(0,S.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(c,a){const t=await this.withProvider(c),s=this.isPathCaseSensitive(t),r=a?.resolveTo,n=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,l=await t.stat(c);let u;return this.toFileStat(t,c,l,void 0,!!o,(d,v)=>(u||(u=b.TernarySearchTree.forUris(()=>!s),u.set(c,!0),r&&u.fill(!0,r)),u.get(d.resource)||u.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&n?v===1:!1))}async toFileStat(c,a,t,s,r,n){const{providerExtUri:o}=this.getExtUri(c),l={resource:a,name:o.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&n(l,s)){try{const u=await c.readdir(a),d=await L.Promises.settled(u.map(async([v,T])=>{try{const _=o.joinPath(a,v),O=r?await c.stat(_):{type:T};return await this.toFileStat(c,_,O,u.length,r,n)}catch(_){return this.logService.trace(_),null}}));l.children=(0,D.coalesce)(d)}catch(u){this.logService.trace(u),l.children=[]}return l}return l}async resolveAll(c){return L.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch(t){return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(t){return t}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new S.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const s=await this.writeFile(c,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,s)),s}async writeFile(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,c,t)||await this.mkdirp(s,r.dirname(c));let o;if((0,S.hasReadWriteCapability)(s)&&!(a instanceof R.VSBuffer))if((0,E.isReadableStream)(a)){const l=await(0,E.peekStream)(a,3);l.ended?o=R.VSBuffer.concat(l.buffer):o=l}else o=(0,E.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else o=a;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&o instanceof R.VSBuffer?await this.doWriteUnbuffered(s,c,t,o):await this.doWriteBuffered(s,c,t,o instanceof R.VSBuffer?(0,R.bufferToReadable)(o):o)}catch(n){throw new S.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(n).toString()),(0,S.toFileOperationResult)(n),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,t){if(!!t?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(a)));let r;try{r=await c.stat(a)}catch(n){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,h.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:r.size}))throw new S.FileOperationError((0,h.localize)(7,null),3,t);return r}async readFile(c,a){const t=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(t,c,a):this.doReadFile(t,c,a)}async doReadFileAtomic(c,a,t){return new Promise((s,r)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(c,a,t);s(n)}catch(n){r(n)}})})}async doReadFile(c,a,t){const s=await this.doReadFileStream(c,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(c,a){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,a)}async doReadFileStream(c,a,t){const s=new k.CancellationTokenSource,r=this.validateReadFile(a,t).then(o=>o,o=>{throw s.cancel(),o});let n;try{return typeof t?.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasFileReadStreamCapability)(c))||(0,S.hasReadWriteCapability)(c)&&t?.preferUnbuffered?n=this.readFileUnbuffered(c,a,t):(0,S.hasFileReadStreamCapability)(c)?n=this.readFileStreamed(c,a,s.token,t):n=this.readFileBuffered(c,a,s.token,t),{...await r,value:n}}catch(o){n&&await(0,E.consumeStream)(n);const l=(0,h.localize)(8,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(o).toString());throw o instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(l,o.stat,t):new S.FileOperationError(l,(0,S.toFileOperationResult)(o),t)}}readFileStreamed(c,a,t,s=Object.create(null)){const r=c.readFileStream(a,s,t);return(0,E.transform)(r,{data:n=>n instanceof R.VSBuffer?n:R.VSBuffer.wrap(n),error:n=>new S.FileOperationError((0,h.localize)(9,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(n).toString()),(0,S.toFileOperationResult)(n),s)},n=>R.VSBuffer.concat(n))}readFileBuffered(c,a,t,s=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,f.readFileIntoStream)(c,a,r,n=>n,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new S.FileOperationError((0,h.localize)(10,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(n).toString()),(0,S.toFileOperationResult)(n),s)},t),r}readFileUnbuffered(c,a,t){const s=(0,E.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r=await c.readFile(a);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(a,r.byteLength,t),s.end(R.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(c,a){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,h.localize)(12,null),t,a);return this.validateReadFileLimits(c,t.size,a),t}validateReadFileLimits(c,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,a,t){return this.doCanMoveCopy(c,a,"move",t)}async canCopy(c,a,t){return this.doCanMoveCopy(c,a,"copy",t)}async doCanMoveCopy(c,a,t,s){if(c.toString()!==a.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(r,c,n,a,t,s)}catch(r){return r}return!0}async move(c,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(s,c,r,a,"move",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,n==="move"?2:3,o)),o}async copy(c,a,t){const s=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(s,c,r,a,"copy",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,n==="copy"?3:2,o)),o}async doMoveCopy(c,a,t,s,r,n){if(a.toString()===s.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,a,t,s,r,n);if(o&&!l&&n&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(c===t&&(0,S.hasFileFolderCopyCapability)(c))await c.copy(a,s,{overwrite:n});else{const u=await this.resolve(a);u.isDirectory?await this.doCopyFolder(c,u,t,s):await this.doCopyFile(c,a,t,s)}return r}else return c===t?(await c.rename(a,s,{overwrite:n}),r):(await this.doMoveCopy(c,a,t,s,"copy",n),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,t,s){if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,a,t,s);if((0,S.hasOpenReadWriteCloseCapability)(c)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,a,t,s);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,a,t,s);if((0,S.hasReadWriteCapability)(c)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,a,t,s)}async doCopyFolder(c,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async r=>{const n=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),t,n):this.doCopyFile(c,r.resource,t,n)}))}async doValidateMoveCopy(c,a,t,s,r,n){let o=!1;if(c===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(o=u.isEqual(a,s)),o&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!o&&u.isEqualOrParent(s,a))throw new Error((0,h.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!o){if(!n)throw new S.FileOperationError((0,h.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(c===t){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(a,s))throw new Error((0,h.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(c,0,t)),t}async mkdirp(c,a){const t=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(a,s.dirname(a));)try{if(((await c.stat(a)).type&S.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(a)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(a)),a=s.dirname(a)}for(let r=t.length-1;r>=0;r--){a=s.joinPath(a,t[r]);try{await c.mkdir(a)}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(t){return t}return!0}async doValidateDelete(c,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let r;try{r=await t.stat(c)}catch(o){}if(r)this.throwIfFileIsReadonly(c,r);else throw new S.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return t}async del(c,a){const t=await this.doValidateDelete(c,a),s=!!a?.useTrash,r=!!a?.recursive;await t.delete(c,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(c,1))}onDidChangeFile(c,a){this._onDidChangeFilesRaw.fire({changes:c});let t,s;{for(const r of c)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!a))}if(s){const r=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ge.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,a={recursive:!1,excludes:[]}){const t=new w.DisposableStore;{let s=!1,r=()=>{s=!0};t.add((0,w.toDisposable)(()=>r())),this.doWatch(c,a).then(n=>{s?(0,w.dispose)(n):r=()=>(0,w.dispose)(n)},n=>this.logService.error(n))}return a.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),t.add((0,w.toDisposable)(()=>{const s=this.watchedResources.get(c);typeof s=="number"&&(s<=1?this.watchedResources.delete(c):this.watchedResources.set(c,s-1))}))),t}async doWatch(c,a){const t=await this.withProvider(c),s=this.toWatchKey(t,c,a),r=this.activeWatchers.get(s)||{count:0,disposable:t.watch(c,a)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,w.toDisposable)(()=>{r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(c,a,t){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(s)||(0,E.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,r,s):await this.doWriteReadableBufferedQueued(c,r,s)}catch(n){throw(0,S.ensureFileSystemProviderError)(n)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,a,t){let s=0,r;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const n=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,a,n,n.byteLength,s,0),s+=n.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((n,o)=>{(0,E.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(c,a,l,l.byteLength,s,0)}catch(u){return o(u)}s+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>o(l),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(c,a,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(c,a,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(c,a,t,s,r,n){let o=0;for(;o<s;)o+=await c.write(a,r+o,t.buffer,n+o,s-o)}async doWriteUnbuffered(c,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,t,s))}async doWriteUnbufferedQueued(c,a,t,s){let r;s instanceof R.VSBuffer?r=s:(0,E.isReadableStream)(s)?r=await(0,R.streamToBuffer)(s):(0,E.isReadableBufferedStream)(s)?r=await(0,R.bufferedStreamToBuffer)(s):r=(0,R.readableToBuffer)(s),await c.writeFile(a,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,t,s))}async doPipeBufferedQueued(c,a,t,s){let r,n;try{r=await c.open(a,{create:!1}),n=await t.open(s,{create:!0,unlock:!1});const o=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,d=0;do d=await c.read(r,l,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(t,n,o,d,l,u),l+=d,u+=d,u===o.byteLength&&(u=0);while(d>0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof n=="number"?t.close(n):Promise.resolve()])}}async doPipeUnbuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,t,s))}async doPipeUnbufferedQueued(c,a,t,s){return t.writeFile(s,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,t,s))}async doPipeUnbufferedToBufferedQueued(c,a,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const n=await c.readFile(a);await this.doWriteBuffer(t,r,R.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,S.ensureFileSystemProviderError)(n)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(c,a,t,s){const r=await(0,R.streamToBuffer)(this.readFileBuffered(c,a,k.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new S.FileOperationError((0,h.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===i.Schemas.file?c.fsPath:c.toString(!0)}};g.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},g=he([X(0,p.ILogService)],g),e.FileService=g}),define(te[177],ne([0,1,17,5,22,3,39,2,9,4,16,52,19,139,14,85,163,164,165,166,46,10,42]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends P.Disposable{constructor(n,o){super();this.logService=n,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:l}=await m.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await m.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,i.joinPath)(n,u.name))).type:d=this.toType(u),l.push([u.name,d])}catch(d){this.logService.trace(d)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let l;return o?.dangling?l=h.FileType.Unknown:n.isFile()?l=h.FileType.File:n.isDirectory()?l=h.FileType.Directory:l=h.FileType.Unknown,o&&(l|=h.FileType.SymbolicLink),l}async readFile(n){try{const o=this.toFilePath(n);return await m.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(n,o,l){const u=(0,I.newWriteableStream)(d=>R.VSBuffer.concat(d.map(v=>R.VSBuffer.wrap(v))).buffer);return(0,S.readFileIntoStream)(this,n,u,d=>d.buffer,{...o,bufferSize:this.BUFFER_SIZE},l),u}async writeFile(n,o,l){let u;try{const d=this.toFilePath(n);if(!l.create||!l.overwrite){if(await m.Promises.exists(d)){if(!l.overwrite)throw(0,h.createFileSystemProviderError)((0,E.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,h.createFileSystemProviderError)((0,E.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(u,0,o,0,o.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(n,d)}finally{typeof u=="number"&&await this.close(u)}}async open(n,o){try{const l=this.toFilePath(n);if((0,h.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:v}=await m.SymlinkSupport.stat(l);v.mode&128||await m.Promises.chmod(l,v.mode|128)}catch(v){this.logService.trace(v)}let u;if((0,h.isFileOpenForWriteOptions)(o)){if(b.isWindows)try{await m.Promises.truncate(l,0),u="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}u||(u="w")}else u="r";const d=await m.Promises.open(l,u);return this.mapHandleToPos.set(d,0),(0,h.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(d,n),d}catch(l){throw(0,h.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await m.Promises.fdatasync(n)}catch(o){this.canFlush=!1,this.logService.error(o)}return await m.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}}async read(n,o,l,u,d){const v=this.normalizePos(n,o);let T=null;try{const _=await m.Promises.read(n,l,u,d,v);return typeof _=="number"?T=_:T=_.bytesRead,T}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(n,v,T)}}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,l){const u=this.mapHandleToPos.get(n);typeof u=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,u+l):this.mapHandleToPos.delete(n)))}async write(n,o,l,u,d){return(0,L.retry)(()=>this.doWrite(n,o,l,u,d),100,3)}async doWrite(n,o,l,u,d){const v=this.normalizePos(n,o);let T=null;try{const _=await m.Promises.write(n,l,u,d,v);return typeof _=="number"?T=_:T=_.bytesWritten,T}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),_)}finally{this.updatePos(n,v,T)}}async mkdir(n){try{await m.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const l=this.toFilePath(n);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,o){o.recursive?await m.Promises.rm(n,m.RimRafMode.MOVE):await m.Promises.unlink(n)}async rename(n,o,l){const u=this.toFilePath(n),d=this.toFilePath(o);if(u!==d)try{await this.validateTargetDeleted(n,o,"move",l.overwrite),await m.Promises.move(u,d)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,E.localize)(2,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(n,o,l){const u=this.toFilePath(n),d=this.toFilePath(o);if(u!==d)try{await this.validateTargetDeleted(n,o,"copy",l.overwrite),await m.Promises.copy(u,d,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,E.localize)(3,null,(0,w.basename)(u),(0,w.basename)((0,w.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(n,o,l,u){const d=this.toFilePath(n),v=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,A.isEqual)(d,v,!0)),T&&l==="copy")throw(0,h.createFileSystemProviderError)((0,E.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!T&&await m.Promises.exists(v)){if(!u)throw(0,h.createFileSystemProviderError)((0,E.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(n,o){return o.recursive?this.watchRecursive(n,o):this.watchNonRecursive(n)}watchRecursive(n,o){const l={path:this.toFilePath(n),excludes:o.excludes},u=(0,D.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{u(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){this.recursiveWatcher?this.recursiveWatcher.watch(this.recursiveFoldersToWatch):this.recursiveFoldersToWatch.length>0&&(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch,n=>this._onDidChangeFile.fire((0,c.toFileChanges)(n)),n=>{n.type==="error"&&this._onDidWatchErrorOccur.fire(n.message),this.logService[n.type](n.message)},this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})))}createRecursiveWatcher(n,o,l,u){let d,v;if(this.options?.watcher?.usePolling)d=y.FileWatcher,v=this.options?.watcher;else{let T=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?T=this.options.legacyWatcher==="on":t.default.quality==="stable"&&(T=this.recursiveFoldersToWatch.length===1),T?b.isLinux?d=y.FileWatcher:d=p.FileWatcher:d=g.FileWatcher}return new d(n,T=>o(T),T=>l(T),u,v)}watchNonRecursive(n){const o=new f.FileWatcher(this.toFilePath(n),u=>this._onDidChangeFile.fire((0,c.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===a.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(o,l)}toFilePath(n){return(0,w.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof h.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=h.FileSystemProviderErrorCode.NoPermissions;break;default:o=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let l=this.toFileSystemProviderError(o);if(n&&l.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.toFilePath(n));u.mode&128||(l=(0,h.createFileSystemProviderError)(o,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return l}}e.DiskFileSystemProvider=s}),define(te[30],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[178],ne([0,1,5,8,2,9,19,10,30]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(I,m,E){super();this.productService=m,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),E=(0,k.dirname)(I),h=(0,k.basename)(I),S=await A.Promises.readdir(E);await Promise.all(S.map(async f=>{if(f===h)return;const p=(0,k.join)(E,f),g=await A.Promises.stat(p);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),A.Promises.rm(p)}))}catch(m){(0,L.onUnexpectedError)(m)}}};b=he([X(1,w.IProductService),X(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(te[179],ne([0,1,5,8,2,9,19,13,10,30]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(m,E,h){super();this.environmentService=m,this.logService=E,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),E=JSON.parse(await A.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let g of Object.keys(E)){const y=E[g];m[`${y.hash}.${g}`]=!0}const h=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(h))return;const f=await A.Promises.readdir(h);for(const g of f){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,k.join)(h,g))}const p=Date.now();for(const g of Object.keys(m)){const y=(0,k.join)(h,g),c=await A.Promises.readdir(y);for(const a of c){if(a==="tcf.json")continue;const t=(0,k.join)(y,a),s=await A.Promises.stat(t);s.isDirectory()&&p-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(g,a)}`),await A.Promises.rm(t))}}}catch(m){(0,L.onUnexpectedError)(m)}}};i=he([X(0,P.INativeEnvironmentService),X(1,w.ILogService),X(2,b.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[34],ne([0,1,99,18]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(A,P){D.ok(L.isString(A)),D.ok(L.isObject(P)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new R}),define(te[86],ne([0,1,3,34]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,b){this.schemasById[R(w)]=b,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;L.Registry.add(e.Extensions.JSONContribution,A)}),define(te[38],ne([0,1,17,3,18,125,86,34]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=P.Registry.as(A.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,c=!0){this.registerConfigurations([y],c)}registerConfigurations(y,c=!0){const a=this.doRegisterConfigurations(y,c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(y){const c=this.doDeregisterConfigurations(y);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:y,remove:c}){const a=[];a.push(...this.doDeregisterConfigurations(c)),a.push(...this.doRegisterConfigurations(y,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(a))}registerDefaultConfigurations(y){const c=[],a=[];for(const t of y)for(const s in t)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const r={type:"object",default:this.defaultValues[s],description:k.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};a.push(E(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=t[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(y){const c=[];for(const a of y)for(const t in a)if(c.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const c of y)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(y,c){const a=[];return y.forEach(t=>{a.push(...this.validateAndRegisterProperties(t,c,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),a}doDeregisterConfigurations(y){const c=[],a=t=>{if(t.properties)for(const s in t.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>a(s))};for(const t of y){a(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(y,c=!0,a,t=3){t=R.isUndefinedOrNull(y.scope)?t:y.scope;let s=[],r=y.properties;if(r)for(let o in r){if(c&&f(o)){delete r[o];continue}const l=r[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=R.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=R.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(o):l.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),s.push(o)}let n=y.allOf;if(n)for(let o of n)s.push(...this.validateAndRegisterProperties(o,c,a,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const c=a=>{let t=a.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let s=a.allOf;s&&s.forEach(c)};c(y)}updateSchema(y,c){switch(e.allSettings.properties[y]=c,c.scope){case 1:e.applicationSettings.properties[y]=c;break;case 2:e.machineSettings.properties[y]=c;break;case 6:e.machineOverridableSettings.properties[y]=c;break;case 3:e.windowSettings.properties[y]=c;break;case 4:e.resourceSettings.properties[y]=c;break;case 5:e.resourceSettings.properties[y]=c,this.resourceLanguageSettingsSchema.properties[y]=c;break}}removeFromSchema(y,c){switch(delete e.allSettings.properties[y],c.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const c=`[${y}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,a),e.allSettings.properties[c]=a,e.applicationSettings.properties[c]=a,e.machineSettings.properties[c]=a,e.machineOverridableSettings.properties[c]=a,e.windowSettings.properties[c]=a,e.resourceSettings.properties[c]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,c){let a=this.defaultValues[y];R.isUndefined(a)&&(a=c.default),R.isUndefined(a)&&(a=h(c.type)),c.default=a}}const m="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(m);function E(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=E;function h(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const S=new I;P.Registry.add(e.Extensions.Configuration,S);function f(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?k.localize(5,null,g):S.getConfigurationProperties()[g]!==void 0?k.localize(6,null,g):null:k.localize(4,null)}e.validateProperty=f;function p(){const g=[],y=S.getConfigurationProperties();for(const c of Object.keys(y))g.push([c,y[c].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=p}),define(te[20],ne([0,1,26,18,7,38,6,34]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof R.URI)}e.isConfigurationOverrides=w;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(s,r){const n=r?s?r.keys.filter(_=>s.keys.indexOf(_)===-1):[...r.keys]:[],o=s?r?s.keys.filter(_=>r.keys.indexOf(_)===-1):[...s.keys]:[],l=[];if(r&&s){for(const _ of s.keys)if(r.keys.indexOf(_)!==-1){const O=p(s.contents,_),N=p(r.contents,_);D.equals(O,N)||l.push(_)}}const u=[],d=_=>{const O={};for(const N of _)for(const C of N.identifiers)O[a(C)]=N;return O},v=r?d(r.overrides):{},T=s?d(s.overrides):{};if(Object.keys(v).length)for(const _ of n){const O=v[_];O&&u.push([(0,k.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(T).length)for(const _ of o){const O=T[_];O&&u.push([(0,k.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(v).length&&Object.keys(T).length)for(const _ of l){const O=T[_],N=v[_];if(O&&N){const C=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});u.push([(0,k.overrideIdentifierFromKey)(_),[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:o,updated:l,overrides:u}}e.compare=I;function m(s,r){const n=[];for(const o of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const l={};for(const u in s[o])l[u]=s[o][u];n.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(l),contents:E(l,r)})}return n}e.toOverrides=m;function E(s,r){const n=Object.create(null);for(let o in s)h(n,o,s[o],r);return n}e.toValuesTree=E;function h(s,r,n,o){const l=r.split("."),u=l.pop();let d=s;for(let v=0;v<l.length;v++){let T=l[v],_=d[T];switch(typeof _){case"undefined":_=d[T]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,v+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[u]=n}catch(v){o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(d)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=h;function S(s,r){const n=r.split(".");f(s,n)}e.removeFromValueTree=S;function f(s,r){const n=r.shift();if(r.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(f(o,r),Object.keys(o).length===0&&delete s[n])}}function p(s,r,n){function o(d,v){let T=d;for(const _ of v){if(typeof T!="object"||T===null)return;T=T[_]}return T}const l=r.split("."),u=o(s,l);return typeof u=="undefined"?n:u}e.getConfigurationValue=p;function g(s,r,n){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in s?L.isObject(s[o])&&L.isObject(r[o])?g(s[o],r[o],n):n&&(s[o]=r[o]):s[o]=r[o])})}e.merge=g;function y(){const s=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=y;function c(){const s=Object.create(null),r=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let n in r){let o=r[n].default;h(s,n,o,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=c;function a(s){return`[${s}]`}e.keyFromOverrideIdentifier=a;function t(s,r,n){const o=s.inspect(r),l=s.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:o.defaultValue}e.getMigratedSettingValue=t}),define(te[87],ne([0,1,17,3,36,2,40,26,18,7,20,38,34]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,i.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=P.deepClone(this.contents),r=P.deepClone(this.overrides),n=[...this.keys];for(const o of t){this.mergeContents(s,o.contents);for(const l of o.overrides){const[u]=r.filter(d=>D.equals(d.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):r.push(P.deepClone(l))}for(const l of o.keys)n.indexOf(l)===-1&&n.push(l)}return new E(s,n,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[n],l=s[n];l&&(typeof o=="object"&&typeof l=="object"?(o=P.deepClone(o),this.mergeContents(o,l)):o=l),r[n]=o}return new E(r,this.keys,this.overrides)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&w.isObject(t[r])&&w.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=P.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),r=[];for(const n of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,s,r)}}e.DefaultConfigurationModel=h;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!w.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:n,overrides:o,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new E(r,n,o),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},r=null,n=[],o=[],l=[];function u(v){Array.isArray(n)?n.push(v):r!==null&&(n[r]=v)}let d={onObjectBegin:()=>{let v={};u(v),o.push(n),n=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let v=[];u(v),o.push(n),n=v,r=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:u,onError:(v,T,_)=>{l.push({error:v,offset:T,length:_})}};if(t)try{R.visit(t,d),s=n[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return s}doParseRaw(t,s){const r=m.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,s);t=n.raw;const o=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),u=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:l,overrides:u,restricted:n.restricted}}filter(t,s,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const o={},l=[];for(let u in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const d=this.filter(t[u],s,!1,n);o[u]=d.raw,l.push(...d.restricted)}else{const d=s[u],v=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(u),(v===void 0||n.scopes===void 0||n.scopes.includes(v))&&(n.skipRestricted&&d?.restricted||(o[u]=t[u]))}return{raw:o,restricted:l}}}e.ConfigurationModelParser=S;class f extends k.Disposable{constructor(t,s,r,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class p{constructor(t,s,r=new E,n=new E,o=new A.ResourceMap,l=new E,u=new A.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new E,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const n=this.getConsolidateConfigurationModel(s,r),o=this.getFolderConfigurationModelForResource(s.resource,r),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,N=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),C=n.getValue(t),F=D.distinct(D.flatten(n.overrides.map(z=>z.identifiers))).filter(z=>n.getOverrideValue(t,z)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:v,userRemoteValue:T,workspaceValue:_,workspaceFolderValue:O,memoryValue:N,value:C,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o?.freeze().getValue(t),override:s.overrideIdentifier?o?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(n=>I.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=(0,I.overrideIdentifierFromKey)(n),l=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=t.getKeysForOverrideIdentifier(o),d=[...u.filter(v=>l.indexOf(v)===-1),...l.filter(v=>u.indexOf(v)===-1),...l.filter(v=>!P.equals(this._defaultConfiguration.override(o).getValue(v),t.override(o).getValue(v)))];return[o,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:o}=(0,i.compare)(this.localUserConfiguration,t),l=[...s,...r,...n];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:o}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...s,...r,...n];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:n,overrides:o}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...s,...r,...n];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:o}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:n,updated:o,removed:l,overrides:u}=(0,i.compare)(r,s);let d=[...n,...o,...l];return(d.length||!r)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:o,overrides:l}=(0,i.compare)(s,void 0);return{keys:[...r,...n,...o],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=r.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:n,keys:o}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((l,u)=>(l.set(b.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new A.ResourceMap);return new p(s,r,new E,n,o,new E,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new E(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,s=new Map;for(const n of a)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,l])=>{const u=(0,A.getOrSet)(s,o,new Set);l.forEach(d=>u.add(d))});const r=[];return s.forEach((n,o)=>r.push([o,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=g;class y{constructor(t,s,r,n){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(u=>o.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>o.add(d))),this.affectedKeys=[...o.values()];const l=new E;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!P.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,i.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=y;class c extends y{constructor(t,s,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=c}),define(te[180],ne([0,1,5,3,2,16,20,87,38,34]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(m,E){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,E)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,E){const h=typeof m=="string"?m:void 0,S=(0,A.isConfigurationOverrides)(m)?m:(0,A.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(h,S,void 0)}updateValue(m,E,h,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,E,1)}onDidDefaultConfigurationChange(m){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,m);this.trigger(h,E,6)}trigger(m,E,h){const S=new P.ConfigurationChangeEvent(m,{data:E},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[181],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(A,P=L.Unknown,w){super(A);this._message=A,this._code=P,this._detail=w,this.isHandled=P===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(A){return A instanceof R&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof R&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof R&&A.isHandled}}e.RemoteAuthorityResolverError=R}),define(te[182],ne([0,1,5,22,27,8,3,2,28,71,181]),function(J,e,D,L,R,k,A,P,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var m;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function E(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(M){const B=new R.CancellationTokenSource;return setTimeout(()=>B.cancel(),M),B.token}function S(M,B){if(M.isCancellationRequested||B.isCancellationRequested)return R.CancellationToken.Cancelled;const V=new R.CancellationTokenSource;return M.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class f{constructor(B){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function p(M,B){const V=new f(B);return V.registerDisposable(M.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),K=j(Z);K?V.reject(K):V.resolve(Z)})),V.promise}function g(M,B,V,Q,Z,K){const H=new f(K);return B.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&M.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function y(M,B){const V=new f(B);return M.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function c(M,B,V,Q){const Z=$(M,B);M.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let K;try{K=await g(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,Q)}catch(ae){throw M.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),M.logService.error(ae),ae}M.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(K,null),H=M.reconnectionProtocol,re=!1):(H=new b.PersistentProtocol(K,null),re=!0),M.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:M.connectionToken||"00000000000000000000"};H.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const ae=await p(H,S(Q,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}M.logService.trace(`${Z} 4/6. received SignRequest control message.`);const ue=await y(M.signService.sign(ae.data),Q),fe={type:"connectionType",commit:M.commit,signedData:ue,desiredConnectionType:B};return V&&(fe.args=V),M.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(L.VSBuffer.fromString(JSON.stringify(fe))),{protocol:H,ownsProtocol:re}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(M.logService.error(`${Z} the handshake timed out. Error:`),M.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${Z} received error control message when negotiating connection. Error:`),M.logService.error(ae)),re&&x(H),ae}}async function a(M,B,V,Q){const Z=Date.now(),K=$(M,B),{protocol:H,ownsProtocol:re}=await c(M,B,V,Q),ie=new f(Q);return ie.registerDisposable(H.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),fe=j(ue);fe?(M.logService.error(`${K} received error control message when negotiating connection. Error:`),M.logService.error(fe),re&&x(H),ie.reject(fe)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${G(Z)}!`),ie.resolve({protocol:H,firstMessage:ue}))})),ie.promise}async function t(M,B){const{protocol:V}=await a(M,1,void 0,B);return{protocol:V}}async function s(M,B,V){const{protocol:Q,firstMessage:Z}=await a(M,2,B,V),K=Z&&Z.debugPort;return{protocol:Q,debugPort:K}}async function r(M,B,V){const Q=Date.now(),Z=$(M,3),{protocol:K}=await c(M,3,B,V);return M.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(Q)}!`),K}async function n(M,B,V){const{host:Q,port:Z,connectionToken:K}=await M.addressProvider.getAddress();return{commit:M.commit,host:Q,port:Z,connectionToken:K,reconnectionToken:B,reconnectionProtocol:V,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function o(M,B,V){try{const Q=(0,w.generateUuid)(),Z=await n(M,Q,null),{protocol:K}=await t(Z,R.CancellationToken.None);return new z(M,B,V,Q,K)}catch(Q){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(Q),F.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=o;async function l(M,B){try{const V=(0,w.generateUuid)(),Q=await n(M,V,null),{protocol:Z,debugPort:K}=await s(Q,B,R.CancellationToken.None);return new U(M,B,V,Z,K)}catch(V){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(V),F.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=l;async function u(M,B,V){const Q=await n(M,(0,w.generateUuid)(),null);return await r(Q,{host:B,port:V},R.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function d(M){return(0,D.createCancelablePromise)(B=>new Promise((V,Q)=>{const Z=setTimeout(V,M*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var v;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=T;class _{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=N;class C{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=C;class F extends P.Disposable{constructor(B,V,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(K=>{const H=W(this._connectionType,this.reconnectionToken,!0);K?K.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${K.hadError}).`),K.error&&this._options.logService.error(K.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this._options.logService.error(K.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const K=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${K} received socket timeout event.`),this._beginReconnecting()})),F._instances.push(this),F._permanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}static triggerPermanentFailure(B,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(F._permanentFailure)return;const B=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=d(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(F._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const K=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${K.host}:${K.port}...`),await this._reconnect(K,h(I)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,k.isPromiseCanceledError)(K)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,i.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!F._permanentFailure)}_gotoPermanentFailure(B,V,Q){this._onDidStateChange.fire(new C(this.reconnectionToken,B,V,Q)),x(this.protocol)}}F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class z extends F{constructor(B,V,Q,Z,K){super(1,B,Z,K);this.client=this._register(new b.Client(K,{remoteAuthority:V,clientId:Q},B.ipcLogger))}async _reconnect(B,V){await t(B,V)}}e.ManagementPersistentConnection=z;class U extends F{constructor(B,V,Q,Z,K){super(2,B,Q,Z);this._startArguments=V,this.debugPort=K}async _reconnect(B,V){await s(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=U;function x(M){try{M.acceptDisconnect();const B=M.getSocket();M.dispose(),B.dispose()}catch(B){(0,k.onUnexpectedError)(B)}}function j(M){if(M&&M.type==="error"){const B=new Error(`Connection error: ${M.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function q(M,B){for(;M.length<B;)M+=" ";return M}function W(M,B,V){return`[remote-connection][${q(E(M),13)}][${B.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function $(M,B){return`${W(B,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function G(M){return`${Date.now()-M} ms`}}),define(te[183],ne([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=L;function R(b){if(!b)return;const i=b.indexOf("+");return i<0?b:b.substr(0,i)}e.getRemoteName=R;function k(b){return b.scheme!==D.Schemas.file&&b.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=k;function A(b){if(b.folders.length)return b.folders.every(i=>k(i.uri))?b.folders[0].uri:void 0;if(b.configuration&&k(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=A;function P(b){return A(b)?.scheme}e.getVirtualWorkspaceScheme=P;function w(b){return A(b)!==void 0}e.isVirtualWorkspace=w}),define(te[88],ne([0,1,25,6,183]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=k;function A(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class w{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let S=typeof E=="string"?E:E.value,f=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(S,f)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=w;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function i(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(m,E){if(E&&m.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,R.getRemoteName)(E)}`;return m.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[35],ne([0,1,25,88]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(h,S){return h.uuid&&S.uuid?h.uuid===S.uuid:h.id===S.id?!0:(0,D.compareIgnoreCase)(h.id,S.id)===0}e.areSameExtensions=R;class k{constructor(S,f){this.version=f,this.id=S.id,this.uuid=S.uuid}key(){return`${this.id}-${this.version}`}equals(S){return S instanceof k?R(this,S)&&this.version===S.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,S){return`${h}.${S}`}e.getExtensionId=A;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function w(h,S){return P(A(h,S))}e.getGalleryExtensionId=w;function b(h,S){const f=[],p=g=>{for(const y of f)if(y.some(c=>R(S(c),S(g))))return y;return null};for(const g of h){const y=p(g);y?y.push(g):f.push([g])}return f}e.groupByExtension=b;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function m(h){const S=new Set;for(const f of h)f.malicious&&S.add(f.id.id);return S}e.getMaliciousExtensionsSet=m;function E(h,S){const f=[],p=S.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const g=p.shift();if(g&&f.every(y=>!R(y.identifier,{id:g}))){const y=h.filter(c=>R(c.identifier,{id:g}));y.length===1&&(f.push(y[0]),p.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=E}),define(te[184],ne([0,1,5,8,2,4,16,61,7,28,19,13,29,35,14,10]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends R.Disposable{constructor(y,c,a,t){super();this.fileService=c,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=w.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,c){await this.cleanUpPromise;const a=this.getName(y),t=(0,A.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(y,s,c);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(n){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return t}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,c,a){try{await i.Promises.rename(y.fsPath,c.fsPath)}catch(t){if(k.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${y} to ${c} with 'EPERM' error. Trying again...`),this.rename(y,c,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const c=[],a=[];for(const r of y.children){const n=this.parse(r.name);n&&a.push([n,r])}const t=(0,E.groupByExtension)(a,([r])=>r),s=[];for(const r of t)r.sort((n,o)=>P.rcompare(n[0].version,o[0].version)),c.push(...r.slice(1).map(n=>n[1].resource)),s.push(r[0][1]);s.sort((r,n)=>r.mtime-n.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(c.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new E.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(y){const c=f.exec(y);return c&&c[1]&&c[2]?new E.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};p=he([X(0,I.INativeEnvironmentService),X(1,h.IFileService),X(2,m.IExtensionGalleryService),X(3,S.ILogService)],p),e.ExtensionsDownloader=p}),define(te[185],ne([0,1,2,9,19,88]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(w,b){super();this.environmentService=w,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(b.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(w){w.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[186],ne([0,1,3,2,16,7,13,35,14,10]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(m,E,h,S){super();this.extensionsManagementService=m,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(g=>{this.installedExtensions=g.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(g=>this.onInstallExtension(g))),this._register(m.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(m.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const f=k.URI.file(h.extensionsPath),p=new R.ExtUri(g=>!E.hasCapability(g,1024));this._register(E.watch(f)),this._register(D.Event.filter(E.onDidChangeFilesRaw,g=>g.changes.some(y=>this.doesChangeAffects(y,f,p)))(()=>this.onDidChange()))}doesChangeAffects(m,E,h){return h.isEqual(h.dirname(m.resource),E)?h.isEqual(m.resource,h.joinPath(E,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const E of m)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(E=>!(0,P.areSameExtensions)(E,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,P.areSameExtensions)(E,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),E=m.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,P.areSameExtensions)(f,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(f=>(0,P.areSameExtensions)(f,S))?!1:m.every(f=>!(0,P.areSameExtensions)(f.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=m.map(S=>S.identifier),(E.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:h})}}};i=he([X(1,w.IFileService),X(2,A.INativeEnvironmentService),X(3,b.ILogService)],i),e.ExtensionsWatcher=i}),define(te[187],ne([0,1,82,17,5,2,15,9,19,13,29,35,59,10]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(p,g,y){super();this.extensionManagementService=p,this.logService=y,this.cache=this._register(new S(g,y)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),g=["en",...Object.keys(p)];return(0,L.distinct)(g)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const g=await this.cache.getLanguagePacks();Object.keys(g).some(y=>g[y]&&g[y].extensions.some(c=>(0,I.areSameExtensions)(c.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(g);return!(0,L.equals)(Object.keys(p),Object.keys(y))}};h=he([X(0,i.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,E.ILogService)],h),e.LocalizationsService=h;let S=class extends k.Disposable{constructor(p,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(g=>{Object.keys(g).forEach(y=>delete g[y]),this.createLanguagePacksFromExtensions(g,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...g){for(const y of g)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,y);Object.keys(p).forEach(y=>this.updateHash(p[y]))}createLanguagePacksFromExtension(p,g){const y=g.identifier,c=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const a of c)if(g.location.scheme===A.Schemas.file&&(0,m.isValidLocalization)(a)){let t=p[a.languageId];t||(t={hash:"",extensions:[],translations:{}},p[a.languageId]=t);let s=t.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,y))[0];s?s.version=g.manifest.version:t.extensions.push({extensionIdentifier:y,version:g.manifest.version});for(const r of a.translations)t.translations[r.id]=(0,P.join)(g.location.fsPath,r.path)}}updateHash(p){if(p){const g=(0,D.createHash)("md5");for(const y of p.extensions)g.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);p.hash=g.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch(c){return{}}}).then(y=>(g=p(y),y)).then(y=>{for(const a of Object.keys(y))y[a]||delete y[a];this.languagePacks=y,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),w.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>g,y=>this.logService.error(y))})}};S=he([X(0,b.INativeEnvironmentService),X(1,E.ILogService)],S)}),define(te[188],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,10]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService");var A;(function(h){h.Http="http",h.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!S)return{address:S[1],port:+S[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function m(h,S){return S?S!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=m;let E=class{constructor(S){this.logService=S,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(S,f){return this._tunnelProvider=S,S?(this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const S=[],f=Array.from(this._tunnels.values());for(let p of f){const g=Array.from(p.values());for(let y of g){const c=await y.value;c&&S.push(c)}}return S}async dispose(){for(const S of this._tunnels.values()){for(const{value:f}of S.values())await f.then(p=>p?.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,f,p,g,y=!1,c=P.Private,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${g}.`),!S)return;f||(f="localhost");const t=this.retainOrCreateTunnel(S,f,p,g,y,c,a);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,privacy:S.privacy,protocol:S.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const f=this._tunnels.get(S.tunnelRemoteHost);if(f){const p=f.get(S.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,p))}}}}async tryDisposeTunnel(S,f,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${f}.`);const g=p.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(f),g}}async closeTunnel(S,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${f} `);const p=this._tunnels.get(S);if(p&&p.has(f)){const g=p.get(f);g.refcount=0,await this.tryDisposeTunnel(S,f,g)}}addTunnelToMap(S,f,p){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(f,{refcount:1,value:p})}async removeEmptyTunnelFromMap(S,f){const p=this._tunnels.get(S);p&&(await p.get(f)||p.delete(f),p.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,f){let p=[S];i(S)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):I(S)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const g=p.map(y=>this._tunnels.get(y));for(const y of g){const c=y?.get(f);if(c)return c}}canTunnel(S){return!!b(S)}createWithProvider(S,f,p,g,y,c,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${g}.`);const s={elevationRequired:y?m(g===void 0?p:g):!1},r={remoteAddress:{host:f,port:p},localAddressPort:g,privacy:c,public:c!==P.Private,protocol:a},n=S.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(f,p,n),n}};E=he([X(0,k.ILogService)],E),e.AbstractTunnelService=E}),define(te[189],ne([0,1,10,62,2,8,5]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(i){this._address=i,this._addressPromise&&(this._addressPromise.complete(i),this._addressPromise=null)}setTunnel(i){this._register(i)}}let w=class yt extends R.Disposable{constructor(i,I){super();this._tunnelService=i,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(i=>i.dispose())}async createTunnel(){return{id:String(++yt._lastId)}}async startTunnel(i,I,m,E,h){const S=new P,f=await Promise.resolve(this._tunnelService.openTunnel(S,I,m,E,h));if(!f)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${I}:${m} (remote).`),S.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(i))throw this._disposedTunnels.delete(i),S.dispose(),await f.dispose(),(0,k.canceled)();return S.setTunnel(f),this._tunnels.set(i,S),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${i}: ${f.localAddress} (local) to ${I}:${m} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(i,I){const m=this._tunnels.get(i);!m||m.setAddress(I)}async destroyTunnel(i){const I=this._tunnels.get(i);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${i}.`),this._tunnels.delete(i),await I.dispose();return}this._disposedTunnels.add(i)}};w._lastId=0,w=he([X(0,L.ITunnelService),X(1,D.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[190],ne([0,1,119,20,10]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,w){this.configurationService=P,this.logService=w}request(P,w){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,w)}async resolveProxy(P){}};k=he([X(0,L.IConfigurationService),X(1,R.ILogService)],k),e.RequestService=k}),define(te[43],ne([0,1,22,140,38,6,34]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function w(h){return h.res.statusCode===204}async function b(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=b;async function i(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const f=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(f)}catch(p){throw p.message+=`:
`+f,p}}e.asJson=i;function I(h){E(h)}e.updateProxyConfigurationsScope=I;let m;function E(h){const S=A.Registry.as(R.Extensions.Configuration),f=m;m={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[m],remove:f?[f]:[]})}E(2)}),define(te[191],ne([0,1,27,15,14,43]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(w,b){this.requestService=w,this.fileService=b}async download(w,b,i=D.CancellationToken.None){if(w.scheme===L.Schemas.file||w.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(w,b);return}const I={type:"GET",url:w.toString()},m=await this.requestService.request(I,i);if(m.res.statusCode===200)await this.fileService.writeFile(b,m.stream);else{const E=await(0,k.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${E}`)}}};A=he([X(0,k.IRequestService),X(1,R.IFileService)],A),e.DownloadService=A}),define(te[192],ne([0,1,17,27,66,2,16,152,14,10,30,43]),function(J,e,D,L,R,k,A,P,w,b,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends k.Disposable{constructor(h,S,f,p){super();this.fileService=h,this.productService=S,this.requestService=f,this.logService=p,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:g})=>this.allConfigBasedTips.set(g.configPath,g))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const S=[];for(const[f,p]of this.allConfigBasedTips)if(!(p.configScheme&&p.configScheme!==h.scheme))try{const g=await this.fileService.readFile((0,A.joinPath)(h,f)),y=new Map;(0,R.forEach)(p.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const s of t.remotes)y.set(s,{extensionId:a,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:a,extensionName:t.name,configName:p.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=(0,P.getDomainsOfRemotes)(g.value.toString(),[...y.keys()]);for(const a of c){const t=y.get(a);t&&S.push(t)}}catch(g){}return S}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const S=await(0,I.asJson)(h);return S?S.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};m=he([X(0,w.IFileService),X(1,i.IProductService),X(2,I.IRequestService),X(3,b.ILogService)],m),e.ExtensionTipsService=m}),define(te[47],ne([0,1,22,28]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,A,P){let w=P&&P.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await A.readFile(k.serviceMachineIdResource)).value.toString();w=(0,L.isUUID)(i)?i:null}catch(b){w=null}if(!w){w=(0,L.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(w))}catch(b){}}return P&&P.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=R}),define(te[89],ne([0,1,103,6]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(k){return(0,D.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId,channelId:k.reply.channel})}e.hash=R,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[193],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(L){L.WorkerSpawn="vscode:shared-process->shared-process-worker=spawn",L.WorkerTerminate="vscode:shared-process->shared-process-worker=terminate",L.WorkerReady="vscode:shared-process-worker->shared-process=ready",L.WorkerAck="vscode:shared-process-worker->shared-process=ack",L.WorkerTrace="vscode:shared-process-worker->shared-process=trace",L.WorkerInfo="vscode:shared-process-worker->shared-process=info",L.WorkerWarn="vscode:shared-process-worker->shared-process=warn",L.WorkerError="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[194],ne([0,1,72,27,2,15,28,10,89,193]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let i=class{constructor(E){this.logService=E,this.workers=new Map,this.processes=new Map}async createWorker(E){const h=`window: ${E.reply.windowId}, moduleId: ${E.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${h})`),this.disposeWorker(E);const S=new L.CancellationTokenSource;let f,p,g;const y=(0,w.hash)(E);if(this.processes.set(y,(0,R.toDisposable)(()=>{S.dispose(!0),f?.terminate(E,L.CancellationToken.None),p?.close(),g?.close(),this.processes.delete(y)})),f=await this.getOrCreateWebWorker(E),S.token.isCancellationRequested)return;const{port1:c,port2:a}=new MessageChannel;p=c,g=a,await f.spawn(E,g,S.token),!S.token.isCancellationRequested&&(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${h})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",E,[p]))}getOrCreateWebWorker(E){let h=this.workers.get(E.process.moduleId);return h||(this.logService.trace(`SharedProcess: creating new web worker (${E.process.moduleId})`),h=new I(E.process.type,this.logService).init(),this.workers.set(E.process.moduleId,h)),h}async disposeWorker(E){const h=this.processes.get((0,w.hash)(E));h&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${E.reply.windowId}, moduleId: ${E.process.moduleId})`),h.dispose())}};i=he([X(0,P.ILogService)],i),e.SharedProcessWorkerService=i;class I{constructor(E,h){this.type=E,this.logService=h,this.workerReady=this.doInit(),this.mapMessageNonceToMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let E;const h=new Promise(f=>E=f),S=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return S.onerror=f=>{this.logService.error(`SharedProcess: worker error (${this.type})`,f.message)},S.onmessageerror=f=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,f)},S.onmessage=f=>{const{id:p,message:g,nonce:y}=f.data;switch(p){case b.SharedProcessWorkerMessages.WorkerReady:E(S);break;case b.SharedProcessWorkerMessages.WorkerAck:if(y){const c=this.mapMessageNonceToMessageResolve.get(y);c&&(this.mapMessageNonceToMessageResolve.delete(y),c())}break;case b.SharedProcessWorkerMessages.WorkerTrace:this.logService.trace(`SharedProcess (${this.type}) [worker]:`,g);break;case b.SharedProcessWorkerMessages.WorkerInfo:g&&this.logService.info(g);break;case b.SharedProcessWorkerMessages.WorkerWarn:this.logService.warn(`SharedProcess (${this.type}) [worker]:`,g);break;case b.SharedProcessWorkerMessages.WorkerError:this.logService.error(`SharedProcess (${this.type}) [worker]:`,g);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,f)}},S.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),h}async send(E,h,S){const f=await this.workerReady;if(!h.isCancellationRequested)return new Promise(p=>{const g=(0,A.generateUuid)();this.mapMessageNonceToMessageResolve.set(g,p);const y={...E,nonce:g};S?f.postMessage(y,[S]):f.postMessage(y)})}spawn(E,h,S){const f={id:b.SharedProcessWorkerMessages.WorkerSpawn,configuration:E,environment:{bootstrapPath:k.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(f,S,h)}terminate(E,h){const S={id:b.SharedProcessWorkerMessages.WorkerTerminate,configuration:E};return this.send(S,h)}}}),define(te[90],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[195],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{vsda(){return new Promise((R,k)=>J(["vsda"],R,k))}async sign(R){try{const k=await this.vsda(),A=new k.signer;if(A)return A.sign(R)}catch(k){}return R}}e.SignService=D}),define(te[23],ne([0,1,5,3,2,18,73,6]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class m extends R.Disposable{constructor(f={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,p){p===w?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:p,target:this.getKeyTargets(f)[p]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,p,g){return this.getStorage(p)?.get(f,g)}getBoolean(f,p,g){return this.getStorage(p)?.getBoolean(f,g)}getNumber(f,p,g){return this.getStorage(p)?.getNumber(f,g)}store(f,p,g,y){if((0,k.isUndefinedOrNull)(p)){this.remove(f,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,g,y),this.getStorage(g)?.set(f,p)})}remove(f,p){this.withPausedEmitters(()=>{this.updateKeyTarget(f,p,void 0),this.getStorage(p)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,p){const g=[],y=this.getKeyTargets(f);for(const c of Object.keys(y))y[c]===p&&g.push(c);return g}updateKeyTarget(f,p,g){const y=this.getKeyTargets(p);typeof g=="number"?y[f]!==g&&(y[f]=g,this.getStorage(p)?.set(w,JSON.stringify(y))):typeof y[f]=="number"&&(delete y[f],this.getStorage(p)?.set(w,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const p=this.get(w,f);if(p)try{return JSON.parse(p)}catch(g){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=b.NONE){this._onWillSaveState.fire({reason:f}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return h(f,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends m{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=E;async function h(S,f,p,g){const y=o=>{try{return JSON.parse(o)}catch(l){return o}},c=new Map,a=new Map;S.forEach((o,l)=>{c.set(l,o),a.set(l,y(o))});const t=new Map,s=new Map;f.forEach((o,l)=>{t.set(l,o),s.set(l,y(o))}),console.group(`Storage: Global (path: ${p})`);let r=[];c.forEach((o,l)=>{r.push({key:l,value:o})}),console.table(r),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${g})`);let n=[];t.forEach((o,l)=>{n.push({key:l,value:o})}),console.table(n),console.groupEnd(),console.log(s)}e.logStorage=h}),define(te[196],ne([0,1,3,2,18,29,35,23]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends L.Disposable{constructor(I){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(I)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(I,m){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:m}),!0):!1}async disableExtension(I,m){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let m=this.getDisabledExtensions();return m.every(E=>!(0,A.areSameExtensions)(E,I))?(m.push(I),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(I){let m=this.getDisabledExtensions();for(let E=0;E<m.length;E++){const h=m[E];if((0,A.areSameExtensions)(h,I))return m.splice(E,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(I){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,m){this.storageManger.set(I,m,0)}};w=he([X(0,P.IStorageService)],w),e.GlobalExtensionEnablementService=w;class b extends L.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(I,m){let E;return m===0?((0,R.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,m)),E=this.storage[I]):E=this._get(I,m),JSON.parse(E)}set(I,m,E){let h=JSON.stringify(m.map(({id:f,uuid:p})=>({id:f,uuid:p})));this._get(I,E)!==h&&(E===0&&(m.length?this.storage[I]=h:delete this.storage[I]),this._set(I,m.length?h:void 0,E))}onDidStorageChange(I){if(I.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const E=this.get(I.key,I.scope);delete this.storage[I.key];const h=this.get(I.key,I.scope),S=E.filter(p=>!h.some(g=>(0,A.areSameExtensions)(p,g))),f=h.filter(p=>!E.some(g=>(0,A.areSameExtensions)(g,p)));(S.length||f.length)&&this._onDidChange.fire([...S,...f])}}_get(I,m){return this.storageService.get(I,m,"[]")}_set(I,m,E){m?this.storageService.store(I,m,E,1):this.storageService.remove(I,E)}}e.StorageManager=b}),define(te[197],ne([0,1,3,2]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i}async getItems(){const b={workspace:this.workspace},i=await this.channel.call("getItems",b);return new Map(i)}updateItems(b){const i={workspace:this.workspace};return b.insert&&(i.insert=Array.from(b.insert.entries())),b.delete&&(i.delete=Array.from(b.delete.values())),this.channel.call("updateItems",i)}}class k extends R{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class A extends R{constructor(b,i){super(b,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends L.Disposable{constructor(b,i){super();this.channel=b,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[198],ne([0,1,5,2,176,16,73,23,197]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends P.AbstractStorageService{constructor(I,m,E){super();this.mainProcessService=m,this.environmentService=E,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new w.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new A.Storage(I.globalStorage);return this._register(m.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),m}createWorkspaceStorage(I){const m=new w.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(m.workspaceStorage){const E=new A.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=E.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=I?.id,E}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const m=this.workspaceStorage,E=m?.items??new Map;m&&(await m.close(),m.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[h,S]of E)this.workspaceStorage.set(h,S)}}e.NativeStorageService=b}),define(te[199],ne([0,1,4,31,7,28]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,i,I,m,E,h,S,f,p,g){const y=Object.create(null);y["common.machineId"]=S,y.sessionID=(0,k.generateUuid)()+Date.now(),y.commitHash=E,y.version=h,y["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=L.platform,y["common.nodeArch"]=m,y["common.product"]=g||"desktop";const c=w(f||[]);c&&(y["common.msftInternal"]=c);let a=0;const t=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const s=A(I);s&&(y["common.platformDetail"]=s);try{const r=await b.readFile(R.URI.file(p));y["common.source"]=r.value.toString().slice(0,30)}catch(r){}return y}e.resolveCommonProperties=P;function w(b){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return b.some(m=>I===m)}e.verifyMicrosoftInternalDomain=w}),define(te[21],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[200],ne([0,1,33,56,5,36,15,9,4,7,112,19,115,78,14,30,21]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(t,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,o=new Map,l=2e4;function u(T,_,O,N){const C=_.substring(T.length+1);return R.Promises.withAsyncBody(async F=>{let z;try{z=await I.Promises.readdir(_,{withFileTypes:!0})}catch(j){F();return}if(N.count>=l){N.count+=z.length,N.maxReached=!0,F();return}let U=z.length;if(U===0){F();return}let x=z;N.count+z.length>l&&(N.maxReached=!0,U=l-N.count,x=z.slice(0,U)),N.count+=z.length;for(const j of x)if(j.isDirectory()){if(O.includes(j.name)||await u(T,(0,P.join)(_,j.name),O,N),--U==0){F();return}}else{const q=j.name.lastIndexOf(".");if(q>=0){const W=j.name.substring(q+1);W&&n.set(W,(n.get(W)??0)+1)}for(const W of r)W.relativePathPattern?.test(C)!==!1&&W.filePattern.test(j.name)&&o.set(W.tag,(o.get(W.tag)??0)+1);if(--U==0){F();return}}})}const d={count:0,maxReached:!1};await u(t,t,s,d);const v=await c(t);return{configFiles:g(o),fileTypes:g(n),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:v}}e.collectWorkspaceStats=p;function g(t){return[...L.Iterable.map(t.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function y(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.getMachineInfo=y;async function c(t){try{const s=new Map,r=(0,P.join)(t,".vscode","launch.json"),n=await I.Promises.readFile(r),o=[],l=(0,k.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const u of l.configurations){const d=u.type;d&&(s.has(d)?s.set(d,s.get(d)+1):s.set(d,1))}return g(s)}catch(s){return[]}}e.collectLaunchConfigs=c;let a=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,m.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async n=>{let[o,l]=n,u=this.formatProcessList(s,o);return r.forEach(d=>{if((0,E.isRemoteDiagnosticError)(d))u+=`
${d.errorMessage}`,l+=`
${d.errorMessage}`;else if(u+=`

Remote: ${d.hostName}`,d.processes&&(u+=`
${this.formatProcessList(s,d.processes)}`),d.workspaceMetadata){l+=`
|  Remote: ${d.hostName}`;for(const v of Object.keys(d.workspaceMetadata)){const T=d.workspaceMetadata[v];let _=`${T.fileCount} files`;T.maxFilesReached&&(_=`more than ${_}`),l+=`|    Folder (${v}): ${_}`,l+=this.formatWorkspaceStats(T)}}}),{processInfo:u,workspaceInfo:l}})}async getSystemInfo(s,r){const{memory:n,vmHint:o,os:l,cpus:u}=y(),d={os:l,memory:n,cpus:u,vmHint:o,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(d.load=`${D.loadavg().map(v=>Math.round(v)).join(", ")}`),w.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(s,r){const n=[];return(0,m.listProcesses)(s.mainPID).then(async o=>(n.push(""),n.push(this.formatEnvironment(s)),n.push(""),n.push(this.formatProcessList(s,o)),s.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(s))),r.forEach(l=>{if((0,E.isRemoteDiagnosticError)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.formatMachineInfo(l.machineInfo)),l.processes&&n.push(this.formatProcessList(s,l.processes)),l.workspaceMetadata)for(const u of Object.keys(l.workspaceMetadata)){const d=l.workspaceMetadata[u];let v=`${d.fileCount} files`;d.maxFilesReached&&(v=`more than ${v}`),n.push(`Folder (${u}): ${v}`),n.push(this.formatWorkspaceStats(d))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(s){const r=[],n=60;let o=0;const l=(T,_)=>{const O=` ${T}(${_})`;o+O.length>n?(r.push(u),u="|                 ",o=u.length):o+=O.length,u+=O};let u="|      File types:";const d=10;let v=s.fileTypes.length>d?d:s.fileTypes.length;for(let T=0;T<v;T++){const _=s.fileTypes[T];l(_.name,_.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",o=0,s.configFiles.forEach(T=>{l(T.name,T.count)}),r.push(u)),s.launchConfigFiles.length>0){let T="|      Launch Configs:";s.launchConfigFiles.forEach(_=>{T+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(T)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(n=>n.length));return Object.keys(s).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${s[n]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],n=[];return s.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const u=b.URI.revive(l);if(u.scheme===A.Schemas.file){const d=u.fsPath;n.push(p(d,["node_modules",".git"]).then(v=>{let T=`${v.fileCount} files`;v.maxFilesReached&&(T=`more than ${T}`),r.push(`|    Folder (${(0,P.basename)(d)}): ${T}`),r.push(this.formatWorkspaceStats(v))}).catch(v=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${v.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(s,r){const n=new Map;s.windows.forEach(l=>n.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,n,o,r,0),o.join(`
`)}formatProcessItem(s,r,n,o,l){const u=l===0;let d;u?d=o.pid===s?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(d=`${d} (${r.get(o.pid)})`));const v=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(v/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(o.children)&&o.children.forEach(T=>this.formatProcessItem(s,r,n,T,l+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const n=b.URI.revive(r);if(n.scheme!==A.Schemas.file)continue;const o=n.fsPath;try{const l=await p(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),l.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),l.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),l.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};a=he([X(0,f.ITelemetryService),X(1,S.IProductService)],a),e.DiagnosticsService=a}),define(te[201],ne([0,1,17,5,27,8,3,2,4,7,129,29,35,10,42,21]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends P.Disposable{constructor(a,t,s){super();this.galleryService=a,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const t=await this.getTargetPlatform();return a.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,a.allTargetPlatforms,t))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));if(!await this.canInstall(a)){const r=await this.getTargetPlatform(),n=new I.ExtensionManagementError(i.localize(1,null,a.identifier.id,h.default.nameLong,(0,I.TargetPlatformToString)(r)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",a.identifier.id,n.message),g(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(a),void 0,n),n}try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(r){throw this.logService.error((0,k.getErrorMessage)(r)),g(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(a),void 0,r),r}const s=await this.galleryService.getManifest(a,R.CancellationToken.None);if(s===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,r.message),g(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(a),void 0,r),r}if(s.version!==a.version){const r=new I.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(r.message),g(this.telemetryService,"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(a),void 0,r),r}return this.installExtension(s,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(2,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(3,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,s){if(!b.URI.isUri(t)){let u=this.installingExtensions.get(new m.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],n=[],o=this.createInstallExtensionTask(a,t,s);b.URI.isUri(t)||this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(o.identifier,a.version).key(),o),this._onInstallExtension.fire({identifier:o.identifier,source:t}),this.logService.info("Installing extension:",o.identifier.id),r.push({task:o,manifest:a});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,a,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:v,manifest:T}of d)if(l=l||!!T.extensionDependencies?.some(_=>(0,m.areSameExtensions)({id:_},o.identifier)),this.installingExtensions.has(new m.ExtensionIdentifierWithVersion(v.identifier,v.version).key()))this.logService.info("Extension is already requested to install",v.identifier.id);else{const _=this.createInstallExtensionTask(T,v,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new m.ExtensionIdentifierWithVersion(_.identifier,T.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:v}),this.logService.info("Installing extension:",_.identifier.id),r.push({task:_,manifest:T})}}catch(d){if(b.URI.isUri(o.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),this.logService.error(d),d}const u=r.reduce((d,{task:v,manifest:T})=>(d.set(v.identifier.id.toLowerCase(),{task:v,manifest:T}),d),new Map);for(;u.size;){let d;const v=[...u.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(_=>u.has(_.toLowerCase())));v.length?d=u.size===1?v:v.filter(({task:T})=>!(T===o&&!l)):(this.logService.info("Found extensions with circular dependencies",v.map(({task:T})=>T.identifier.id)),d=[...u.values()]),await this.joinAllSettled(d.map(async({task:T})=>{const _=new Date().getTime();try{const O=await T.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(O,T.source,s,R.CancellationToken.None))),!b.URI.isUri(T.source)&&(g(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-_,void 0),w.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(N){}n.push({local:O,identifier:T.identifier,operation:T.operation,source:T.source})}catch(O){throw b.URI.isUri(T.source)||g(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,m.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-_,O),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(O),O}finally{u.delete(T.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:d})=>(0,m.areSameExtensions)(d,o.identifier))[0].local}catch(u){if(r.forEach(({task:d})=>d.cancel()),n.length)try{const d=await Promise.allSettled(n.map(({local:v})=>this.createUninstallExtensionTask(v,{versionOnly:!0}).run()));for(let v=0;v<d.length;v++){const T=d[v],{identifier:_}=n[v];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,k.getErrorMessage)(T.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(d),n.map(({identifier:v})=>v.id))}throw this.logService.error("Failed to install extension:",o.identifier.id,(0,k.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:d}of r)if(!b.URI.isUri(u.source)){const v=new m.ExtensionIdentifierWithVersion(u.identifier,d.version).key();this.installingExtensions.delete(v)||this.logService.warn("Installation task is not found in the cache",v)}}}async joinAllSettled(a){const t=[],s=[],r=await Promise.allSettled(a);for(const n of r)n.status==="fulfilled"?t.push(n.value):s.push(n.reason);if(s.length)throw p(s);return t}async getAllDepsAndPackExtensionsToInstall(a,t,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const n=[a,...r.map(u=>u.identifier)],o=[],l=async(u,d)=>{const v=d.extensionDependencies||[],T=[...v];if(d.extensionPack){const _=s?r.find(O=>(0,m.areSameExtensions)(O.identifier,u)):void 0;for(const O of d.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(N=>(0,m.areSameExtensions)({id:N},{id:O}))||T.every(N=>!(0,m.areSameExtensions)({id:N},{id:O}))&&T.push(O)}if(T.length){const _=[...n,...o.map(N=>N.gallery.identifier)],O=T.filter(N=>_.every(C=>!(0,m.areSameExtensions)(C,{id:N})));if(O.length){const N=await this.galleryService.query({names:O,pageSize:T.length},R.CancellationToken.None);for(const C of N.firstPage){if(_.find(x=>(0,m.areSameExtensions)(x,C.identifier)))continue;if(!v.some(x=>(0,m.areSameExtensions)({id:x},C.identifier))&&!await this.canInstall(C)){this.logService.info("Skipping the packed extension as it cannot be installed",C.identifier.id);continue}const z=await this.checkAndGetCompatibleVersion(C,!0),U=await this.galleryService.getManifest(z,R.CancellationToken.None);if(U===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${z.identifier.id}`,e.INSTALL_ERROR_VALIDATING);o.push({gallery:z,manifest:U}),await l(z.identifier,U)}}}};return await l(a,t),r=await this.getInstalled(),o.filter(u=>!r.some(d=>(0,m.areSameExtensions)(d.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new I.ExtensionManagementError(i.localize(4,null,a.identifier.id),I.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(a,t);if(!s)throw new I.ExtensionManagementError(i.localize(5,null,a.identifier.id,h.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(a,t){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(a,s)&&(r=a),!r&&t&&(r=await this.galleryService.getCompatibleExtension(a,s)),r}async isMalicious(a){const t=await this.getExtensionsReport();return(0,m.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const s=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),s.waitUntilTaskIsFinished();const r=(u,d)=>{const v=this.createUninstallExtensionTask(u,d);return this.uninstallingExtensions.set(v.extension.identifier.id.toLowerCase(),v),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),v},n=(u,d)=>{d?this.logService.error("Failed to uninstall extension:",u.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),g(this.telemetryService,"extensionGallery:uninstall",(0,m.getLocalExtensionTelemetryData)(u),void 0,d),this._onDidUninstallExtension.fire({identifier:u.identifier,error:d?.code})},o=[],l=[];try{o.push(r(a,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,u);for(const v of d)this.uninstallingExtensions.has(v.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",v.identifier.id):o.push(r(v,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(o.map(d=>d.extension),u,a),await this.joinAllSettled(o.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(v=>v.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(v){}n(d.extension)}catch(v){const T=v instanceof I.ExtensionManagementError?v:new I.ExtensionManagementError((0,k.getErrorMessage)(v),e.ERROR_UNKNOWN);throw n(d.extension,T),T}finally{l.push(d)}}))}catch(u){const d=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,k.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const v of o){try{v.cancel()}catch(T){}l.includes(v)||n(v.extension,d)}throw d}finally{for(const u of o)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(a,t,s){for(const r of a){const n=this.getDependents(r,t);if(n.length){const o=n.filter(l=>!a.some(u=>(0,m.areSameExtensions)(u.identifier,l.identifier)));if(o.length)throw new Error(this.getDependentsErrorMessage(r,o,s))}}}getDependentsErrorMessage(a,t,s){return s===a?t.length===1?i.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(9,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(10,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(11,null,s.manifest.displayName||s.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,s=[]){if(s.indexOf(a)!==-1)return[];s.push(a);const r=a.manifest.extensionPack?a.manifest.extensionPack:[];if(r.length){const n=t.filter(l=>!l.isBuiltin&&r.some(u=>(0,m.areSameExtensions)({id:u},l.identifier))),o=[];for(const l of n)o.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...n,...o]}return[]}getDependents(a,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,m.areSameExtensions)({id:r},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=he([X(0,I.IExtensionGalleryService),X(1,S.ITelemetryService),X(2,E.ILogService)],f),e.AbstractExtensionManagementService=f;function p(c){const a=Array.isArray(c)?c:[c];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=p;function g(c,a,t,s,r){const n=r?r instanceof I.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;c.publicLogError(a,{...t,success:!r,duration:s,errorcode:n})}e.reportTelemetry=g;class y{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,s)=>{const r=a.onCancellationRequested(()=>{r.dispose(),s((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=y}),define(te[202],ne([0,1,17,5,66,3,9,4,31,7,131,13,29,192,80,14,10,60,30,43,23,21]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends E.ExtensionTipsService{constructor(o,l,u,d,v,T,_,O,N,C){super(_,O,N,C);this.environmentService=o,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=v,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,R.forEach)(O.exeBasedExtensionTips,({key:F,value:z})=>{const U=[],x=[],j=[];(0,R.forEach)(z.recommendations,({key:q,value:W})=>{W.important?z.important?U.push({extensionId:q,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):x.push({extensionId:q,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):j.push({extensionId:q,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:U}),x.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:x}),j.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:j})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(o,l){const u=new Map;o.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:d,uninstalled:v}=this.groupByInstalled([...u.keys()],l);for(const O of d){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of v){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const T=this.getPromptedExecutableTips(),_=new Map;for(const O of v){const N=u.get(O);if(N&&(!T[N.exeName]||!T[N.exeName].includes(N.extensionId))){let C=_.get(N.exeName);C||(C=[],_.set(N.exeName,C)),C.push(N)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":const d=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const v=this._register((0,L.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),l=Date.now()-o,u=7*24*60*60*1e3;if(l<u){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(v[0].exeName,v);const _=this._register((0,L.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,L.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(o){const l=o.map(({extensionId:d})=>d.toLowerCase()),u=(0,i.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(o,l){const u=this.getPromptedExecutableTips();u[o]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(o,l){const u=[],d=[],v=l.reduce((T,_)=>(T.add(_.identifier.id.toLowerCase()),T),new Set);return o.forEach(T=>{v.has(T.toLowerCase())?u.push(T):d.push(T)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(o){const l=[],u=new Map;for(const d of o.keys()){const v=o.get(d);if(!v||!(0,D.isNonEmptyArray)(v.recommendations))continue;const T=[];P.isWindows?v.windowsPath&&T.push(v.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(T.push((0,A.join)("/usr/local/bin",d)),T.push((0,A.join)("/usr/bin",d)),T.push((0,A.join)(this.environmentService.userHome.fsPath,d)));for(const _ of T){let O=u.get(_);if(O===void 0&&(O=await this.fileService.exists(b.URI.file(_)),u.set(_,O)),O)for(const{extensionId:N,extensionName:C,isExtensionPack:F}of v.recommendations)l.push({extensionId:N,extensionName:C,isExtensionPack:F,exeName:d,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return l}};r=he([X(0,I.INativeEnvironmentService),X(1,a.ITelemetryService),X(2,m.IExtensionManagementService),X(3,c.IStorageService),X(4,p.INativeHostService),X(5,h.IExtensionRecommendationNotificationService),X(6,S.IFileService),X(7,g.IProductService),X(8,y.IRequestService),X(9,f.ILogService)],r),e.ExtensionTipsService=r}),define(te[91],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(k){this.appenders=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:P,data:w}){return this.appenders.forEach(b=>b.log(P,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[48],ne([0,1,26,18,20,21]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,g){return Promise.resolve(void 0)}publicLog2(p,g){return this.publicLog(p,g)}publicLogError(p,g){return Promise.resolve(void 0)}publicLogError2(p,g){return this.publicLogError(p,g)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class P{async publicLog(p,g,y){}async publicLogError(p,g,y){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(f,p){return p.onDidChangeConfiguration(g=>{g.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(g.source),configurationKeys:h(g.sourceConfig)})})}e.configurationTelemetry=w;function b(f,p){return!(p.disableTelemetry||!f.enableTelemetry)}e.supportsTelemetry=b;function i(f){const p=f.getValue(k.TELEMETRY_SETTING_ID),g=f.getValue("telemetry.enableCrashReporter");if(f.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function I(f){const p=Object.create(null),g=Object.create(null),y=Object.create(null);E(f,y);for(let c in y){c=c.length>150?c.substr(c.length-149):c;const a=y[c];typeof a=="number"?g[c]=a:typeof a=="boolean"?g[c]=a?1:0:typeof a=="string"?p[c]=a.substring(0,1023):typeof a!="undefined"&&a!==null&&(p[c]=a)}return{properties:p,measurements:g}}e.validateTelemetryData=I;function m(f){if(!f)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{f.indexOf(`${y}+`)===0&&(p=y)}),p}e.cleanRemoteAuthority=m;function E(f,p,g=0,y){if(!!f)for(let c of Object.getOwnPropertyNames(f)){const a=f[c],t=y?y+c:c;Array.isArray(a)?p[t]=(0,D.safeStringify)(a):a instanceof Date?p[t]=a.toISOString():(0,L.isObject)(a)?g<2?E(a,p,g+1,t+"."):p[t]=(0,D.safeStringify)(a):p[t]=a}}function h(f){if(!f)return[];const p=[];return S(p,"",f),p}function S(f,p,g){g&&typeof g=="object"&&!Array.isArray(g)?Object.keys(g).forEach(y=>S(f,p?`${p}.${y}`:y,g[y])):f.push(p)}}),define(te[203],ne([0,1,17,27,8,26,4,31,7,20,13,29,35,76,14,10,30,43,47,23,21,48]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,I.getTargetPlatform)(A.platform,P.arch);var s;(function(K){K[K.None=0]="None",K[K.IncludeVersions=1]="IncludeVersions",K[K.IncludeFiles=2]="IncludeFiles",K[K.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",K[K.IncludeSharedAccounts=8]="IncludeSharedAccounts",K[K.IncludeVersionProperties=16]="IncludeVersionProperties",K[K.ExcludeNonValidated=32]="ExcludeNonValidated",K[K.IncludeInstallationTargets=64]="IncludeInstallationTargets",K[K.IncludeAssetUri=128]="IncludeAssetUri",K[K.IncludeStatistics=256]="IncludeStatistics",K[K.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",K[K.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...K){return String(K.reduce((H,re)=>H|re,0))}var n;(function(K){K[K.Tag=1]="Tag",K[K.ExtensionId=4]="ExtensionId",K[K.Category=5]="Category",K[K.ExtensionName=7]="ExtensionName",K[K.Target=8]="Target",K[K.Featured=9]="Featured",K[K.SearchText=10]="SearchText",K[K.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class v{constructor(H=d){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new v({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ae=>({filterType:H,value:ae})):[{filterType:H}]];return new v({...this.state,criteria:ie})}withSortBy(H){return new v({...this.state,sortBy:H})}withSortOrder(H){return new v({...this.state,sortOrder:H})}withFlags(...H){return new v({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new v({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ae,sortOrder:ue,flags:fe,assetTypes:de}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ae,sortOrder:ue}],assetTypes:de,flags:fe}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===n.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(K,H){const re=(K||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function _(K){const H="Microsoft.VisualStudio.Code.Translation.";return K.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ae)=>{const ue=F(K,ae.assetType);return ue&&ie.push([ae.assetType.substring(H.length),ue]),ie},[])}function O(K){if(K.properties){const H=K.properties.filter(ae=>ae.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ae=>re.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return F(K,o.Repository)}function N(K){return{uri:`${K.fallbackAssetUri}/${o.VSIX}?redirect=true${K.targetPlatform?`&targetPlatform=${K.targetPlatform}`:""}`,fallbackUri:`${K.fallbackAssetUri}/${o.VSIX}${K.targetPlatform?`?targetPlatform=${K.targetPlatform}`:""}`}}function C(K){const H=F(K,o.Icon);if(H)return H;const re=I.DefaultIconPath;return{uri:re,fallbackUri:re}}function F(K,H){return K.files.filter(ie=>ie.assetType===H)[0]?{uri:`${K.assetUri}/${H}`,fallbackUri:`${K.fallbackAssetUri}/${H}`}:null}function z(K,H){const re=K.properties?K.properties.filter(ae=>ae.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ae=>(0,m.adoptToGalleryExtensionId)(ae)):[]}function U(K){const H=K.properties?K.properties.filter(re=>re.key===l.Engine):[];return H.length>0&&H[0].value||""}function x(K){const H=K.properties?K.properties.filter(ie=>ie.key===l.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function j(K){return K.indexOf("preview")!==-1}function q(K){return K.targetPlatform?(0,I.toTargetPlatform)(K.targetPlatform):"undefined"}function W(K){const H=(0,D.distinct)(K.versions.map(q)),re=!!K.tags?.includes(I.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function $(K,H){const re=(0,I.getFallbackTargetPlarforms)(H);for(let ie=0;ie<K.length;ie++){const ae=K[ie];if(ae.version===K[ie-1]?.version){let ue=ie;const fe=q(ae);if(fe===H)for(;ue>0&&K[ue-1].version===ae.version;)ue--;else if(re.includes(fe))for(;ue>0&&K[ue-1].version===ae.version&&q(K[ue-1])!==H;)ue--;ue!==ie&&(K.splice(ie,1),K.splice(ue,0,ae))}}return K}e.sortExtensionVersions=$;function G(K,H,re,ie,ae){const ue=W(K);let fe=K.versions[0];return fe=K.versions.find(de=>de.version===fe.version&&(0,I.isTargetPlatformCompatible)(q(de),ue,ae))||fe,M(K,fe,ue,H,re,ie)}function M(K,H,re,ie,ae,ue){const fe={manifest:F(H,o.Manifest),readme:F(H,o.Details),changelog:F(H,o.Changelog),license:F(H,o.License),repository:O(H),download:N(H),icon:C(H),coreTranslations:_(H)};return{identifier:{id:(0,m.getGalleryExtensionId)(K.publisher.publisherName,K.extensionName),uuid:K.extensionId},name:K.extensionName,version:H.version,displayName:K.displayName,publisherId:K.publisher.publisherId,publisher:K.publisher.publisherName,publisherDisplayName:K.publisher.displayName,description:K.shortDescription||"",installCount:T(K.statistics,"install"),rating:T(K.statistics,"averagerating"),ratingCount:T(K.statistics,"ratingcount"),categories:K.categories||[],tags:K.tags||[],releaseDate:Date.parse(K.releaseDate),lastUpdated:Date.parse(K.lastUpdated),allTargetPlatforms:re,assets:fe,properties:{dependencies:z(H,l.Dependency),extensionPack:z(H,l.ExtensionPack),engine:U(H),localizedLanguages:x(H),targetPlatform:q(H)},preview:j(K.flags),telemetryData:{index:(ae.pageNumber-1)*ae.pageSize+ie,querySource:ue}}}let B=class{constructor(H,re,ie,ae,ue,fe,de,Ie){this.requestService=re,this.logService=ie,this.environmentService=ae,this.telemetryService=ue,this.fileService=fe,this.productService=de,this.configurationService=Ie;const Ce=de.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(de.version,de,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ae=new v().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...H.map(({id:fe})=>fe.toLowerCase()));H.every(fe=>!fe.version)&&(ae=ae.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ae,t,L.CancellationToken.None);for(let fe=0;fe<ue.length;fe++){const de=ue[fe];if(!de.versions.length)continue;const Ie=(0,m.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Ce=H.find(Ee=>(0,m.areSameExtensions)(Ee,{id:Ie}))?.version;if(Ce){const Ee=de.versions.find(_e=>_e.version===Ce);Ee&&ie.push(M(de,Ee,W(de),fe,ae))}else ie.push(G(de,fe,ae,void 0,t))}return ie}async getCompatibleExtension(H,re){const ie=(0,I.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ae,uuid:ue}=ie?ie.identifier:H;let fe=new v().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");ue?fe=fe.withFilter(n.ExtensionId,ue):fe=fe.withFilter(n.ExtensionName,ae);const{galleryExtensions:de}=await this.queryGallery(fe,re,L.CancellationToken.None),[Ie]=de;if(!Ie||!Ie.versions.length)return null;const Ce=W(Ie);if((0,I.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of Ie.versions){if(!U(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return M(Ie,Ee,Ce,0,fe)}return null}async isExtensionCompatible(H,re){if(!(0,I.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ae=await this.getManifest(H,L.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return(0,E.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,I.isTargetPlatformCompatible)(q(H),re,ie))return!1;const ae=await this.getEngine(H);return(0,E.isEngineValid)(ae,this.productService.version,this.productService.date)}async query(H,re){const ie=L.CancellationToken.isCancellationToken(H)?{}:H,ae=L.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=ie.text||"";const fe=(0,k.getOrDefault)(ie,Pe=>Pe.pageSize,50);let de=new v().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(n.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Te,Fe)=>(de=de.withFilter(n.Category,Fe||Te),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Te,Fe)=>(de=de.withFilter(n.Tag,Fe||Te),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(n.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),de=de.withFilter(n.SearchText,ue)),de=de.withSortBy(0)):ie.ids?de=de.withFilter(n.ExtensionId,...ie.ids):ie.names?de=de.withFilter(n.ExtensionName,...ie.names):de=de.withSortBy(4),typeof ie.sortBy=="number"&&(de=de.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(de=de.withSortOrder(ie.sortOrder));const{galleryExtensions:Ie,total:Ce}=await this.queryGallery(de,t,ae),Ee=Ie.map((Pe,Te)=>G(Pe,Te,de,ie.source,t)),_e=async(Pe,Te)=>{if(Te.isCancellationRequested)throw(0,R.canceled)();const Fe=de.withPage(Pe+1),{galleryExtensions:$e}=await this.queryGallery(Fe,t,Te);return $e.map((Ne,qe)=>G(Ne,qe,Fe,ie.source,t))};return{firstPage:Ee,total:Ce,pageSize:de.pageSize,getPage:_e}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,r(s.Unpublished));const ae=await this.commonHeadersPromise,ue=JSON.stringify(H.raw),fe={...ae,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},de=new Date().getTime();let Ie,Ce,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:fe},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,p.asJson)(Ie);if(_e){const Pe=_e.results[0],Te=Pe.extensions;Te.forEach($e=>$($e.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Ce=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-de,success:!!Ie&&(0,p.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Ce?(0,R.isPromiseCanceledError)(Ce)?"canceled":(0,R.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ae){if(!this.isEnabled())return;const ue=A.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ae}`),fe=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},L.CancellationToken.None)}catch(Ce){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ae=(0,m.getGalleryExtensionTelemetryData)(H),ue=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:Ee}),de=ie===1?"install":ie===2?"update":"",Ie=de?{uri:`${H.assets.download.uri}${w.URI.parse(H.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${H.assets.download.fallbackUri}${w.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:H.assets.download,Ce=await this.getAsset(Ie);await this.fileService.writeFile(re,Ce.stream),fe(new Date().getTime()-ue)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,p.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ae=await(0,p.asText)(ie);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=F(H,o.Manifest);if(!ie)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ue=await this.getAsset(ie,{headers:ae});return await(0,p.asJson)(ue)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ae=>ae[0]===re.toUpperCase())[0];if(ie){const ae=await this.getAsset(ie[1]),ue=await(0,p.asText)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,p.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new v().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(n.ExtensionId,H.identifier.uuid):ie=ie.withFilter(n.ExtensionName,H.identifier.id);const{galleryExtensions:ae}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ae.length)return[];const ue=W(ae[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(ue,re))return[];const fe=[];for(const de of ae[0].versions)try{fe[fe.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,ue,re)&&fe.push({version:de.version,date:de.lastUpdated})}catch(Ie){}return fe}async getAsset(H,re={},ie=L.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},fe={...ae,...re.headers||{}};re={...re,...ue,headers:fe};const de=H.uri,Ie=H.fallbackUri,Ce={...re,url:de};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const _e=await(0,p.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,R.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,R.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:_e});const Pe={...re,url:Ie};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=U(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,p.asJson)(H),ie=new Map;if(re)for(const ae of re.malicious){const ue=ie.get(ae)||{id:{id:ae},malicious:!0,slow:!1};ue.malicious=!0,ie.set(ae,ue)}return[...ie.values()]}};B=he([X(1,p.IRequestService),X(2,S.ILogService),X(3,i.IEnvironmentService),X(4,c.ITelemetryService),X(5,h.IFileService),X(6,f.IProductService),X(7,b.IConfigurationService)],B);let V=class extends B{constructor(H,re,ie,ae,ue,fe,de,Ie){super(H,re,ie,ae,ue,fe,de,Ie)}};V=he([X(0,y.IStorageService),X(1,p.IRequestService),X(2,S.ILogService),X(3,i.IEnvironmentService),X(4,c.ITelemetryService),X(5,h.IFileService),X(6,f.IProductService),X(7,b.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends B{constructor(H,re,ie,ae,ue,fe,de){super(void 0,H,re,ie,ae,ue,fe,de)}};Q=he([X(0,p.IRequestService),X(1,S.ILogService),X(2,i.IEnvironmentService),X(3,c.ITelemetryService),X(4,h.IFileService),X(5,f.IProductService),X(6,b.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(K,H,re,ie,ae,ue){const fe={"X-Market-Client-Id":`VSCode ${K}`,"User-Agent":`VSCode ${K}`},de=await(0,g.getServiceMachineId)(re,ae,ue);return(0,a.supportsTelemetry)(H,re)&&(0,a.getTelemetryLevel)(ie)===3&&(fe["X-Market-User-Id"]=de),fe}e.resolveMarketplaceHeaders=Z}),define(te[92],ne([0,1,2,13,10,48]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(w,b,i=""){super();this.prefix=i;const I=w.getLogger(b.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(w.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,b){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,k.validateTelemetryData)(b))}};A=he([X(0,R.ILoggerService),X(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[93],ne([0,1,2,26,4,25,141,20,38,42,34,21,48]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(f,p){this._configurationService=p,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let g of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(g),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(g=>{const y=/^[a-f0-9]+$/i.test(g["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(f,p){this._experimentProperties[f]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let p=f.sessionID,g=f["common.instanceId"],y=f["common.machineId"],c=f["common.firstSessionDate"],a=f["common.msftInternal"];return{sessionId:p,instanceId:g,machineId:y,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(f,p,g,y){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(c=>{g=(0,L.mixin)(g,c),g=(0,L.mixin)(g,this._experimentProperties),g=(0,L.cloneAndChange)(g,a=>{if(typeof a=="string")return this._cleanupInfo(a,y)}),this._appenders.forEach(a=>a.log(f,g))},c=>{console.error(c)})}publicLog(f,p,g){return this._log(f,3,p,g)}publicLog2(f,p,g){return this.publicLog(f,p,g)}publicLogError(f,p){return this.sendErrorTelemetry?this._log(f,2,p,!0):Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}_anonymizeFilePaths(f){let p=f;const g=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(f);if(!s)break;g.push([s.index,t.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(p="";;){const t=c.exec(f);if(!t)break;!y.test(t[0])&&g.every(([s,r])=>t.index<s||t.index>=r)&&(p+=f.substring(a,t.index)+"<REDACTED: user-file-path>",a=c.lastIndex)}return a<f.length&&(p+=f.substr(a)),p}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const p=f.toLowerCase(),g=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(p)?"<REDACTED: secret>":g.test(p)?"<REDACTED: email>":f}_cleanupInfo(f,p){let g=f;p&&(g=this._anonymizeFilePaths(g));for(let y of this._cleanupPatterns)g=g.replace(y,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([X(1,P.IConfigurationService)],E),e.TelemetryService=E;function h(){const S=(0,A.localize)(0,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.isWeb?"":(0,A.localize)(3,null),g=(0,A.localize)(4,null),y=(0,A.localize)(5,null),c=(0,A.localize)(6,null),a=(0,A.localize)(7,null),t=`
|       | ${g} | ${y} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,A.localize)(8,null);return`
${S} ${f} ${p}

&nbsp;

${a}
${t}

&nbsp;

${s}
`}i.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(w.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,A.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,A.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[204],ne([0,1,8,26,48]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P){const w=await new Promise((i,I)=>{J(["applicationinsights"],i,I)});let b;return w.defaultClient?(b=new w.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(w.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=w.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class A{constructor(w,b,i){this._eventPrefix=w,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(b=>{w(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(w,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+w,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[205],ne([0,1,15,45,20,13,10,21,91,92,93]),function(J,e,D,L,R,k,A,P,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(E,h,S,f){this.configurationService=E,this.telemetryService=h,this.loggerService=S,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(E){if(!this.customTelemetryServices.has(E.id)){const{machineId:h,sessionId:S}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=h,f["common.vscodesessionid"]=S;const p=[E.id,JSON.stringify(f),E.aiKey],y=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new w.TelemetryAppenderClient(y),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${E.id}] `)];this.customTelemetryServices.set(E.id,new i.TelemetryService({appenders:c,sendErrorTelemetry:E.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(E.id)}async publicLog(E,h,S){await(await this.getCustomTelemetryService(E)).publicLog(h,S)}async publicLogError(E,h,S){await(await this.getCustomTelemetryService(E)).publicLogError(h,S)}};I=he([X(0,R.IConfigurationService),X(1,P.ITelemetryService),X(2,A.ILoggerService),X(3,k.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[206],ne([0,1,5,27,3,2,10]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(b,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((i,I)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,i),this._onCreateRequest.fire({requestId:m,...b});const E=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,E.token).then(()=>I(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,k.toDisposable)(()=>E.cancel())])})}acceptReply(b,i){const I=this._pendingRequests.get(b);I?(this._pendingRequests.delete(b),(0,k.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),I(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=he([X(1,A.ILogService)],P),e.RequestStore=P}),define(te[94],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var w;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var i;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(i=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(f){f.TerminalView="view",f.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(f){f.CwdDetection="cwdDetection"})(m=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var S;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(S=e.ProfileSource||(e.ProfileSource={}))}),define(te[207],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[208],ne([0,1,33,26,9,4,31,18,19]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let m=0;return I&&I.length===4&&(m=parseInt(I[3])),m}e.getWindowsBuildNumber=b;async function i(I,m,E,h=A.env,S=w.Promises.exists){if(R.isAbsolute(I))return await S(I)?I:void 0;if(m===void 0&&(m=A.cwd()),R.dirname(I)!=="."){const y=R.join(m,I);return await S(y)?y:void 0}const p=(0,L.getCaseInsensitive)(h,"PATH");if(E===void 0&&(0,P.isString)(p)&&(E=p.split(R.delimiter)),E===void 0||E.length===0){const y=R.join(m,I);return await S(y)?y:void 0}for(let y of E){let c;if(R.isAbsolute(y)?c=R.join(y,I):c=R.join(m,y,I),await S(c))return c;if(k.isWindows){let a=c+".com";if(await S(a)||(a=c+".exe",await S(a)))return a}}const g=R.join(m,I);return await S(g)?g:void 0}e.findExecutable=i}),define(te[209],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[95],ne([0,1,51,3,2,6,34,209]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var w;(function(f){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}f.isThemeColor=p})(w=e.ThemeColor||(e.ThemeColor={}));function b(f){return{id:f}}e.themeColorFromId=b;var i;(function(f){function p(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}f.isThemeIcon=p;const g=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function y(s){const r=g.exec(s);if(!r)return;let[,n]=r;return{id:n}}f.fromString=y;function c(s,r){let n=s.id;const o=n.lastIndexOf("~");return o!==-1&&(n=n.substring(0,o)),r&&(n=`${n}~${r}`),{id:n}}f.modify=c;function a(s,r){return s.id===r.id&&s.color?.id===r.color?.id}f.isEqual=a;function t(s,r){return{id:s.id,color:r?b(r):void 0}}f.asThemeIcon=t,f.asClassNameArray=D.CSSIcon.asClassNameArray,f.asClassName=D.CSSIcon.asClassName,f.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,R.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new m;A.Registry.add(e.Extensions.ThemingContribution,E);function h(f){return E.onColorThemeChange(f)}e.registerThemingParticipant=h;class S extends R.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let y=this.theme.getColor(p);return y&&g&&(y=g(y,this.theme)),y?y.toString():null}}e.Themable=S}),define(te[210],ne([0,1,51,95]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,w){const b=P.map(i=>({name:i.profileName,description:k(i)}));return w&&b.push(...w.map(i=>({name:i.title,description:A(i)}))),{values:b.map(i=>i.name),markdownDescriptions:b.map(i=>i.description)}}e.createProfileSchemaEnums=R;function k(P){let w=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?w+=`
- args: "${P.args}"`:w+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(w+=`
- overrideName: ${P.overrideName}`),P.color&&(w+=`
- color: ${P.color}`),P.env&&(w+=`
- env: ${JSON.stringify(P.env)}`),w}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[211],ne([0,1,51,142,38,34,210]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0}}};function E(){k.Registry.as(R.Extensions.Configuration).registerConfiguration(m),S()}e.registerTerminalPlatformConfiguration=E;let h;function S(f,p){const g=k.Registry.as(R.Extensions.Configuration);let y;f&&(y=(0,A.createProfileSchemaEnums)(f?.profiles,p));const c=h;h={id:"terminal",order:100,title:(0,L.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?y?.values:void 0,markdownEnumDescriptions:f?.os===3?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?y?.values:void 0,markdownEnumDescriptions:f?.os===2?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?y?.values:void 0,markdownEnumDescriptions:f?.os===1?y?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[h],remove:c?[c]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(te[212],ne([0,1,41,51,9,4,19,70,208,95]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function I(t,s,r,n,o=process.env,l,u,d,v){return l=l||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},k.isWindows?m(r,l,o,u,n.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:n.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:n.getValue("terminal.integrated.defaultProfile.windows"),v,d):y(l,u,r,t&&typeof t=="object"?{...t}:n.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:n.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,d,o)}e.detectAvailableProfiles=I;async function m(t,s,r,n,o,l,u,d,v){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let O=!1;(0,w.getWindowsBuildNumber)()>=16299&&(O=!0),await S(d);const N=new Map;t&&(N.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),c(l,N);const C=await E(N.entries(),u,s,r,n,v);if(t||!t&&o)try{const F=await p(`${_}\\${O?"wsl":"bash"}.exe`,u);for(const z of F)(!l||!(z.profileName in l))&&C.push(z)}catch(F){n?.info("WSL is not installed, so could not detect WSL profiles")}return C}async function E(t,s,r,n=process.env,o,l){const u=[];for(const[d,v]of t){if(v===null)continue;let T,_,O;if("source"in v){const F=i?.get(v.source);if(!F)continue;T=F.paths,_=v.args||F.args,v.icon?O=h(v.icon):F.icon&&(O=F.icon)}else T=Array.isArray(v.path)?v.path:[v.path],_=k.isWindows||Array.isArray(v.args)?v.args:void 0,O=h(v.icon)||void 0;const N=await l?.(T)||T.slice(),C=await a(d,s,N,r,n,_,v.env,v.overrideName,v.isAutoDetected,o);C?(C.isAutoDetected=v.isAutoDetected,C.icon=O,C.color=v.color,u.push(C)):o?.trace("profile not validated",d,T)}return u}function h(t){return typeof t=="string"?{id:t}:t}async function S(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function p(t,s){const r=[],n=await new Promise((u,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(v,T)=>{if(v)return d("Problem occurred when getting wsl distros");u(T)})});if(!n)return[];const o=new RegExp(/[\r?\n]/),l=n.split(o).filter(u=>u.trim().length>0&&u!=="");for(const u of l){if(u===""||u.startsWith("docker-desktop"))continue;const d=`${u} (WSL)`,v={profileName:d,path:t,args:["-d",`${u}`],isDefault:d===s,icon:g(u)};r.push(v)}return r}function g(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function y(t,s,r,n,o,l,u,d){const v=new Map;if(r){const T=(await t.readFile("/etc/shells")).toString(),_=l||T.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),O=new Map;for(const N of _){let C=(0,R.basename)(N),F=O.get(C)||0;F++,F>1&&(C=`${C} (${F})`),O.set(C,F),v.set(C,{path:N,isAutoDetected:!0})}}return c(n,v),await E(v.entries(),o,t,d,s,u)}function c(t,s){if(!!t)for(const[r,n]of Object.entries(t))n===null||!("path"in n)&&!("source"in n)?s.delete(r):s.set(r,n)}async function a(t,s,r,n,o,l,u,d,v,T){if(r.length===0)return Promise.resolve(void 0);const _=r.shift();if(_==="")return a(t,s,r,n,o,l,u,d,v);const O={profileName:t,path:_,args:l,env:u,overrideName:d,isAutoDetected:v,isDefault:t===s};if((0,R.basename)(_)===_){const C=o.PATH?o.PATH.split(R.delimiter):void 0;return await(0,w.findExecutable)(_,void 0,C,void 0,n.existsFile)?O:a(t,s,r,n,o,l)}return await n.existsFile((0,R.normalize)(_))?O:a(t,s,r,n,o,l,u,d,v)}}),define(te[213],ne([0,1,3,2,15,4,32,45,20,13,75,162,10,84,21,206,94,211,212]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let c=0,a=class extends L.Disposable{constructor(s,r,n,o,l){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=n,this._logService=o,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,p.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new S.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,i.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const n=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),A.ProxyChannel.toService(n.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=n.getChannel(f.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const u=A.ProxyChannel.toService(n.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(d=>this._onProcessData.fire(d))),this._register(u.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(u.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(u.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(u.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(u.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(u.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(u.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(u.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(u.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(u.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(u.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[n,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,n,o,l,u,d,v,T,_,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),C=await this._proxy.createProcess(s,r,n,o,l,u,d,v,T,_,O);return clearTimeout(N),c=Math.max(c,C),C}updateTitle(s,r,n){return this._proxy.updateTitle(s,r,n)}updateIcon(s,r,n){return this._proxy.updateIcon(s,r,n)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,n){return this._proxy.resize(s,r,n)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,n,o=!1){const l=await this._shellEnv;return(0,g.detectAvailableProfiles)(r,n,o,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,n){return this._proxy.updateProperty(s,r,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};a=he([X(1,w.IConfigurationService),X(2,b.IEnvironmentService),X(3,m.ILogService),X(4,h.ITelemetryService)],a),e.PtyHostService=a}),define(te[55],ne([0,1,44]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,w,b){const i=(0,D.setProperty)(A,P,w,b)[0];return i&&(A=A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)),A}e.edit=L;function R(A,P,w){let b=w;for(;b>=0;){if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&A.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function k(A,P,w){let b=w;for(;b>=0;)if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&A.charAt(b)===P.charAt(1)))return b;return A.length-1}e.getLineEndOffset=k}),define(te[214],ne([0,1,26,61]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(I,m,E,h,S){const f=[],p=[],g=[];if(!m){const _=I.filter(({identifier:O})=>S.every(N=>N.toLowerCase()!==O.id.toLowerCase()));return{local:{added:f,removed:p,updated:g},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}I=I.map(b),m=m.map(b),E=E?E.map(b):null;const y=new Map,c=_=>{_.uuid&&y.set(_.id.toLowerCase(),_.uuid)};I.forEach(({identifier:_})=>c(_)),m.forEach(({identifier:_})=>c(_)),E&&E.forEach(({identifier:_})=>c(_));const a=_=>{const O=_.identifier.uuid||y.get(_.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,O)=>(_.set(a(O),O),_),s=I.reduce(t,new Map),r=m.reduce(t,new Map),n=m.reduce((_,O)=>{const N=a(O);O=(0,D.deepClone)(O);const C=s.get(N);return C&&(C.installed&&(O.installed=!0),O.version||(O.version=C.version)),t(_,O)},new Map),o=E?E.reduce(t,new Map):null,l=h.reduce(t,new Map),u=S.reduce((_,O)=>{const N=y.get(O.toLowerCase());return _.add(N?`uuid:${N}`:`id:${O.toLowerCase()}`)},new Set),d=k(s,r,u);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const _=k(o,s,u),O=k(o,r,u),N=(C,F)=>{const z=s.get(C);if(z){const U=r.get(C);return{...F?U:z,version:(U.version&&L.gt(U.version,z.version),z.version),state:A(z,U,o?.get(C))}}};for(const C of O.removed.values()){const F=s.get(C);F&&p.push(F.identifier)}for(const C of O.added.values())if(_.added.has(C)){if(d.updated.has(C)){const F=N(C,!0);F&&(g.push(i(F,C)),n.set(C,F))}}else{const F=r.get(C);F.installed&&f.push(i(F,C))}for(const C of O.updated.values()){const F=N(C,!0);F&&(g.push(i(F,C)),n.set(C,F))}for(const C of _.added.values())O.added.has(C)||n.set(C,s.get(C));for(const C of _.updated.values())if(!O.removed.has(C)&&!O.updated.has(C)){const F=N(C,!1);F&&(n.get(C)?.installed&&(F.installed=!0),n.set(C,F))}for(const C of _.removed.values())!l.has(C)&&!O.updated.has(C)&&o?.get(C)?.installed&&n.delete(C)}const v=[],T=k(r,n,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&n.forEach((_,O)=>v.push(i(_,O))),{local:{added:f,removed:p,updated:g},remote:v.length?{added:[...T.added].map(_=>n.get(_)),updated:[...T.updated].map(_=>n.get(_)),removed:[...T.removed].map(_=>r.get(_)),all:v}:null}}e.merge=R;function k(I,m,E,{checkInstalledProperty:h,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=I?[...I.keys()].filter(a=>!E.has(a)):[],p=[...m.keys()].filter(a=>!E.has(a)),g=p.filter(a=>f.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),y=f.filter(a=>p.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),c=new Set;for(const a of f){if(y.has(a))continue;const t=I.get(a),s=m.get(a);(!s||t.disabled!==s.disabled||!w(t.state,s.state)||S&&t.version!==s.version||h&&t.installed!==s.installed)&&c.add(a)}return{added:g,removed:y,updated:c}}function A(I,m,E){const h=I.state,S=m.state,f=E?.state;if(!m.version||h&&L.gt(I.version,m.version))return h;if(S&&L.gt(m.version,I.version)||!h)return S;if(!S)return h;const p=(0,D.deepClone)(h),g=f?P(f,S):{added:Object.keys(S).reduce((c,a)=>(c.add(a),c),new Set),removed:new Set,updated:new Set},y=f?P(f,h):{added:Object.keys(h).reduce((c,a)=>(c.add(a),c),new Set),removed:new Set,updated:new Set};for(const c of[...g.added.values(),...g.updated.values()])p[c]=S[c];for(const c of g.removed.values())y.updated.has(c)||delete p[c];return p}function P(I,m){const E=Object.keys(I),h=Object.keys(m),S=h.filter(g=>E.indexOf(g)===-1).reduce((g,y)=>(g.add(y),g),new Set),f=E.filter(g=>h.indexOf(g)===-1).reduce((g,y)=>(g.add(y),g),new Set),p=new Set;for(const g of E){if(f.has(g))continue;const y=I[g],c=m[g];(0,D.equals)(y,c)||p.add(g)}return{added:S,removed:f,updated:p}}function w(I={},m={}){const{added:E,removed:h,updated:S}=P(I,m);return E.size===0&&h.size===0&&S.size===0}function b(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function i(I,m){const E={identifier:{id:I.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return I.version&&(E.version=I.version),I.disabled&&(E.disabled=!0),I.installed&&(E.installed=!0),I.state&&(E.state=I.state),E}}),define(te[96],ne([0,1,17,3,2,35,6,30,23]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class nt extends R.Disposable{constructor(m,E){super();this.storageService=m,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const E=b.exec(m);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const m=this.storageService.keys(0,1);for(const E of m){const h=nt.fromKey(E);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=nt.fromKey(m.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,E){this.storageService.store(nt.toKey(m),JSON.stringify(E),0,1)}getKeysForSync(m){const E=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],h=this.storageService.get(nt.toKey(m),0),S=h?JSON.parse(h):void 0;return S&&E?(0,D.distinct)([...S,...E]):S||E}};i=he([X(0,w.IStorageService),X(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[97],ne([0,1,17,20,6]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),w&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,w){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return b=b.filter(i=>i!==P&&i!==`-${P}`),w&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const w=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),i=[],I=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?I.push(m.substring(1)):i.push(m);return(0,D.distinct)([...w,...i].filter(m=>I.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};k=he([X(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[215],ne([0,1,17,36,26,157,55]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(c){return(0,L.parse)(c)||[]}e.parseKeybindings=P;async function w(c,a,t,s,r){const n=P(c),o=P(a),l=t?P(t):null,u=[...n,...o,...l||[]].map(x=>x.key),d=await r.resolveUserBindings(u);let v=i(n,o,l,d);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const T=m(n),_=m(o),O=l?m(l):null,N=h(T,_,d),C=O?h(O,T,d):{added:[...T.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set},F=O?h(O,_,d):{added:[..._.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set},z=b(N,C,F);let U=c;for(const x of z.removed.values())z.conflicts.has(x)||(U=g(U,x,s));for(const x of z.added.values()){if(z.conflicts.has(x))continue;const j=_.get(x);if(j.some(q=>q.command!==`-${x}`&&v.conflicts.has(d[q.key]))){z.conflicts.add(x);continue}U=p(U,j,s)}for(const x of z.updated.values()){if(z.conflicts.has(x))continue;const j=_.get(x);if(j.some(q=>q.command!==`-${x}`&&v.conflicts.has(d[q.key]))){z.conflicts.add(x);continue}U=y(U,x,j,s)}return{mergeContent:U,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=w;function b(c,a,t){const s=new Set,r=new Set,n=new Set,o=new Set;for(const l of a.removed.values())t.updated.has(l)&&o.add(l);for(const l of t.removed.values())o.has(l)||(a.updated.has(l)?o.add(l):r.add(l));for(const l of a.added.values())o.has(l)||t.added.has(l)&&c.updated.has(l)&&o.add(l);for(const l of t.added.values())o.has(l)||(a.added.has(l)?c.updated.has(l)&&o.add(l):s.add(l));for(const l of a.updated.values())o.has(l)||t.updated.has(l)&&c.updated.has(l)&&o.add(l);for(const l of t.updated.values())o.has(l)||(a.updated.has(l)?c.updated.has(l)&&o.add(l):n.add(l));return{added:s,removed:r,updated:n,conflicts:o}}function i(c,a,t,s){const r=new Set,n=I(c,s),o=I(a,s),l=t?I(t,s):null,u=E(n,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const d=l?E(l,n):{added:[...n.keys()].reduce((C,F)=>(C.add(F),C),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const v=l?E(l,o):{added:[...o.keys()].reduce((C,F)=>(C.add(F),C),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:T,removed:_,updated:O,conflicts:N}=b(u,d,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:_,updated:O,conflicts:N}}function I(c,a){const t=new Map;for(const s of c){const r=a[s.key];let n=t.get(r);n||(n=[],t.set(r,n)),n.push(s)}return t}function m(c){const a=new Map;for(const t of c){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=a.get(s);r||(r=[],a.set(s,r)),r.push(t)}return a}function E(c,a){const t=[...c.keys()],s=[...a.keys()],r=s.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),n=t.filter(l=>s.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),o=new Set;for(const l of t){if(n.has(l))continue;const u=c.get(l).map(v=>({...v,key:l})),d=a.get(l).map(v=>({...v,key:l}));(0,D.equals)(u,d,(v,T)=>f(v,T))||o.add(l)}return{added:r,removed:n,updated:o}}function h(c,a,t){const s=[...c.keys()],r=[...a.keys()],n=r.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),o=s.filter(u=>r.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of s){if(o.has(u))continue;const d=c.get(u).map(T=>({...T,key:t[T.key]})),v=a.get(u).map(T=>({...T,key:t[T.key]}));S(d,v)||l.add(u)}return{added:n,removed:o,updated:l}}function S(c,a){return!(!(0,D.equals)(c.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,s)=>f(t,s))||!(0,D.equals)(c.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,s)=>f(t,s)))}function f(c,a){if(c.command!==a.command||c.key!==a.key)return!1;const t=k.ContextKeyExpr.deserialize(c.when),s=k.ContextKeyExpr.deserialize(a.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!R.equals(c.args,a.args))}function p(c,a,t){for(const s of a)c=A.edit(c,[-1],s,t);return c}function g(c,a,t){const s=P(c);for(let r=s.length-1;r>=0;r--)(s[r].command===a||s[r].command===`-${a}`)&&(c=A.edit(c,[r],void 0,t));return c}function y(c,a,t,s){const r=P(c),n=r.findIndex(o=>o.command===a||o.command===`-${a}`);for(let o=r.length-1;o>=0;o--)(r[o].command===a||r[o].command===`-${a}`)&&(c=A.edit(c,[o],void 0,s));for(let o=t.length-1;o>=0;o--)c=A.edit(c,[n],t[o],s);return c}}),define(te[216],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(k,A,P){const w={},b={},i=new Set;if(!A)return{local:{added:w,updated:b,removed:[...i.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const I=L(k,A);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:w,updated:b,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(P,k),E=L(P,A),h={},S={},f=new Set,p=new Set;for(const g of m.removed.values())E.updated.has(g)?w[g]=A[g]:f.add(g);for(const g of E.removed.values())p.has(g)||(m.updated.has(g)?p.add(g):i.add(g));for(const g of m.updated.values())p.has(g)||(E.updated.has(g)?I.updated.has(g)&&p.add(g):S[g]=k[g]);for(const g of E.updated.values())p.has(g)||(m.updated.has(g)?I.updated.has(g)&&p.add(g):k[g]!==void 0&&(b[g]=A[g]));for(const g of m.added.values())p.has(g)||(E.added.has(g)?I.updated.has(g)&&p.add(g):h[g]=k[g]);for(const g of E.added.values())p.has(g)||(m.added.has(g)?I.updated.has(g)&&p.add(g):w[g]=A[g]);return{local:{added:w,removed:[...i.values()],updated:b},remote:{added:h,removed:[...f.values()],updated:S},conflicts:[...p.values()]}}e.merge=D;function L(k,A){const P=k?Object.keys(k):[],w=A?Object.keys(A):[],b=w.filter(m=>P.indexOf(m)===-1).reduce((m,E)=>(m.add(E),m),new Set),i=P.filter(m=>w.indexOf(m)===-1).reduce((m,E)=>(m.add(E),m),new Set),I=new Set;for(const m of P){if(i.has(m))continue;const E=k[m],h=A[m];E!==h&&I.add(m)}return{added:b,removed:i,updated:I}}function R(k,A){const{added:P,removed:w,updated:b}=L(k,A);return P.size===0&&w.size===0&&b.size===0}e.areSame=R}),define(te[24],ne([0,1,17,16,18,147,38,29,6,86,34]),function(J,e,D,L,R,k,A,P,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const l=i.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(u=>!!l[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function m(){const l=i.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(l).filter(T=>!!l[T].ignoreSync),d=Object.keys(l).filter(T=>l[T].scope===2||l[T].scope===6),v=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...v])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function E(){const l="vscode://schemas/ignoredSettings",u=i.Registry.as(A.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(b.Extensions.JSONContribution),v=()=>{const T=I(),_=m().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(F=>_.indexOf(F)===-1),N=_.filter(F=>T.indexOf(F)===-1),C={items:{type:"string",enum:[...O,...N.map(F=>`-${F}`)]}};d.registerSchema(l,C)};return u.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=E;function h(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=h;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(l){const u={};return u[e.HEADER_EXECUTION_ID]=l,u}e.createSyncHeaders=p;var g;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(u,d,v,T){super(u);this.code=d,this.resource=v,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class c extends y{constructor(u,d,v,T,_){super(u,v,void 0,_);this.url=d,this.serverCode=T}}e.UserDataSyncStoreError=c;class a extends y{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=a,function(l){function u(d){if(d instanceof l)return d;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(v&&v[1]){const T=v[2]==="unknown"?void 0:v[2],_=v[3]==="unknown"?void 0:v[3];return new l(d.message,v[1],T,_)}return new l(d.message,"Unknown")}l.toUserDataSyncError=u}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(l){return`sync.enable.${l}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(l,u){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[49],ne([0,1,17,5,22,27,3,36,2,16,25,18,7,143,20,13,14,47,23,21,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=a;let t=class extends w.Disposable{constructor(l,u,d,v,T,_,O,N,C,F){super();this.resource=l,this.fileService=u,this.environmentService=d,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=O,this.telemetryService=N,this.logService=C,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(d,u,v)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,this.getUserDataSyncConfiguration(),k.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const u=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,u={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),u)}async preview(l,u,d={}){return this._sync(l,!1,u,d)}async apply(l,u={}){try{this.syncHeaders={...u};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,u,d,v){try{if(this.syncHeaders={...v},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let T="idle";try{const _=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,_);return T=await this.performSync(O,_,u,d),T==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(T)}}finally{this.syncHeaders={}}}async replace(l){const u=await this.resolveContent(l);if(!u)return!1;const d=this.parseSyncData(u);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const v=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,v),_=await this.isRemoteDataFromCurrentMachine(T),O=await this.generateSyncPreview({ref:T.ref,syncData:d},v,_,this.getUserDataSyncConfiguration(),k.CancellationToken.None),N=[];for(const C of O){const F=await this.getAcceptResult(C,C.remoteResource,void 0,k.CancellationToken.None),{remoteChange:z}=await this.getAcceptResult(C,C.previewResource,C.remoteContent,k.CancellationToken.None);N.push([C,{...F,remoteChange:z!==0?z:2}])}await this.applyResult(T,v,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const u=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===u}async getLatestRemoteUserData(l,u){if(u){const d=l&&l.latest?l.latest[this.resource]:void 0;if(u.ref===d||d===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(l,u,d,v){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,u,d,v)}catch(T){if(T instanceof c.UserDataSyncError)switch(T.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,u,d,v);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(l,u,d,v)}throw T}}async doSync(l,u,d,v){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(_=>this.doGenerateSyncResourcePreview(l,u,d,v,_)));const T=await this.syncPreviewPromise;return this.updateConflicts(T.resourcePreviews),T.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(T){throw this.syncPreviewPromise=null,T}}async merge(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,k.CancellationToken.None);await this.fileService.writeFile(u.previewResource,R.VSBuffer.fromString(d?.content||""));const v=d&&!d.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,k.CancellationToken.None):void 0;return u.acceptResult=v,u.mergeState=d.hasConflicts?"conflict":v?"accepted":"preview",u.localChange=v?v.localChange:d.localChange,u.remoteChange=v?v.remoteChange:d.remoteChange,u}),this.syncPreviewPromise}async accept(l,u){return await this.updateSyncResourcePreview(l,async d=>{const v=await this.getAcceptResult(d,l,u,k.CancellationToken.None);return d.acceptResult=v,d.mergeState="accepted",d.localChange=v.localChange,d.remoteChange=v.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,k.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,R.VSBuffer.fromString(d.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=d.localChange,u.remoteChange=d.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(l,u){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const v=d.resourcePreviews.findIndex(({localResource:T,remoteResource:_,previewResource:O})=>this.extUri.isEqual(T,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(O,l));v!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async T=>{const _=[...d.resourcePreviews];return _[v]=await u(_[v]),{...d,resourcePreviews:_}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const u=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,u,(d,v)=>this.extUri.isEqual(d.previewResource,v.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return m.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return m.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(l){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const d of u.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,u,d,v,T){const _=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,u,_,v,T),N=[];for(const C of O){const F=C.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(C.localChange===0&&C.remoteChange===0)N.push({...C,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=d?await this.getMergeResult(C,T):void 0;if(T.isCancellationRequested)break;await this.fileService.writeFile(C.previewResource,R.VSBuffer.fromString(z?.content||""));const U=z&&!z.hasConflicts?await this.getAcceptResult(C,C.previewResource,void 0,T):void 0;N.push({...C,acceptResult:U,mergeState:z?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:z?z.localChange:C.localChange,remoteChange:U?U.remoteChange:z?z.remoteChange:C.remoteChange})}}return{remoteUserData:l,lastSyncUserData:u,resourcePreviews:N,isLastSyncFromCurrentMachine:_}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&d&&u.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const v=u;if(v.content===null)return{ref:u.ref,syncData:null};const T=JSON.parse(v.content);if(a(T))return{...u,syncData:T,content:void 0}}catch(l){l instanceof f.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),v={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...u};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(v)))}async getRemoteUserData(l){const{ref:u,content:d}=await this.getUserData(l);let v=null;return d!==null&&(v=this.parseSyncData(d)),{ref:u,syncData:v}}parseSyncData(l){try{const u=JSON.parse(l);if(a(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,I.isString)(l)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:u}}else{const u=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(l,u){const d=await this.currentMachineIdPromise,v={version:this.version,machineId:d,content:l};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(v),u,this.syncHeaders),{ref:u,syncData:v}}async backupLocal(l){const u={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([X(1,f.IFileService),X(2,S.IEnvironmentService),X(3,g.IStorageService),X(4,c.IUserDataSyncStoreService),X(5,c.IUserDataSyncBackupStoreService),X(6,c.IUserDataSyncResourceEnablementService),X(7,y.ITelemetryService),X(8,c.IUserDataSyncLogService),X(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,u,d,v,T,_,O,N,C,F,z){super(u,d,v,T,_,O,N,C,F,z);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,u,d){try{u?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:u):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(v){throw v instanceof f.FileOperationError&&v.fileOperationResult===1||v instanceof f.FileOperationError&&v.fileOperationResult===3?new c.UserDataSyncError(v.message,"LocalPreconditionFailed"):v}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=he([X(2,f.IFileService),X(3,S.IEnvironmentService),X(4,g.IStorageService),X(5,c.IUserDataSyncStoreService),X(6,c.IUserDataSyncBackupStoreService),X(7,c.IUserDataSyncResourceEnablementService),X(8,y.ITelemetryService),X(9,c.IUserDataSyncLogService),X(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(l,u,d,v,T,_,O,N,C,F,z,U){super(l,u,d,v,T,_,O,N,C,F,U);this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(l){const u=[];return(0,P.parse)(l,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([X(2,f.IFileService),X(3,S.IEnvironmentService),X(4,g.IStorageService),X(5,c.IUserDataSyncStoreService),X(6,c.IUserDataSyncBackupStoreService),X(7,c.IUserDataSyncResourceEnablementService),X(8,y.ITelemetryService),X(9,c.IUserDataSyncLogService),X(10,c.IUserDataSyncUtilService),X(11,h.IConfigurationService)],r),e.AbstractJsonFileSynchroniser=r;let n=class{constructor(l,u,d,v){this.resource=l,this.environmentService=u,this.logService=d,this.fileService=v,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,b.extUri)}async initialize({ref:l,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(u);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(T){this.logService.error(T)}}parseSyncData(l){try{const u=JSON.parse(l);if(a(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,u={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};n=he([X(1,S.IEnvironmentService),X(2,c.IUserDataSyncLogService),X(3,f.IFileService)],n),e.AbstractInitializer=n}),define(te[217],ne([0,1,5,27,8,3,44,50,25,7,20,13,29,35,14,23,21,49,214,96,97,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,u){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const v=(await u.getInstalled(0)).filter(T=>T.isBuiltin);for(const T of d)l.version===1&&(T.enabled===!1&&(T.disabled=!0),delete T.enabled),l.version===2&&v.every(_=>!(0,E.areSameExtensions)(_.identifier,T.identifier))&&(T.installed=!0)}return d}function s(l,u,d){const v=d.get((0,E.getExtensionId)(l,u),0)||"{}";return JSON.parse(v)}e.getExtensionStorageState=s;function r(l,u,d,v){v.store((0,E.getExtensionId)(l,u),JSON.stringify(d),0,1)}e.storeExtensionStorageState=r;let n=class ft extends p.AbstractSynchroniser{constructor(u,d,v,T,_,O,N,C,F,z,U,x,j,q){super("extensions",d,u,v,T,_,x,j,F,U);this.storageService=v,this.extensionManagementService=O,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=C,this.extensionGalleryService=z,this.extensionsStorageSyncService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:$})=>!!$)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,d){const v=u.syncData?await t(u.syncData,this.extensionManagementService):null,T=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(O),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:z}=(0,g.merge)(N,v,_,T,C),U={local:F,remote:z,content:this.getPreviewContent(N,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:T,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:v?this.format(v):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,d,v,T){const _=[...d,...v],O=new Set,N=C=>{O.add(C.id.toLowerCase()),C.uuid&&O.add(C.uuid)};_.forEach(({identifier:C})=>N(C)),T.forEach(N);for(const C of u)O.has(C.identifier.id.toLowerCase())||C.identifier.uuid&&O.has(C.identifier.uuid)||_.push(C);return this.format(_)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,v,T){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),T=(0,g.merge)(u.localExtensions,null,null,u.skippedExtensions,v),{local:_,remote:O}=T;return{content:u.localContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),T=u.remoteContent?JSON.parse(u.remoteContent):null;if(T!==null){const _=(0,g.merge)(u.localExtensions,T,u.localExtensions,[],v),{local:O,remote:N}=_;return{content:u.remoteContent,local:O,remote:N,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,v,T){let{skippedExtensions:_,localExtensions:O}=v[0][0],{local:N,remote:C,localChange:F,remoteChange:z}=v[0][1];if(F===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(O)),_=await this.updateLocalExtensions(N.added,N.removed,N.updated,_)),C){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(C.all);u=await this.updateRemoteUserData(U,T?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${C.added.length?` Added: ${JSON.stringify(C.added.map(x=>x.identifier.id))}.`:""}${C.updated.length?` Updated: ${JSON.stringify(C.updated.map(x=>x.identifier.id))}.`:""}${C.removed.length?` Removed: ${JSON.stringify(C.removed.map(x=>x.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ft.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ft.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),T=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),_=this.getLocalExtensions(v).filter(O=>!T.some(N=>(0,E.areSameExtensions)({id:N},O.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const v=this.parseSyncData(d);if(v)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(v))}}return null}format(u){u.sort((T,_)=>!T.identifier.uuid&&_.identifier.uuid?-1:T.identifier.uuid&&!_.identifier.uuid?1:(0,w.compare)(T.identifier.id,_.identifier.id));const d=JSON.stringify(u),v=(0,P.format)(d,void 0,{});return(0,A.applyEdits)(d,v)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(v=>v.installed||v.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,d,v,T){const _=[],O=[],N=await this.extensionManagementService.getInstalled();if(d.length){const F=N.filter(({identifier:z,isBuiltin:U})=>!U&&d.some(x=>(0,E.areSameExtensions)(z,x)));await D.Promises.settled(F.map(async z=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,z.identifier.id),await this.extensionManagementService.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,z.identifier.id),_.push(z.identifier)}))}(u.length||v.length)&&await D.Promises.settled([...u,...v].map(async F=>{const z=N.find(x=>(0,E.areSameExtensions)(x.identifier,F.identifier));if(z&&z.isBuiltin){F.state&&z.manifest.version===F.version&&this.updateExtensionState(F.state,z.manifest.publisher,z.manifest.name,z.manifest.version),F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id)),_.push(F.identifier);return}const U=(await this.extensionGalleryService.getExtensions([F.identifier],L.CancellationToken.None))[0];if(F.state&&(z?z.manifest.version===F.version:!!U)){const x=z?z.manifest.publisher:U.publisher,j=z?z.manifest.name:U.name;this.updateExtensionState(F.state,x,j,z?.manifest.version)}if(U)try{F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,U.version)),z||(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,U.version),_.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),O.push(F)))}catch(x){O.push(F),x instanceof m.ExtensionManagementError&&x.code===m.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else O.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const C=[];for(const F of T)_.some(z=>(0,E.areSameExtensions)(z,F.identifier))||C.push(F);for(const F of O)C.some(z=>(0,E.areSameExtensions)(z.identifier,F.identifier))||C.push(F);return C}updateExtensionState(u,d,v,T){const _=s(d,v,this.storageService),O=T?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(d,v),version:T}):void 0;O?O.forEach(N=>{_[N]=u[N]}):Object.keys(u).forEach(N=>_[N]=u[N]),r(d,v,_,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:v,isBuiltin:T,manifest:_})=>{const O={identifier:v,version:_.version};d.some(N=>(0,E.areSameExtensions)(N,v))&&(O.disabled=!0),T||(O.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:v.id,version:_.version});if(N){const C=s(_.publisher,_.name,this.storageService);O.state=Object.keys(C).reduce((F,z)=>(N.includes(z)&&(F[z]=C[z]),F),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(N))}return O})}};n.EXTENSIONS_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=he([X(0,I.IEnvironmentService),X(1,h.IFileService),X(2,S.IStorageService),X(3,a.IUserDataSyncStoreService),X(4,a.IUserDataSyncBackupStoreService),X(5,m.IExtensionManagementService),X(6,m.IGlobalExtensionEnablementService),X(7,c.IIgnoredExtensionsManagementService),X(8,a.IUserDataSyncLogService),X(9,m.IExtensionGalleryService),X(10,i.IConfigurationService),X(11,a.IUserDataSyncResourceEnablementService),X(12,f.ITelemetryService),X(13,y.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let o=class extends p.AbstractInitializer{constructor(u,d,v,T,_){super("extensions",T,_,v);this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const v=[],T=[],_=[];for(const O of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const N=d.find(C=>(0,E.areSameExtensions)(C.identifier,O.identifier));N?(v.push(N),O.disabled&&_.push(O.identifier)):O.installed&&(T.push(O.identifier),O.disabled&&_.push(O.identifier))}return{installedExtensions:v,newExtensions:T,disabledExtensions:_,remoteExtensions:u}}};o=he([X(0,m.IExtensionManagementService),X(1,c.IIgnoredExtensionsManagementService),X(2,h.IFileService),X(3,I.IEnvironmentService),X(4,a.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(te[218],ne([0,1,26,24]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,w,b,i,I){if(!w)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const m=k(P,w);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=b?k(b,w):{added:Object.keys(w).reduce((g,y)=>(g.add(y),g),new Set),removed:new Set,updated:new Set},h=b?k(b,P):{added:Object.keys(P).reduce((g,y)=>(g.add(y),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},f=D.deepClone(w),p=!b;for(const g of h.added.values())g!==L.SYNC_SERVICE_URL_TYPE&&p&&E.added.has(g)||(f[g]=P[g]);for(const g of h.updated.values())f[g]=P[g];for(const g of h.removed.values())i.unregistered.includes(g)||delete f[g];for(const g of E.added.values()){const y=w[g];if(i.machine.includes(g)){I.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(g))continue;const c=P[g];c&&c.value===y.value||g===L.SYNC_SERVICE_URL_TYPE&&p&&h.added.has(g)||(c?S.updated[g]=y:S.added[g]=y)}for(const g of E.updated.values()){const y=w[g];if(i.machine.includes(g)){I.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const c=P[g];c&&c.value===y.value||(S.updated[g]=y)}for(const g of E.removed.values()){if(i.machine.includes(g)){I.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||S.removed.push(g)}return{local:S,remote:A(f,w)?null:f}}e.merge=R;function k(P,w){const b=Object.keys(P),i=Object.keys(w),I=i.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),m=b.filter(h=>i.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),E=new Set;for(const h of b){if(m.has(h))continue;const S=P[h],f=w[h];D.equals(S,f)||E.add(h)}return{added:I,removed:m,updated:E}}function A(P,w){const{added:b,removed:i,updated:I}=k(P,w);return b.size===0&&i.size===0&&I.size===0}}),define(te[219],ne([0,1,22,8,3,36,44,50,4,7,28,20,13,14,10,47,23,21,49,55,218,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",s=["locale"];function r(d){const v=d.storage?Object.keys(d.storage).sort():[],T={};v.forEach(N=>T[N]=d.storage[N]),d.storage=T;const _=JSON.stringify(d),O=(0,P.format)(_,void 0,{});return(0,A.applyEdits)(_,O)}const n=1;let o=class dt extends g.AbstractSynchroniser{constructor(v,T,_,O,N,C,F,z,U){super("globalState",v,N,U,T,_,C,F,O,z);this.storageService=U,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(v.onDidFilesChange,x=>x.contains(this.environmentService.argvResource)),R.Event.filter(U.onDidChangeValue,x=>x.scope===0&&x.target!==void 0?x.target===0:U.keys(0,0).includes(x.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,T,_){const O=v.syncData?JSON.parse(v.syncData.content):null;T=T===null&&_?v:T;const N=T&&T.syncData?JSON.parse(T.syncData.content):null,C=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(N),{local:z,remote:U}=(0,c.merge)(C.storage,O?O.storage:null,N?N.storage:null,F,this.logService),x={content:null,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(C),localUserData:C,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async getMergeResult(v,T){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,T,_,O){if(this.extUri.isEqual(T,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(T,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(T,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const T=JSON.parse(v.remoteContent),{local:_,remote:O}=(0,c.merge)(v.localUserData.storage,T.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,T,_,O){let{localUserData:N}=_[0][0],{local:C,remote:F,localChange:z,remoteChange:U}=_[0][1];if(z===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(C),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),U!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const x=JSON.stringify({storage:F});v=await this.updateRemoteUserData(x,O?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}T?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:dt.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,dt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let T=await super.resolveContent(v);if(T)return T;if(T=await super.resolveContent(this.extUri.dirname(v)),T){const _=this.parseSyncData(T);if(_)switch(this.extUri.basename(v)){case"globalState.json":return r(JSON.parse(_.content))}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${t}.locale`]?.value!=="en")return!0}catch(v){}return!1}async getLocalGlobalState(){const v={},T=await this.getLocalArgvContent(),_=(0,k.parse)(T);for(const O of s)_[O]!==void 0&&(v[`${t}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const N=this.storageService.get(O,0);N&&(v[O]={version:1,value:N})}return{storage:v}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const v=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),v.value.toString()}catch(v){this.logService.debug((0,L.getErrorMessage)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:T,updated:_}){const O={},N={},C=(z,U)=>{for(const x of z){if(x.startsWith(t)){O[x.substring(t.length)]=U?U[x].value:void 0;continue}if(U){const j=U[x];j.value!==String(this.storageService.get(x,0))&&(N[x]=j.value)}else this.storageService.get(x,0)!==void 0&&(N[x]=void 0)}};if(C(Object.keys(v),v),C(Object.keys(_),_),C(T),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(N))this.storageService.store(z,N[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(v){const T=await this.getLocalArgvContent();let _=T;for(const O of Object.keys(v))_=(0,y.edit)(_,[O],v[O],{});T!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const T=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...T,..._],N=v?.storage?Object.keys(v.storage).filter(C=>!C.startsWith(t)&&!O.includes(C)&&this.storageService.get(C,0)!==void 0):[];if(!w.isWeb){const C=[...a.ALL_SYNC_RESOURCES.map(F=>(0,a.getEnablementKey)(F)),a.SYNC_SERVICE_URL_TYPE];N.push(...C),_.push(...C)}return{user:T,machine:_,unregistered:N}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([X(0,E.IFileService),X(1,a.IUserDataSyncStoreService),X(2,a.IUserDataSyncBackupStoreService),X(3,a.IUserDataSyncLogService),X(4,m.IEnvironmentService),X(5,a.IUserDataSyncResourceEnablementService),X(6,p.ITelemetryService),X(7,I.IConfigurationService),X(8,f.IStorageService)],o),e.GlobalStateSynchroniser=o;let l=class extends g.AbstractInitializer{constructor(v,T,_,O){super("globalState",_,O,T);this.storageService=v}async doInitialize(v){const T=v.syncData?JSON.parse(v.syncData.content):null;if(!T){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const N of Object.keys(T.storage))N.startsWith(t)?_[N.substring(t.length)]=T.storage[N].value:this.storageService.get(N,0)===void 0&&(O[N]=T.storage[N].value);if(Object.keys(_).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(C){}for(const C of Object.keys(_))N=(0,y.edit)(N,[C],_[C],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(O).length)for(const N of Object.keys(O))this.storageService.store(N,O[N],0,0)}};l=he([X(0,f.IStorageService),X(1,E.IFileService),X(2,m.IEnvironmentService),X(3,a.IUserDataSyncLogService)],l),e.GlobalStateInitializer=l;let u=class{constructor(v,T,_,O,N){this.userDataSyncStoreClient=v,this.storageService=T,this.environmentService=_,this.fileService=O,this.logService=N}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[a.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const T=(0,a.createSyncHeaders)((0,i.generateUuid)());try{return await this.doSync(v,T)}catch(_){if(_ instanceof a.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,T)}throw _}}async doSync(v,T){const _=await this.userDataSyncStoreClient.read("globalState",null,T),O=this.parseGlobalState(_)||{storage:{}};O.storage[a.SYNC_SERVICE_URL_TYPE]={value:v,version:n};const N=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),C={version:n,machineId:N,content:r(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(C),_.ref,T)}parseGlobalState({content:v}){if(!v)return null;const T=JSON.parse(v);if((0,g.isSyncData)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};u=he([X(1,f.IStorageService),X(2,m.IEnvironmentService),X(3,E.IFileService),X(4,h.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(te[220],ne([0,1,17,22,3,36,4,18,144,20,13,14,23,21,49,215,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(c,a,t){try{const s=JSON.parse(c);if(!a)return(0,P.isUndefined)(s.all)?null:s.all;switch(A.OS){case 2:return(0,P.isUndefined)(s.mac)?null:s.mac;case 3:return(0,P.isUndefined)(s.linux)?null:s.linux;case 1:return(0,P.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=p;let g=class extends h.AbstractJsonFileSynchroniser{constructor(a,t,s,r,n,o,l,u,d,v){super(l.keybindingsResource,"keybindings",o,l,u,a,t,n,v,s,d,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(r.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,s,r){const n=a.syncData?p(a.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?a:t;const o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),u=await this.getFormattingOptions();let d=null,v=!1,T=!1,_=!1;if(n){let N=l?l.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new f.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==N||o!==n){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const C=await(0,S.merge)(N,n,o,u,this.userDataSyncUtilService);C.hasChanges&&(d=C.mergeContent,_=C.hasConflicts,v=_||C.mergeContent!==N,T=_||C.mergeContent!==n)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),T=!0);const O={content:d,localChange:v?l?2:1:0,remoteChange:T?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:n,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,s,r){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,s,r){const{fileContent:n}=s[0][0];let{content:o,localChange:l,remoteChange:u}=s[0][1];if(l===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new f.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),n&&await this.backupLocal(this.toSyncContent(n.value.toString())),await this.updateLocalFileContent(o||"[]",n,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(o||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,r?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,k.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(a)){case"keybindings.json":return p(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:p(a.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(a,t){let s={};try{s=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=a,A.OS){case 2:s.mac=a;break;case 3:s.linux=a;break;case 1:s.windows=a;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=he([X(0,f.IUserDataSyncStoreService),X(1,f.IUserDataSyncBackupStoreService),X(2,f.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,f.IUserDataSyncResourceEnablementService),X(5,I.IFileService),X(6,i.IEnvironmentService),X(7,m.IStorageService),X(8,f.IUserDataSyncUtilService),X(9,E.ITelemetryService)],g),e.KeybindingsSynchroniser=g;let y=class extends h.AbstractInitializer{constructor(a,t,s){super("keybindings",t,s,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return p(a,!0,this.logService)}catch(t){return this.logService.error(t),null}}};y=he([X(0,I.IFileService),X(1,i.IEnvironmentService),X(2,f.IUserDataSyncLogService)],y),e.KeybindingsInitializer=y}),define(te[221],ne([0,1,17,36,44,50,26,55,24]),function(J,e,D,L,R,k,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(l,u,d){let v=[];d?v=I(d):v=i(u);const T=[],_=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const O of v)O.startsWith("-")?_.push(O.substring(1)):T.push(O);return(0,D.distinct)([...l,...T].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=b;function i(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function I(l){const u=(0,L.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(l,u,d,v){if(d.length){const T=o(u),_=(0,L.parse)(u),O=(0,L.parse)(l),N=[];for(const C of d){const F=_[C],z=O[C];F===void 0?l=P.edit(l,[C],void 0,v):z!==void 0?l=P.edit(l,[C],F,v):N.push(a(C,T))}N.sort((C,F)=>C.startOffset-F.startOffset),N.forEach(C=>l=p(C.setting.key,u,l,v))}return l}e.updateIgnoredSettings=m;function E(l,u,d,v,T,_){const O=m(l,u,v,_),N=d!==O,C=d!==u;if(!N&&!C)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!C)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(C&&!N)return{conflictsSettings:[],localContent:m(u,l,v,_),remoteContent:null,hasConflicts:!1};if(d===null&&S(l)){const H=h(l,u,v)?null:m(u,l,v,_);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let F=l,z=u;const U=(0,L.parse)(l),x=(0,L.parse)(u),j=d?(0,L.parse)(d):null,q=v.reduce((H,re)=>(H.add(re),H),new Set),W=f(U,x,q),$=f(j,U,q),G=f(j,x,q),M=new Map,B=new Set,V=H=>{B.add(H);const re=T.filter(({key:ie})=>ie===H)[0];re?(F=P.edit(F,[H],re.value,_),z=P.edit(z,[H],re.value,_)):M.set(H,{key:H,localValue:U[H],remoteValue:x[H]})};for(const H of $.removed.values())G.updated.has(H)?V(H):z=P.edit(z,[H],void 0,_);for(const H of G.removed.values())B.has(H)||($.updated.has(H)?V(H):F=P.edit(F,[H],void 0,_));for(const H of $.updated.values())B.has(H)||(G.updated.has(H)?W.updated.has(H)&&V(H):z=P.edit(z,[H],U[H],_));for(const H of G.updated.values())B.has(H)||($.updated.has(H)?W.updated.has(H)&&V(H):F=P.edit(F,[H],x[H],_));for(const H of $.added.values())B.has(H)||(G.added.has(H)?W.updated.has(H)&&V(H):z=p(H,F,z,_));for(const H of G.added.values())B.has(H)||($.added.has(H)?W.updated.has(H)&&V(H):F=p(H,z,F,_));const Q=M.size>0||!h(F,z,v),Z=Q||!h(F,l,[]),K=Q||!h(z,u,[]);return{localContent:Z?F:null,remoteContent:K?z:null,conflictsSettings:[...M.values()],hasConflicts:Q}}e.merge=E;function h(l,u,d){if(l===u)return!0;const v=(0,L.parse)(l),T=(0,L.parse)(u),_=d.reduce((C,F)=>(C.add(F),C),new Set),O=o(l).filter(C=>!(C.setting&&_.has(C.setting.key))),N=o(u).filter(C=>!(C.setting&&_.has(C.setting.key)));if(O.length!==N.length)return!1;for(let C=0;C<O.length;C++){const F=O[C],z=N[C];if(F.setting&&z.setting){if(F.setting.key!==z.setting.key||!A.equals(v[F.setting.key],T[F.setting.key]))return!1}else if(!F.setting&&!z.setting){if(F.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function S(l){return l?o(l).length===0:!0}e.isEmpty=S;function f(l,u,d){const v=l?Object.keys(l).filter(C=>!d.has(C)):[],T=Object.keys(u).filter(C=>!d.has(C)),_=T.filter(C=>v.indexOf(C)===-1).reduce((C,F)=>(C.add(F),C),new Set),O=v.filter(C=>T.indexOf(C)===-1).reduce((C,F)=>(C.add(F),C),new Set),N=new Set;if(l)for(const C of v){if(O.has(C))continue;const F=l[C],z=u[C];A.equals(F,z)||N.add(C)}return{added:_,removed:O,updated:N}}function p(l,u,d,v){const T=(0,L.parse)(u),_=o(u),O=o(d),N=g(l,_,O);return y(d,l,T[l],N,O,v)}e.addSetting=p;function g(l,u,d){const v=u.findIndex(_=>_.setting?.key===l),T=u[v-1];if(T){if(T.setting){const O=a(T.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!0}}else{const O=t(v,u);if(O){const N=a(O.setting.key,d);if(N){const C=s(d.indexOf(N),d),F=r(u,O,u[v]);if(C){const z=r(d,N,C),U=n(F,z);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.indexOf(C),insertAfter:!1}}else{const z=r(d,N,d[d.length-1]),U=n(F,z);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const _=u[v+1];if(_)if(_.setting){const O=a(_.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!1}}else{const O=s(v,u);if(O){const N=a(O.setting.key,d);if(N){const C=t(d.indexOf(N),d),F=r(u,u[v],O);if(C){const z=r(d,C,N),U=n(F.reverse(),z.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:d.indexOf(C),insertAfter:!0}}else{const z=r(d,d[0],N),U=n(F.reverse(),z.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function y(l,u,d,v,T,_){let O;return v.index===-1?O=(0,R.setProperty)(l,[u],d,_):O=c(l,u,d,v,T,_).map(N=>(0,R.withFormatting)(l,N,_)[0]),(0,R.applyEdits)(l,O)}function c(l,u,d,v,T,_){const O=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,N=(0,k.getEOL)(_,l),C=T[v.index];if(v.insertAfter){const F=[];if(C.setting)F.push({offset:C.endOffset,length:0,content:","+O});else{const z=s(v.index,T),U=t(v.index,T),x=U?.setting?.commaOffset;U&&x===void 0&&F.push({offset:U.endOffset,length:0,content:","});const j=x!==void 0&&x>C.endOffset;F.push({offset:j?x+1:C.endOffset,length:0,content:z?N+O+",":N+O})}return F}else{if(C.setting)return[{offset:C.startOffset,length:0,content:O+","}];const F=(T[v.index-1]&&!T[v.index-1].setting?N:"")+O+(s(v.index,T)?",":"")+N;return[{offset:C.startOffset,length:0,content:F}]}}function a(l,u){return u.filter(d=>d.setting?.key===l)[0]}function t(l,u){for(let d=l-1;d>=0;d--)if(u[d].setting)return u[d]}function s(l,u){for(let d=l+1;d<u.length;d++)if(u[d].setting)return u[d]}function r(l,u,d){const v=l.indexOf(u),T=l.indexOf(d);return l.filter((_,O)=>v<O&&O<T)}function n(l,u){if(l.length&&u.length){let d=0;for(;d<u.length&&d<l.length;d++)if(l[d].value!==u[d].value)return u[d-1];return u[d-1]}}function o(l){const u=[];let d=-1,v,T;const _={onObjectBegin:O=>{d++},onObjectProperty:(O,N,C)=>{d===0&&(v=N,T=O)},onObjectEnd:(O,N)=>{d--,d===0&&u.push({startOffset:v,endOffset:O+N,value:l.substring(v,O+N),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(O,N)=>{d++},onArrayEnd:(O,N)=>{d--,d===0&&u.push({startOffset:v,endOffset:O+N,value:l.substring(v,O+N),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(O,N,C)=>{d===0&&u.push({startOffset:v,endOffset:N+C,value:l.substring(v,N+C),setting:{key:T,commaOffset:void 0}})},onSeparator:(O,N,C)=>{if(d===0&&O===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const z=u[F];z&&u.splice(F,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:N}})}},onComment:(O,N)=>{d===0&&u.push({startOffset:O,endOffset:O+N,value:l.substring(O,O+N)})}};return(0,L.visit)(l,_),u}}),define(te[222],ne([0,1,22,3,44,145,20,87,13,29,14,23,21,49,55,221,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function p(t){return t&&t.settings&&typeof t.settings=="string"&&Object.keys(t).length===1}function g(t){const s=JSON.parse(t);return p(s)?s:{settings:t}}e.parseSettingsSyncContent=g;let y=class extends E.AbstractJsonFileSynchroniser{constructor(s,r,n,o,l,u,d,v,T,_,O){super(r.settingsResource,"settings",s,r,n,o,l,T,_,u,d,v);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const r=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(s,r),o=this.getSettingsSyncContent(n),l=new P.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&l.parse(o.settings),l.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,r,n){const o=await this.getLocalFileContent(),l=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);r=r===null&&n?s:r;const d=r?this.getSettingsSyncContent(r):null,v=await this.getIgnoredSettings();let T=null,_=!1,O=!1,N=!1;if(u){let F=o?o.value.toString().trim():"{}";F=F||"{}",this.validateContent(F),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const z=(0,S.merge)(F,u.settings,d?d.settings:null,v,[],l);T=z.localContent||z.remoteContent,_=z.localContent!==null,O=z.remoteContent!==null,N=z.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),T=o.value.toString(),O=!0);const C={content:T,localChange:_?2:0,remoteChange:O?2:0,hasConflicts:N};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:C.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:C.remoteChange,previewResource:this.previewResource,previewResult:C,acceptedResource:this.acceptedResource}]}async getMergeResult(s,r){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,S.updateIgnoredSettings)(s.previewResult.content,"{}",o,n):null}}async getAcceptResult(s,r,n,o){const l=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:s.fileContent?(0,S.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:s.remoteContent!==null?(0,S.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,S.updateIgnoredSettings)(n,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(s,r,n,o){const{fileContent:l}=n[0][0];let{content:u,localChange:d,remoteChange:v}=n[0][1];if(d===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(u,l,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const T=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),O=await this.getIgnoredSettings(u);u=(0,S.updateIgnoredSettings)(u,_?_.settings:"{}",O,T),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(T){}r?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const r=await this.getFormattingOptions(),n=(0,h.edit)(s.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,S.isEmpty)(n)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:r}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let r=await super.resolveContent(s);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(s)),r){const n=this.parseSyncData(r);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let r=await super.resolvePreviewContent(s);if(r){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();r=(0,S.updateIgnoredSettings)(r,"{}",o,n)}return r}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return g(s)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:l})=>!!l)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,S.getIgnoredSettings)(r,this.configurationService,s)}validateContent(s){if(this.hasErrors(s))throw new f.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const s=await this.getLocalFileContent();if(!s)return;const r=JSON.parse(s.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(r.content);if(!n||!n.settings)return;let o=n.settings;const l=await this.getFormattingOptions();for(const u in r)if(["version","content","machineId"].indexOf(u)===-1&&r[u]!==void 0){const d=(0,R.setProperty)(o,[u],r[u],l);d.length&&(o=(0,R.applyEdits)(o,d))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(o))}catch(s){}}};y=he([X(0,i.IFileService),X(1,w.IEnvironmentService),X(2,I.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncBackupStoreService),X(5,f.IUserDataSyncLogService),X(6,f.IUserDataSyncUtilService),X(7,A.IConfigurationService),X(8,f.IUserDataSyncResourceEnablementService),X(9,m.ITelemetryService),X(10,b.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let c=class extends E.AbstractInitializer{constructor(s,r,n){super("settings",r,n,s)}async doInitialize(s){const r=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource);return(0,S.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return g(s)}catch(r){this.logService.error(r)}return null}};c=he([X(0,i.IFileService),X(1,w.IEnvironmentService),X(2,f.IUserDataSyncLogService)],c),e.SettingsInitializer=c;function a(t){return!!(t&&t.version!==void 0&&typeof t.version=="number"&&t.content!==void 0&&typeof t.content=="string"&&t.machineId!==void 0&&typeof t.machineId=="string")}}),define(te[223],ne([0,1,22,3,26,20,13,14,23,21,49,216,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends i.AbstractSynchroniser{constructor(f,p,g,y,c,a,t,s,r){super("snippets",p,f,g,y,c,s,r,a,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,n=>n.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,p,g){const y=await this.getSnippetsFileContents(),c=this.toSnippetsContents(y),a=f.syncData?this.parseSnippets(f.syncData):null;p=p===null&&g?f:p;const t=p&&p.syncData?this.parseSnippets(p.syncData):null;a?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(c,a,t);return this.getResourcePreviews(s,y,a||{})}async getMergeResult(f,p){return f.previewResult}async getAcceptResult(f,p,g,y){if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(p,this.syncPreviewFolder))return g===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:g,localChange:g===null?f.fileContent!==null?3:0:2,remoteChange:g===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(f,p,g,y){const c=g.map(([a,t])=>({...a,acceptResult:t}));c.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,y)),c.some(({remoteChange:a})=>a!==0)&&(f=await this.updateRemoteSnippets(c,f,y)),p?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of c)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(f,p,g){const y=new Map;for(const c of Object.keys(f.local.added)){const a={content:f.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};y.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.local.updated)){const a={content:f.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.added)){const a={content:f.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.updated)){const a={content:f.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c],localContent:p[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.conflicts){const a={content:p[c]?p[c].value.toString():null,hasConflicts:!0,localChange:p[c]?2:1,remoteChange:g[c]?2:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c]||null,localContent:p[c]?p[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(p))if(!y.has(c)){const a={content:p[c]?p[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:p[c]||null,localContent:p[c]?p[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:f}){let p=await super.resolveContent(f);if(p){const g=this.parseSyncData(p);if(g){const y=this.parseSnippets(g),c=[];for(const a of Object.keys(y)){const t=this.extUri.joinPath(f,a),s=this.extUri.joinPath(this.snippetsFolder,a),r=await this.fileService.exists(s);c.push({resource:t,comparableResource:r?s:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let p=await super.resolveContent(f);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(f)),p){const g=this.parseSyncData(p);if(g)return this.parseSnippets(g)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const p={};for(const g of f)g.fileContent&&(p[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(p)))}async updateLocalSnippets(f,p){for(const{fileContent:g,acceptResult:y,localResource:c,remoteResource:a,localChange:t}of f)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(c),r=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,D.VSBuffer.fromString(y.content),{overwrite:p}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,D.VSBuffer.fromString(y.content),p?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(f,p,g){const y=p.syncData?this.parseSnippets(p.syncData):{},c=(0,R.deepClone)(y);for(const{acceptResult:a,localResource:t,remoteResource:s,remoteChange:r}of f)if(r!==0){const n=t?this.extUri.basename(t):this.extUri.basename(s);r===3?delete c[n]:c[n]=a.content}return(0,I.areSame)(y,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),p=await this.updateRemoteUserData(JSON.stringify(c),g?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),p}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const p={};for(const g of Object.keys(f))p[g]=f[g].value.toString();return p}async getSnippetsFileContents(){const f={};let p;try{p=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof P.FileOperationError&&g.fileOperationResult===1)return f;throw g}for(const g of p.children||[]){const y=g.resource,c=this.extUri.extname(y);if(c===".json"||c===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,y),t=await this.fileService.readFile(y);f[a]=t}}return f}};E=he([X(0,A.IEnvironmentService),X(1,P.IFileService),X(2,w.IStorageService),X(3,m.IUserDataSyncStoreService),X(4,m.IUserDataSyncBackupStoreService),X(5,m.IUserDataSyncLogService),X(6,k.IConfigurationService),X(7,m.IUserDataSyncResourceEnablementService),X(8,b.ITelemetryService)],E),e.SnippetsSynchroniser=E;let h=class extends i.AbstractInitializer{constructor(f,p,g){super("snippets",p,g,f)}async doInitialize(f){const p=f.syncData?JSON.parse(f.syncData.content):null;if(!p){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(p)){const c=p[y];if(c){const a=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(a,D.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};h=he([X(0,P.IFileService),X(1,A.IEnvironmentService),X(2,m.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(w){super();this.userDataSyncStoreService=w,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};A=he([X(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(te[224],ne([0,1,5,22,58,2,16,20,13,14,24]),function(J,e,D,L,R,k,A,P,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends k.Disposable{constructor(E,h,S,f){super();this.environmentService=E,this.fileService=h,this.configurationService=S,this.logService=f,i.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(E){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,E),S=await this.fileService.resolve(h);return S.children?S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(E,h){if(!h){const S=await this.getAllRefs(E);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,E,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(E,h){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,E),f=(0,A.joinPath)(S,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,L.VSBuffer.fromString(h))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(E)}catch(p){}}async cleanUpBackup(E){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(h))return}catch(f){return}const S=await this.fileService.resolve(h);if(S.children){const f=S.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=f.filter(c=>Date.now()-this.getCreationTime(c)>p);const y=f.length-g.length;y<10&&(g=g.slice(10-y)),await D.Promises.settled(g.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};I=he([X(0,w.IEnvironmentService),X(1,b.IFileService),X(2,P.IConfigurationService),X(3,i.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[225],ne([0,1,2,7]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(m){this.service=m}listen(m,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(m){this.service=m}listen(m,E){throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(m,E,h){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class w{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class b{constructor(m){this.service=m}listen(m,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(m,E,h){switch(E){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class i extends D.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:L.URI.revive(m.url),type:m.type,defaultUrl:L.URI.revive(m.defaultUrl),insidersUrl:L.URI.revive(m.insidersUrl),stableUrl:L.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[226],ne([0,1,13,10]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};R=he([X(0,L.ILoggerService),X(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[64],ne([0,1,3,2,4,25,148,13,14,6,30,47,23,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let S=class et extends L.Disposable{constructor(p,g,y,c,a,t){super();this.storageService=y,this.userDataSyncStoreService=c,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(p,g,y)}async getMachines(p){const g=await this.currentMachineIdPromise;return(await this.readMachinesData(p)).machines.map(c=>({...c,isCurrent:c.id===g}))}async addCurrentMachine(p){const g=await this.currentMachineIdPromise,y=await this.readMachinesData(p);y.machines.some(({id:c})=>c===g)||(y.machines.push({id:g,name:this.computeCurrentMachineName(y.machines)}),await this.writeMachinesData(y))}async removeCurrentMachine(p){const g=await this.currentMachineIdPromise,y=await this.readMachinesData(p),c=y.machines.filter(({id:a})=>a!==g);c.length!==y.machines.length&&(y.machines=c,await this.writeMachinesData(y))}async renameMachine(p,g,y){const c=await this.currentMachineIdPromise,a=await this.readMachinesData(y),t=a.machines.find(({id:s})=>s===p);t&&(t.name=g,await this.writeMachinesData(a),a.machines.some(({id:s})=>s===c)&&this.storageService.store(h,g,0,1))}async setEnablement(p,g){const y=await this.readMachinesData(),c=y.machines.find(({id:a})=>a===p);c&&(c.disabled=g?void 0:!0,await this.writeMachinesData(y))}computeCurrentMachineName(p){const g=this.storageService.get(h,0);if(g)return g;const y=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,c=new RegExp(`${(0,k.escapeRegExpCharacters)(y)}\\s#(\\d+)`);let a=0;for(const t of p){const s=c.exec(t.name),r=s?parseInt(s[1]):0;a=r>a?r:a}return`${y} #${a+1}`}async readMachinesData(p){this.userData=await this.readUserData(p);const g=this.parse(this.userData);if(g.version!==et.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return g}async writeMachinesData(p){const g=JSON.stringify(p),y=await this.userDataSyncStoreService.write(et.RESOURCE,g,this.userData?.ref||null);this.userData={ref:y,content:g},this._onDidChange.fire()}async readUserData(p){if(this.userData){const g=p&&p.latest?p.latest[et.RESOURCE]:void 0;if(this.userData.ref===g)return this.userData;if(g===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(p){if(p.content!==null)try{return JSON.parse(p.content)}catch(g){this.logService.error(g)}return{version:et.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=he([X(0,P.IEnvironmentService),X(1,w.IFileService),X(2,m.IStorageService),X(3,E.IUserDataSyncStoreService),X(4,E.IUserDataSyncLogService),X(5,i.IProductService)],S),e.UserDataSyncMachinesService=S}),define(te[98],ne([0,1,5,58,37,8,3,2,4,16,7,146,13,30,23,21,24,63,64]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const y="sync.enable",c="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let r=class extends P.Disposable{constructor(u,d,v){super();this.storageService=u,this.environmentService=d,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(y,u,0,1)}onDidStorageChange(u){if(u.scope===0&&y===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([X(0,h.IStorageService),X(1,m.IEnvironmentService),X(2,f.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let n=class extends P.Disposable{constructor(u,d,v,T,_,O,N,C,F,z,U){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=_,this.logService=O,this.userDataSyncAccountService=N,this.telemetryService=C,this.userDataSyncMachinesService=F,this.storageService=z,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(N.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(_.onDidChangeLocal,(x,j)=>x?[...x,j]:[j],1e3)(x=>this.triggerSync(x,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,x])=>x)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?i.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:d}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,d,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(d)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(y,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(u);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?w.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,d,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=he([X(0,E.IProductService),X(1,f.IUserDataSyncStoreManagementService),X(2,f.IUserDataSyncStoreService),X(3,f.IUserDataSyncResourceEnablementService),X(4,f.IUserDataSyncService),X(5,f.IUserDataSyncLogService),X(6,p.IUserDataSyncAccountService),X(7,S.ITelemetryService),X(8,g.IUserDataSyncMachinesService),X(9,h.IStorageService),X(10,f.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class o extends P.Disposable{constructor(u,d,v,T,_,O,N,C){super();this.lastSyncUrl=u,this.interval=d,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=T,this.userDataSyncService=_,this.userDataSyncMachinesService=O,this.logService=N,this.storageService=C,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(u,d){const v=(0,D.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,k.isPromiseCanceledError)(_))return}return this.doSync(u,d,T)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!u&&(!(0,b.isEqual)(d.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(d.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(d.stableUrl,u.stableUrl))}async doSync(u,d,v){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),v.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const _=this.storageService.get(a,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(v.isCancellationRequested)return;const N=O.find(C=>C.isCurrent);if(N?.disabled)throw new f.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(C){throw new f.UserDataAutoSyncError((0,R.toErrorMessage)(C),C instanceof f.UserDataSyncError?C.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(a,this.manifest.session,0,1),v.isCancellationRequested)return;N||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),T=_}this._onDidFinishSync.fire(T)}register(u){return super._register(u)}}o.INTERVAL_SYNCING="Interval"}),define(te[227],ne([0,1,3,2,4,23,21,24]),function(J,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends L.Disposable{constructor(i,I){super();this.storageService=i,this.telemetryService=I,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,I){if(this.isResourceEnabled(i)!==I){const m=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(m,{enabled:I}),this.storeResourceEnablement(m,I)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,I){this.storageService.store(i,I,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const I=P.ALL_SYNC_RESOURCES.filter(m=>(0,P.getEnablementKey)(m)===i.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};w=he([X(0,k.IStorageService),X(1,A.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[228],ne([0,1,17,5,37,8,3,2,16,28,20,6,23,21,217,219,220,222,223,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let a=class extends P.Disposable{constructor(n,o,l,u,d,v,T){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=o,this.instantiationService=l,this.configurationService=u,this.logService=d,this.telemetryService=v,this.storageService=T,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(p.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(f.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(g.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(_=>A.Event.map(_.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(_=>A.Event.map(_.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(_=>A.Event.map(_.onDidChangeLocal,()=>_.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,o){await this.checkEnablement();const l=(0,b.generateUuid)();try{const T=(0,y.createSyncHeaders)(l);o&&(T["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,T)}catch(T){const _=y.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(_,l),_}let u=!1;const d=this;let v;return{manifest:n,run(){if(u)throw new Error("Can run a task only once");return v=(0,L.createCancelablePromise)(T=>d.sync(n,l,T)),v.finally(()=>v=void 0)},async stop(){if(v&&v.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,b.generateUuid)(),o=(0,y.createSyncHeaders)(n);let l;try{l=await this.userDataSyncStoreService.manifest(null,o)}catch(u){const d=y.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,n),d}return new t(n,l,o,this.synchronisers,this.configurationService,this.logService)}async sync(n,o,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,y.createSyncHeaders)(o);for(const v of this.synchronisers){if(l.isCancellationRequested)return;try{await v.sync(n,d)}catch(T){let _=!1;if(T instanceof y.UserDataSyncError)switch(T.code){case"TooLarge":T=new y.UserDataSyncError(T.message,T.code,v.resource),_=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":_=!0;break}const O=y.UserDataSyncError.toUserDataSyncError(T);if(this.reportUserDataSyncError(O,o),_)throw O;this.logService.error(T),this.logService.error(`${v.resource}: ${(0,R.toErrorMessage)(T)}`),this._syncErrors.push([v.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(d){const v=y.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(v,o),v}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(o){this.logService.error(o)}}async replace(n){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(n))return}async accept(n,o,l,u){await this.checkEnablement();const d=this.getSynchroniser(n);await d.accept(o,l),u&&await d.apply(!1,(0,y.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(n){for(const o of this.synchronisers){const l=await o.resolveContent(n);if(l)return l}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,o){return this.getSynchroniser(n).getAssociatedResources(o)}getMachineId(n,o){return this.getSynchroniser(n).getMachineId(o)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of n)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(o){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const o=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([o,l],[u,d])=>o===o&&(0,D.equals)(l,d,(v,T)=>(0,w.isEqual)(v.previewResource,T.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,o){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof y.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof y.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(s)])}getSynchroniser(n){return this.synchronisers.find(o=>o.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=he([X(0,y.IUserDataSyncStoreService),X(1,y.IUserDataSyncStoreManagementService),X(2,I.IInstantiationService),X(3,i.IConfigurationService),X(4,y.IUserDataSyncLogService),X(5,E.ITelemetryService),X(6,m.IStorageService)],a),e.UserDataSyncService=a;class t extends P.Disposable{constructor(n,o,l,u,d,v){super();this.id=n,this.manifest=o,this.syncHeaders=l,this.synchronisers=u,this.configurationService=d,this.logService=v,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,o){try{return await this.performAction(n,l=>l.accept(n,o))}catch(l){throw this.logService.error(l),l}}async merge(n){try{return n?await this.performAction(n,o=>o.merge(n)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(n){try{return await this.performAction(n,o=>o.discard(n))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,o]of this.previews)for(const l of o.resourcePreviews)l.mergeState==="conflict"&&n.push(l.previewResource);for(const o of n)await this.discard(o);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(v=>v.resource===o);for(const v of l.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&await u.merge(v.previewResource);const d=await u.apply(!1,this.syncHeaders);d&&n.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===n);for(const u of o.resourcePreviews)await l.accept(u.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===n);for(const u of o.resourcePreviews)await l.accept(u.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(o){(0,k.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(n,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,C])=>C.resourcePreviews.some(({localResource:F,previewResource:z,remoteResource:U})=>(0,w.isEqual)(n,F)||(0,w.isEqual)(n,z)||(0,w.isEqual)(n,U)));if(l===-1)return this.previews;const[u,d]=this.previews[l],v=d.resourcePreviews.find(({localResource:C,remoteResource:F,previewResource:z})=>(0,w.isEqual)(C,n)||(0,w.isEqual)(F,n)||(0,w.isEqual)(z,n));if(!v)return this.previews;let T=this.synchronizingResources.find(C=>C[0]===u);T||(T=[u,[]],this.synchronizingResources.push(T)),T[1].some(C=>(0,w.isEqual)(C,v.localResource))||(T[1].push(v.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find(C=>C.resource===this.previews[l][0]),O=await o(_);O?this.previews.splice(l,1,this.toSyncResourcePreview(_.resource,O)):this.previews.splice(l,1);const N=this.synchronizingResources.findIndex(C=>C[0]===u);return this.synchronizingResources[N][1].splice(T[1].findIndex(C=>(0,w.isEqual)(C,v.localResource)),1),T[1].length||(this.synchronizingResources.splice(N,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(v=>v.resource===o);let d=l;for(const v of l.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&(d=await u.merge(v.previewResource));d&&n.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const o=[],l=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(n.isCancellationRequested)return[];const d=await u.preview(this.manifest,l,this.syncHeaders);d&&o.push(this.toSyncResourcePreview(u.resource,d))}return o}async getUserDataSyncConfiguration(){const n=this.configurationService.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE),o=await this.synchronisers.find(l=>l instanceof p.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...n,...o}}toSyncResourcePreview(n,o){return[n,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[229],ne([0,1,3,2,18,7,24]),function(J,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(I,m){this.service=I,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(I,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(I,m,E){try{return await this._call(I,m,E)}catch(h){throw this.logService.error(h),h}}async _call(I,m,E){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],k.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:k.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:k.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),S=E[0],f=this.getManualSyncTask(S);switch(E=E.slice(1),h){case"preview":return f.preview();case"accept":return f.accept(k.URI.revive(E[0]),E[1]);case"merge":return f.merge(k.URI.revive(E[0]));case"discard":return f.discard(k.URI.revive(E[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(I){const m=this.manualSyncTasks.get(this.createKey(I));if(!m)throw new Error(`Manual sync taks not found: ${I}`);return m.manualSyncTask}async createManualSyncTask(){const I=new L.DisposableStore,m=I.add(await this.service.createManualSyncTask());return I.add(m.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:E}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:I}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(I){I.dispose();const m=this.createKey(I.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=P;class w extends L.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,E,h){return I.call(m,E,h).then(null,S=>{throw A.UserDataSyncError.toUserDataSyncError(S)})},listen(m,E){return I.listen(m,E)}},this.channel.call("_getInitialData").then(([m,E,h])=>{this.updateStatus(m),this.updateConflicts(E),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([E,h])=>[E,A.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:m,status:E}=await this.channel.call("createManualSyncTask"),h=this,S=new b(I,m,E,{async call(f,p,g){return h.channel.call(`manualSync/${f}`,[I,...(0,R.isArray)(p)?p:[p]],g)},listen(f,p){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${f}`,p),g=>!S.isDiposed()&&g.manualSyncTaskId===I),g=>g.data)}});return S}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,m,E,h){return this.channel.call("accept",[I,m,E,h])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:k.URI.revive(h)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:k.URI.revive(h)}))}async getAssociatedResources(I,m){return(await this.channel.call("getAssociatedResources",[I,m])).map(({resource:h,comparableResource:S})=>({resource:k.URI.revive(h),comparableResource:k.URI.revive(S)}))}async getMachineId(I,m){return this.channel.call("getMachineId",[I,m])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([m,E])=>[m,E.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=w;class b extends L.Disposable{constructor(I,m,E,h){super();this.id=I,this.manifest=m,this._disposed=!1,this._status=E;const S=this;this.channel={async call(f,p,g){try{const y=await h.call(f,p,g);return S.isDiposed()||(S._status=await h.call("_getStatus")),y}catch(y){throw A.UserDataSyncError.toUserDataSyncError(y)}},listen(f,p){return h.listen(f,p)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,m){const E=await this.channel.call("accept",[I,m]);return this.deserializePreviews(E)}async merge(I){const m=await this.channel.call("merge",[I]);return this.deserializePreviews(m)}async discard(I){const m=await this.channel.call("discard",[I]);return this.deserializePreviews(m)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([m,E])=>[m,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource),acceptedResource:k.URI.revive(h.acceptedResource)}))}])}}}),define(te[230],ne([0,1,5,27,8,3,2,107,4,16,18,7,28,20,13,14,30,43,47,23,24]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",n=100,o=1e3*60*5;let l=class extends A.Disposable{constructor(O,N,C){super();this.productService=O,this.configurationService=N,this.storageService=C,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(C.onDidChangeValue,F=>F.key===c.SYNC_SERVICE_URL_TYPE&&F.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=w.isWeb&&O?.web?{...O,...O.web}:O;const C={...O||{},...N||{}};if(C&&(0,i.isString)(C.url)&&(0,i.isObject)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(F=>(0,i.isArray)(C.authenticationProviders[F].scopes))){const F=C,z=!!F.canSwitch&&!N?.url,U=F.url===F.insidersUrl?"insiders":"stable",x=(z?this.userDataSyncStoreType:void 0)||U,j=N?.url||(x==="insiders"?F.insidersUrl:x==="stable"?F.stableUrl:F.url);return{url:I.URI.parse(j),type:x,defaultType:U,defaultUrl:I.URI.parse(F.url),stableUrl:I.URI.parse(F.stableUrl),insidersUrl:I.URI.parse(F.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(F.authenticationProviders).reduce((q,W)=>(q.push({id:W,scopes:F.authenticationProviders[W].scopes}),q),[])}}}};l=he([X(0,f.IProductService),X(1,E.IConfigurationService),X(2,y.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let u=class extends l{constructor(O,N,C){super(O,N,C);const F=this.storageService.get(a,0);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const z=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(a,JSON.stringify(z),0,1):this.storageService.remove(a,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([X(0,f.IProductService),X(1,E.IConfigurationService),X(2,y.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends A.Disposable{constructor(O,N,C,F,z,U,x){super();this.requestService=C,this.logService=F,this.storageService=x,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,g.getServiceMachineId)(z,U,x).then(j=>{const q={"X-Client-Name":`${N.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(q["X-Client-Commit"]=N.commit),q}),this.session=new T(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),C={},F=await this.request(N.toString(),{type:"GET",headers:C},[],L.CancellationToken.None);return(await(0,p.asJson)(F)||[]).map(({url:U,created:x})=>({ref:(0,b.relativePath)(N,N.with({path:U})),created:x*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const C=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),F={};F["Cache-Control"]="no-cache";const z=await this.request(C,{type:"GET",headers:F},[],L.CancellationToken.None);return await(0,p.asText)(z)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),C={};await this.request(N,{type:"DELETE",headers:C},[],L.CancellationToken.None)}async read(O,N,C={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();C={...C},C["Cache-Control"]="no-cache",N&&(C["If-None-Match"]=N.ref);const z=await this.request(F,{type:"GET",headers:C},[304],L.CancellationToken.None);let U=null;if(z.res.statusCode===304&&(U=N),U===null){const x=z.res.headers.etag;if(!x)throw new c.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,p.asText)(z);if(!j&&z.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[c.HEADER_OPERATION_ID]);U={ref:x,content:j}}return U}async write(O,N,C,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();F={...F},F["Content-Type"]=P.Mimes.text,C&&(F["If-Match"]=C);const U=await this.request(z,{type:"POST",data:N,headers:F},[],L.CancellationToken.None),x=U.res.headers.etag;if(!x)throw new c.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",U.res.statusCode,U.res.headers[c.HEADER_OPERATION_ID]);return x}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const C=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const F=await this.request(C,{type:"GET",headers:N},[304],L.CancellationToken.None);let z=null;if(F.res.statusCode===304&&(z=O),!z){const x=F.res.headers.etag;if(!x)throw new c.UserDataSyncStoreError("Server did not return the ref",C,"NoRef",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,p.asText)(F);if(!j&&F.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",C,"EmptyResponse",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);j&&(z={...JSON.parse(j),ref:x})}const U=this.storageService.get(s,0);return U&&z&&U!==z.session&&this.clearSession(),z===null&&U&&this.clearSession(),z&&this.storageService.store(s,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(O,N,C,F){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;N.headers={...N.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let U;try{U=await this.session.request(O,N,F)}catch(W){if(!(W instanceof c.UserDataSyncStoreError)){let $="RequestFailed";const G=(0,R.getErrorMessage)(W).toLowerCase();G.includes("xhr timeout")?$="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?$="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":G.includes("headers must be an object")?$="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(W)&&($="RequestCanceled"),W=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,$,void 0,void 0)}throw this.logService.info("Request failed",O),W}const x=U.res.headers[c.HEADER_OPERATION_ID],j={url:O,status:U.res.statusCode,"execution-id":N.headers[c.HEADER_EXECUTION_ID],"operation-id":x},q=(0,p.isSuccess)(U)||U.res.statusCode&&C.indexOf(U.res.statusCode)!==-1;if(q?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,x);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,x);if(U.res.statusCode===410)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,x);if(U.res.statusCode===412)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,x);if(U.res.statusCode===413)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,x);if(U.res.statusCode===426)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,x);if(U.res.statusCode===429){const W=U.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,x)):new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,x)}if(!q)throw new c.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,x);return U}addSessionHeaders(O){let N=this.storageService.get(r,0);N===void 0&&(N=(0,m.generateUuid)(),this.storageService.store(r,N,0,1)),O["X-Machine-Session-Id"]=N;const C=this.storageService.get(s,0);C!==void 0&&(O["X-User-Session-Id"]=C)}};d=he([X(1,f.IProductService),X(2,p.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,y.IStorageService)],d),e.UserDataSyncStoreClient=d;let v=class extends d{constructor(O,N,C,F,z,U,x){super(O.userDataSyncStore?.url,N,C,F,z,U,x);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};v=he([X(0,c.IUserDataSyncStoreManagementService),X(1,f.IProductService),X(2,p.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,S.IFileService),X(6,y.IStorageService)],v),e.UserDataSyncStoreService=v;class T{constructor(O,N,C,F){this.limit=O,this.interval=N,this.requestService=C,this.logService=F,this.requests=[],this.startTime=void 0}request(O,N,C){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,C)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[231],ne([0,1,3,60,30,23,21,98,24,63,64]),function(J,e,D,L,R,k,A,P,w,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends P.UserDataAutoSyncService{constructor(E,h,S,f,p,g,y,c,a,t,s,r){super(E,h,S,f,p,y,c,a,t,s,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(g.onDidFocusWindow,()=>"windowFocus"),D.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(n,o)=>n?[...n,o]:[o],1e3)(n=>this.triggerSync(n,!0,!1)))}};I=he([X(0,R.IProductService),X(1,w.IUserDataSyncStoreManagementService),X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncResourceEnablementService),X(4,w.IUserDataSyncService),X(5,L.INativeHostService),X(6,w.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,A.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,k.IStorageService),X(11,w.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[232],ne([0,1,5,3,2]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:w,getActiveWindowId:b}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[65],ne([0,1,53,5,9,18,19,124,243,244]),function(J,e,D,L,R,k,A,P,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,s){let r=s.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=s}}e.ExtractError=i;function I(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,r)=>s+r,t&61440)}function m(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function E(a,t,s,r,n,o){const l=R.dirname(t),u=R.join(r,l);if(!u.startsWith(r))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(r,t);let v;return o.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,_)=>{if(!o.isCancellationRequested)try{v=(0,D.createWriteStream)(d,{mode:s}),v.once("close",()=>T()),v.once("error",_),a.once("error",_),a.pipe(v)}catch(O){_(O)}}))}function h(a,t,s,r){let n=(0,L.createCancelablePromise)(()=>Promise.resolve()),o=0;return r.onCancellationRequested(()=>{n.cancel(),a.close()}),new Promise((l,u)=>{const d=new L.Sequencer,v=T=>{T.isCancellationRequested||(o++,a.readEntry())};a.once("error",u),a.once("close",()=>n.then(()=>{r.isCancellationRequested||a.entryCount===o?l():u(new i("Incomplete",new Error(P.localize(1,null,o,a.entryCount))))},u)),a.readEntry(),a.on("entry",T=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(T.fileName)){v(r);return}const _=T.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const C=R.join(t,_);n=(0,L.createCancelablePromise)(F=>A.Promises.mkdir(C,{recursive:!0}).then(()=>v(F)).then(void 0,u));return}const O=f(a,T),N=I(T);n=(0,L.createCancelablePromise)(C=>d.queue(()=>O.then(F=>E(F,_,N,t,s,C).then(()=>v(C)))).then(null,u))})})}function S(a,t=!1){return new Promise((s,r)=>{(0,w.open)(a,t?{lazyEntries:!0}:void 0,(n,o)=>{n?r(m(n)):s((0,k.assertIsDefined)(o))})})}function f(a,t){return new Promise((s,r)=>{a.openReadStream(t,(n,o)=>{n?r(m(n)):s((0,k.assertIsDefined)(o))})})}function p(a,t){return new Promise((s,r)=>{const n=new b.ZipFile;t.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const o=(0,D.createWriteStream)(a);n.outputStream.pipe(o),n.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>s(a))})}e.zip=p;function g(a,t,s={},r){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=S(a,!0);return s.overwrite&&(o=o.then(l=>A.Promises.rm(t).then(()=>l))),o.then(l=>h(l,t,{sourcePathRegex:n},r))}e.extract=g;function y(a,t){return S(a).then(s=>new Promise((r,n)=>{s.on("entry",o=>{o.fileName===t&&f(s,o).then(l=>r(l),l=>n(l))}),s.once("close",()=>n(new Error(P.localize(2,null,t))))}))}function c(a,t){return y(a,t).then(s=>new Promise((r,n)=>{const o=[];s.once("error",n),s.on("data",l=>o.push(l)),s.on("end",()=>r(Buffer.concat(o)))}))}e.buffer=c}),define(te[233],ne([0,1,65,133]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,D.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[234],ne([0,1,17,5,8,2,15,9,4,16,61,7,28,19,65,134,13,29,35,153,14,10,30]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",r="scanningUser",n="extracting",o="deleting",l="renaming";let u=class extends k.Disposable{constructor(v,T,_,O,N){super();this.beforeRemovingExtension=v,this.fileService=T,this.logService=_,this.environmentService=O,this.productService=N,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(v){const T=[];(v===null||v===0)&&T.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(_).message,s)))),(v===null||v===1)&&T.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(_).message,r))));try{const _=await Promise.all(T);return(0,D.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(v){this.logService.trace("Started scanning user extensions");let[T,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(O=>!T[new g.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),v&&(_=(0,g.groupByExtension)(_,N=>N.identifier).map(N=>N.sort((C,F)=>i.rcompare(C.manifest.version,F.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(v,T,_,O){const N=v.key(),C=P.join(this.extensionsPath,`.${(0,m.generateUuid)()}`),F=P.join(this.extensionsPath,N);try{await E.Promises.rm(F)}catch(U){try{await E.Promises.rm(F)}catch(x){}throw new p.ExtensionManagementError((0,S.localize)(0,null,F,v.id),o)}await this.extractAtLocation(v,T,C,O);let z=await this.scanExtension(I.URI.file(C),1);if(!z)throw new Error((0,S.localize)(1,null,C));await this.storeMetadata(z,{..._,installedTimestamp:Date.now()});try{await this.rename(v,C,F,Date.now()+2*60*1e3),this.logService.info("Renamed to",F)}catch(U){try{await E.Promises.rm(C)}catch(x){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",v.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(U)}. Deleted from extracted location`,C),U}try{z=await this.scanExtension(I.URI.file(F),1)}catch(U){}if(z)return z;throw new Error((0,S.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(v,T){return this.setMetadata(v,T),await this.storeMetadata(v,{...T,installedTimestamp:v.installedTimestamp}),v}async storeMetadata(v,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const _=P.join(v.location.fsPath,"package.json"),O=await E.Promises.readFile(_,"utf8"),{manifest:N}=await this.parseManifest(O);return N.__metadata=T,await E.Promises.writeFile(_,JSON.stringify(N,null,"	")),v}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...v){const T=v.map(_=>new g.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{T.forEach(O=>_[O.key()]=!0)})}async setInstalled(v){await this.withUninstalledExtensions(O=>delete O[v.key()]);const _=(await this.scanExtensions(1)).find(O=>new g.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(v))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(v){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let _={};if(T)try{_=JSON.parse(T)}catch(O){}return v&&(v(_),Object.keys(_).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await E.Promises.rm(this.uninstalledPath)),_})}async removeExtension(v,T){this.logService.trace(`Deleting ${T} extension from disk`,v.identifier.id,v.location.fsPath),await E.Promises.rm(v.location.fsPath),this.logService.info("Deleted from disk",v.identifier.id,v.location.fsPath)}async removeUninstalledExtension(v){await this.removeExtension(v,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new g.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()])}async extractAtLocation(v,T,_,O){this.logService.trace(`Started extracting the extension from ${T} to ${_}`);try{await E.Promises.rm(_)}catch(N){throw new p.ExtensionManagementError(this.joinErrors(N).message,o)}try{await(0,h.extract)(T,_,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${_}:`,v.id)}catch(N){try{await E.Promises.rm(_)}catch(C){}throw new p.ExtensionManagementError(N.message,N instanceof h.ExtractError&&N.type?N.type:n)}}async rename(v,T,_,O){try{await E.Promises.rename(T,_)}catch(N){if(w.isWindows&&N&&N.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${T} to ${_} with 'EPERM' error. Trying again...`,v.id),this.rename(v,T,_,O);throw new p.ExtensionManagementError(N.message||(0,S.localize)(3,null,T,_),N.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const v=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return v;const T=this.scanDevSystemExtensions(),[_,O]=await Promise.all([v,T]);return[..._,...O]}async scanExtensionsInDir(v,T){const _=new L.Limiter(10),O=await this.fileService.resolve(I.URI.file(v));return O.children?(await Promise.all(O.children.filter(C=>C.isDirectory).map(C=>_.queue(async()=>T===1&&(0,b.basename)(C.resource).indexOf(".")===0?null:this.scanExtension(C.resource,T))))).filter(C=>C&&C.identifier):[]}async scanExtension(v,T){try{const _=await this.fileService.resolve(v);if(_.children){const{manifest:O,metadata:N}=await this.readManifest(v.fsPath),C=_.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,F=_.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource,z={id:(0,g.getGalleryExtensionId)(O.publisher,O.name)},U={type:T,identifier:z,manifest:O,location:v,readmeUrl:C,changelogUrl:F,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return N&&(this.setMetadata(U,N),U.installedTimestamp=N.installedTimestamp),U}}catch(_){T!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const v=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",v.length),v}async scanDevSystemExtensions(){const v=this.getDevSystemExtensionsList();if(v.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(_=>v.some(O=>(0,g.areSameExtensions)(_.identifier,{id:O})))}else return[]}setMetadata(v,T){v.publisherDisplayName=T.publisherDisplayName||null,v.publisherId=T.publisherId||null,v.identifier.uuid=T.id,v.isMachineScoped=!!T.isMachineScoped,v.isBuiltin=v.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const v=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),_=new Set;for(const C of T)v[new g.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]||_.add(C.identifier.id.toLowerCase());const O=(0,g.groupByExtension)(T,C=>C.identifier);await L.Promises.settled(O.map(async C=>{const F=C.sort((z,U)=>i.rcompare(z.manifest.version,U.manifest.version))[0];_.has(F.identifier.id.toLowerCase())||await this.beforeRemovingExtension(F)}));const N=T.filter(C=>v[new g.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]);await L.Promises.settled(N.map(C=>this.removeUninstalledExtension(C)))}async removeOutdatedExtensions(){const v=await this.scanAllUserExtensions(),T=[],_=(0,g.groupByExtension)(v,O=>O.identifier);T.push(...(0,D.flatten)(_.map(O=>O.sort((N,C)=>i.rcompare(N.manifest.version,C.manifest.version)).slice(1)))),await L.Promises.settled(T.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(v=>v.name)}joinErrors(v){const T=Array.isArray(v)?v:[v];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((_,O)=>new Error(`${_.message}${_.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(v){const T=[E.Promises.readFile(P.join(v,"package.json"),"utf8").then(C=>this.parseManifest(C)),E.Promises.readFile(P.join(v,"package.nls.json"),"utf8").then(void 0,C=>C.code!=="ENOENT"?Promise.reject(C):"{}").then(C=>JSON.parse(C))],[{manifest:_,metadata:O},N]=await Promise.all(T);return{manifest:(0,y.localizeManifest)(_,N),metadata:O}}parseManifest(v){return new Promise((T,_)=>{try{const O=JSON.parse(v),N=O.__metadata||null;T({manifest:O,metadata:N})}catch(O){_(new Error((0,S.localize)(4,null)))}})}};u=he([X(1,c.IFileService),X(2,a.ILogService),X(3,f.INativeEnvironmentService),X(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(te[235],ne([0,1,37,8,15,9,4,31,16,61,7,28,19,65,132,79,13,201,29,35,184,173,233,185,234,186,76,14,6,10,42,21]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a,t,s,r,n,o,l,u,d,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",O="downloading";let N=class extends p.AbstractExtensionManagementService{constructor(j,q,W,$,G,M,B){super(j,q,W);this.environmentService=$,this.downloadService=G,this.fileService=B;const V=this._register(M.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(r.ExtensionsScanner,Z=>V.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache($,this)),this.extensionsDownloader=this._register(M.createInstance(c.ExtensionsDownloader));const Q=this._register(new n.ExtensionsWatcher(this,B,$,W));this._register(Q.onDidChangeExtensionsByAnotherSource(({added:Z,removed:K})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(H=>({identifier:H.identifier,operation:0,local:H}))),K.forEach(H=>this._onDidUninstallExtension.fire({identifier:H}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const j=await this.isAlpineLinux(),q=(0,g.getTargetPlatform)(j?"alpine":A.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let j;try{j=(await this.fileService.readFile(i.URI.file("/etc/os-release"))).value.toString()}catch(q){try{j=(await this.fileService.readFile(i.URI.file("/usr/lib/os-release"))).value.toString()}catch(W){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(W))}}return!!j&&(j.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const q=await this.collectFiles(j),W=await(0,E.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,q);return i.URI.file(W)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const q=await this.downloadVsix(j),W=k.resolve(q.fsPath);return(0,t.getManifest)(W)}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}async install(j,q={}){this.logService.trace("ExtensionManagementService#install",j.toString());const W=await this.downloadVsix(j),$=await(0,t.getManifest)(k.resolve(W.fsPath));if($.engines&&$.engines.vscode&&!(0,o.isEngineValid)($.engines.vscode,v.default.version,v.default.date))throw new Error(h.localize(0,null,(0,y.getGalleryExtensionId)($.publisher,$.name),v.default.version));return this.installExtension($,W,q)}async updateMetadata(j,q){return this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),j}async updateExtensionScope(j,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),j}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(j){if(j.scheme===R.Schemas.file)return j;const q=(0,w.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(j,q),q}createInstallExtensionTask(j,q,W){return i.URI.isUri(q)?new z(j,q,W,this.galleryService,this.extensionsScanner,this.logService):new F(q,W,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(j,q){return new U(j,q,this.extensionsScanner)}async collectFiles(j){const q=async $=>{let G=await m.Promises.readdir($);G=G.map(V=>k.join($,V));const M=await Promise.all(G.map(V=>m.Promises.stat(V)));let B=Promise.resolve([]);return M.forEach((V,Q)=>{const Z=G[Q];V.isFile()&&(B=B.then(K=>[...K,Z])),V.isDirectory()&&(B=B.then(K=>q(Z).then(H=>[...K,...H])))}),B};return(await q(j.location.fsPath)).map($=>({path:`extension/${k.relative(j.location.fsPath,$)}`,localPath:$}))}};N=he([X(0,g.IExtensionGalleryService),X(1,T.ITelemetryService),X(2,d.ILogService),X(3,f.INativeEnvironmentService),X(4,S.IDownloadService),X(5,u.IInstantiationService),X(6,l.IFileService)],N),e.ExtensionManagementService=N;class C extends p.AbstractExtensionTask{constructor(j,q,W,$){super();this.identifier=j,this.source=q,this.extensionsScanner=W,this.logService=$,this._operation=1}get operation(){return this._operation}async installExtension(j,q){try{const W=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(W)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(W,j.metadata):W}catch(W){throw A.isMacintosh?new g.ExtensionManagementError(h.localize(1,null),_):new g.ExtensionManagementError(h.localize(2,null),_)}return this.extract(j,q)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const W=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),W}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.key()]}async extract({zipPath:j,identifierWithVersion:q,metadata:W},$){let G=await this.extensionsScanner.extractUserExtension(q,j,W,$);return this.logService.info("Extracting completed.",q.id),G}}class F extends C{constructor(j,q,W,$,G){super(j.identifier,j,$,G);this.gallery=j,this.options=q,this.extensionsDownloader=W}async doRun(j){const W=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,y.areSameExtensions)(G.identifier,this.gallery.identifier));W&&(this._operation=2);const $=await this.downloadInstallableExtension(this.gallery,this._operation);$.metadata.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,$.metadata.isBuiltin=this.options.isBuiltin||W?.isBuiltin;try{const G=await this.installExtension($,j);return W&&b.neq(W.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(W),G}catch(G){throw await this.deleteDownloadedVSIX($.zipPath),G}}async deleteDownloadedVSIX(j){try{await this.extensionsDownloader.delete(i.URI.file(j))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",j.toString(),(0,L.getErrorMessage)(q))}}async downloadInstallableExtension(j,q){const W={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let $;try{this.logService.trace("Started downloading extension:",j.identifier.id),$=(await this.extensionsDownloader.downloadExtension(j,q)).fsPath,this.logService.info("Downloaded extension:",j.identifier.id,$)}catch(G){throw new g.ExtensionManagementError((0,p.joinErrors)(G).message,O)}try{const G=await(0,t.getManifest)($);return{zipPath:$,identifierWithVersion:new y.ExtensionIdentifierWithVersion(j.identifier,G.version),metadata:W}}catch(G){throw await this.deleteDownloadedVSIX($),new g.ExtensionManagementError((0,p.joinErrors)(G).message,p.INSTALL_ERROR_VALIDATING)}}}class z extends C{constructor(j,q,W,$,G,M){super({id:(0,y.getGalleryExtensionId)(j.publisher,j.name)},q,G,M);this.manifest=j,this.location=q,this.options=W,this.galleryService=$}async doRun(j){const q=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),$=(await this.extensionsScanner.scanExtensions(1)).find(M=>(0,y.areSameExtensions)(this.identifier,M.identifier)),G=await this.getMetadata(this.identifier.id,j);if(G.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||$?.isBuiltin,$)if(this._operation=2,q.equals(new y.ExtensionIdentifierWithVersion($.identifier,$.manifest.version)))try{await this.extensionsScanner.removeExtension($,"existing")}catch(M){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt($.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled($);else{const M=await this.unsetUninstalledAndGetLocal(q);if(M)try{await this.extensionsScanner.removeExtension(M,"existing")}catch(B){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:k.resolve(this.location.fsPath),identifierWithVersion:q,metadata:G},j)}async getMetadata(j,q){try{const W=(await this.galleryService.query({names:[j],pageSize:1},q)).firstPage[0];if(W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId}}catch(W){}return{}}}class U extends p.AbstractExtensionTask{constructor(j,q,W){super();this.extension=j,this.options=q,this.extensionsScanner=W}async doRun(j){const q=[],W=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const $=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...W.filter(G=>$.equals(new y.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version))))}else q.push(...W.filter($=>(0,y.areSameExtensions)($.identifier,this.extension.identifier)));if(!q.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const $ of q)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension($)}catch(G){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(G)))}}}}),define(te[236],ne([0,1,82,57,33,22,8,3,2,9,4,28,32,71,245]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class S{constructor(u){this.socket=u,this._errorListener=d=>{if(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=v=>u(k.VSBuffer.wrap(v));return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=v=>{u({type:0,hadError:v,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,A.onUnexpectedError)(d)}}end(){this.socket.end()}drain(){return new Promise((u,d)=>{if(this.socket.bufferSize===0){u();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),u()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=S;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var p;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(p||(p={}));class g extends w.Disposable{constructor(u,d,v,T){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=d,this._recordInflateBytes=T,d?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,A.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),v&&(this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,A.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let d=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.length-4),this._isEnded||this._write(k.VSBuffer.wrap(d),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,d){let v=2;u.byteLength<126?v+=0:u.byteLength<2**16?v+=2:v+=8;const T=k.VSBuffer.alloc(v);if(d?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(u.byteLength>>>8&255,++_),T.writeUInt8(u.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(u.byteLength>>>24&255,++_),T.writeUInt8(u.byteLength>>>16&255,++_),T.writeUInt8(u.byteLength>>>8&255,++_),T.writeUInt8(u.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=T.byteLength+u.byteLength,this.socket.write(k.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),v=d.readUInt8(0),T=(v&128)>>>7,_=(v&64)>>>6,O=d.readUInt8(1),N=(O&128)>>>7,C=O&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(C===126?2:0)+(C===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),v=d.readUInt8(1),T=(v&128)>>>7;let _=v&127,O=1;_===126?_=d.readUInt8(++O)*2**8+d.readUInt8(++O):_===127&&(_=d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O));let N=0;T&&(N=d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O)),this._state.state=3,this._state.readLen=_,this._state.mask=N}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);y(d,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(d.buffer)),this._zlibInflate.write(d.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const v=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=v.length,this._onData.fire(k.VSBuffer.wrap(v))})):(this._totalIncomingDataBytes+=d.byteLength,this._onData.fire(d))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=g;function y(l,u){if(u===0)return;let d=l.byteLength>>>2;for(let C=0;C<d;C++){const F=l.readUInt32BE(C*4);l.writeUInt32BE(F^u,C*4)}let v=d*4,T=l.byteLength-v;const _=u>>>24&255,O=u>>>16&255,N=u>>>8&255;T>=1&&l.writeUInt8(l.readUInt8(v)^_,v),T>=2&&l.writeUInt8(l.readUInt8(v+1)^O,v+1),T>=3&&l.writeUInt8(l.readUInt8(v+2)^N,v+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function a(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):u=(0,b.join)((0,R.tmpdir)(),`vscode-ipc-${l}.sock`),s(u),u}e.createRandomIPCHandle=a;function t(l,u,d){const v=(0,D.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${d}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${d}-${u}.sock`):T=(0,b.join)(l,`${d}-${u}.sock`),s(T),T}e.createStaticIPCHandle=t;function s(l){const u=c[i.platform];typeof u=="number"&&l.length>=u&&console.warn(`WARNING: IPC handle "${l}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends m.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const d=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(d,v=>({protocol:new E.Protocol(new S(v)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(l){return new Promise((u,d)=>{const v=(0,L.createServer)();v.on("error",d),v.listen(l,()=>{v.removeListener("error",d),u(new r(v))})})}e.serve=n;function o(l,u){return new Promise((d,v)=>{const T=(0,L.createConnection)(l,()=>{T.removeListener("error",v),d(E.Client.fromSocket(new S(T),u))});T.once("error",v)})}e.connect=o}),define(te[237],ne([0,1,57,236]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,k,A,P){const w=i=>P(i,void 0),b=D.createConnection({host:R,port:k},()=>{b.removeListener("error",w);const i=Buffer.alloc(16);for(let h=0;h<16;h++)i[h]=Math.round(Math.random()*256);const I=i.toString("base64");let m=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${k}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];b.write(m.join(`\r
`)+`\r
\r
`);const E=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),P(void 0,new L.NodeSocket(b)))};b.on("data",E)});b.once("error",w)}}}),define(te[238],ne([0,1,57,114,237,5,2,20,10,30,182,62,90]),function(J,e,D,L,R,k,A,P,w,b,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(p,g,y,c,a){return new h(p,g,y,c,a).waitForReady()}class h extends A.Disposable{constructor(g,y,c,a,t){super();this.defaultTunnelHost=y,this.suggestedLocalPort=t,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=D.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(y=>{y()})}async waitForReady(){let g=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),y=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address(),y||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address()),this.tunnelLocalPort=y.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${y.port}`,this}async _onConnection(g){g.pause();const y=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,i.connectRemoteAgentTunnel)(this._options,y,this.tunnelRemotePort),a=c.getSocket().socket,t=c.readEntireBuffer();c.dispose(),t.byteLength>0&&g.write(t.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),a.end()}),g.on("close",()=>a.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),a.destroy()}),a.on("end",()=>g.end()),a.on("close",()=>g.end()),a.on("error",()=>{g.destroy()}),g.pipe(a),a.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),a.end()})}}let S=class extends I.AbstractTunnelService{constructor(g,y,c,a,t){super(y);this.socketFactory=g,this.signService=c,this.productService=a,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,y,c,a,t,s,r){const n=this.getTunnelFromMap(y,c);if(n)return++n.refcount,n.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,y,c,a,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${y}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},l=E(o,this.defaultTunnelHost,y,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(y,c,l),l}}};S=he([X(1,w.ILogService),X(2,m.ISignService),X(3,b.IProductService),X(4,P.IConfigurationService)],S),e.BaseTunnelService=S;let f=class extends S{constructor(g,y,c,a){super(R.nodeSocketFactory,g,y,c,a)}};f=he([X(0,w.ILogService),X(1,m.ISignService),X(2,b.IProductService),X(3,P.IConfigurationService)],f),e.TunnelService=f}),define(te[246],ne([0,1,72,53,247,33,37,8,2,15,16,7,32,118,178,158,179,170,171,172,156,160,20,180,78,200,79,191,13,151,196,203,29,159,202,235,80,154,14,175,177,54,6,167,83,168,169,59,187,10,84,60,42,30,190,43,23,198,199,21,91,92,93,48,204,205,94,207,213,96,97,98,24,63,224,225,226,64,227,228,229,230,231,232,81,174,90,195,62,238,188,189,89,194]),function(J,e,D,L,R,k,A,P,w,b,i,I,m,E,h,S,f,p,g,y,c,a,t,s,r,n,o,l,u,d,v,T,_,O,N,C,F,z,U,x,j,q,W,$,G,M,B,V,Q,Z,K,H,re,ie,ae,ue,fe,de,Ie,Ce,Ee,_e,Pe,Te,Fe,$e,Ne,qe,ee,oe,ce,ye,pe,Oe,De,Y,se,le,ge,me,be,ke,Le,Se,we,Re,Ae,Me,it,Ke,xe,wt,at,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class bt extends w.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",ze=(Ye,We)=>this.onDisposeWorker(We);D.ipcRenderer.on(Ue,ze),this._register((0,w.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,ze)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,pe.registerConfiguration)(),ve.invokeFunction(Ue=>{const ze=Ue.get(Z.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(ze)}),this._register((0,w.combinedDisposable)(ve.createInstance(h.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(f.LanguagePackCachedDataCleaner),ve.createInstance(y.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(g.LogsDataCleaner),ve.createInstance(p.LocalizationsUpdater),ve.createInstance(S.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new G.ServiceCollection,Ue={_serviceBrand:void 0,...re.default};ve.set(ie.IProductService,Ue);const ze=new m.StaticRouter(je=>je==="main"),Ye=new M.MessagePortMainProcessService(this.server,ze);ve.set(B.IMainProcessService,Ye);const We=new d.NativeEnvironmentService(this.configuration.args,Ue);ve.set(u.INativeEnvironmentService,We);const rt=new K.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Qe=new K.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ye.getChannel("logger"));ve.set(Z.ILoggerService,Qe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,i.joinPath)(I.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new K.FollowerLogService(rt,ot));ve.set(Z.ILogService,Ve),this.sharedProcessWorkerService=new Et.SharedProcessWorkerService(Ve),ve.set(at.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ze=this._register(new x.FileService(Ve));ve.set(U.IFileService,Ze);const ct=this._register(new j.DiskFileSystemProvider(Ve));Ze.registerProvider(b.Schemas.file,ct);const He=this._register(new s.ConfigurationService(We.settingsResource,Ze));ve.set(t.IConfigurationService,He);const tt=new de.NativeStorageService(void 0,Ye,We);ve.set(fe.IStorageService,tt),this._register((0,w.toDisposable)(()=>tt.flush())),await Promise.all([He.initialize(),tt.initialize()]),ve.set(ue.IRequestService,new q.SyncDescriptor(ae.RequestService)),ve.set(c.IChecksumService,new q.SyncDescriptor(a.ChecksumService));const st=m.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(H.INativeHostService,st),ve.set(o.IDownloadService,new q.SyncDescriptor(l.DownloadService));const lt=this._register(new Se.ActiveWindowManager(st)),ut=new m.StaticRouter(je=>lt.getActiveClientId().then(ht=>je===ht));ve.set(F.IExtensionRecommendationNotificationService,new z.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let Je;const Xe=[];if((0,Te.supportsTelemetry)(Ue,We)){const je=new _e.TelemetryLogAppender(Qe,We);Xe.push(je);const{appRoot:ht,extensionsPath:Pt,installSourcePath:Rt}=We;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const mt=new Fe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,w.toDisposable)(()=>mt.flush())),Xe.push(mt)}Je=new Pe.TelemetryService({appenders:Xe,commonProperties:(0,Ie.resolveCommonProperties)(Ze,(0,k.release)(),(0,k.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Rt),sendErrorTelemetry:!0,piiPaths:[ht,Pt]},He)}else{Je=Te.NullTelemetryService;const je=Te.NullAppender;Xe.push(je)}this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(Xe)),ve.set(Ce.ITelemetryService,Je);const Ct=new $e.CustomEndpointTelemetryService(He,Je,Qe,We);return ve.set(Ce.ICustomEndpointTelemetryService,Ct),ve.set(_.IExtensionManagementService,new q.SyncDescriptor(C.ExtensionManagementService)),ve.set(_.IExtensionGalleryService,new q.SyncDescriptor(T.ExtensionGalleryService)),ve.set(_.IExtensionTipsService,new q.SyncDescriptor(N.ExtensionTipsService)),ve.set(V.ILocalizationsService,new q.SyncDescriptor(Q.LocalizationsService)),ve.set(r.IDiagnosticsService,new q.SyncDescriptor(n.DiagnosticsService)),ve.set(Oe.IUserDataSyncAccountService,new q.SyncDescriptor(Oe.UserDataSyncAccountService)),ve.set(pe.IUserDataSyncLogService,new q.SyncDescriptor(se.UserDataSyncLogService)),ve.set(pe.IUserDataSyncUtilService,new Y.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),ve.set(_.IGlobalExtensionEnablementService,new q.SyncDescriptor(v.GlobalExtensionEnablementService)),ve.set(ce.IIgnoredExtensionsManagementService,new q.SyncDescriptor(ce.IgnoredExtensionsManagementService)),ve.set(oe.IExtensionsStorageSyncService,new q.SyncDescriptor(oe.ExtensionsStorageSyncService)),ve.set(pe.IUserDataSyncStoreManagementService,new q.SyncDescriptor(ke.UserDataSyncStoreManagementService)),ve.set(pe.IUserDataSyncStoreService,new q.SyncDescriptor(ke.UserDataSyncStoreService)),ve.set(le.IUserDataSyncMachinesService,new q.SyncDescriptor(le.UserDataSyncMachinesService)),ve.set(pe.IUserDataSyncBackupStoreService,new q.SyncDescriptor(De.UserDataSyncBackupStoreService)),ve.set(pe.IUserDataAutoSyncEnablementService,new q.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),ve.set(pe.IUserDataSyncResourceEnablementService,new q.SyncDescriptor(ge.UserDataSyncResourceEnablementService)),ve.set(pe.IUserDataSyncService,new q.SyncDescriptor(me.UserDataSyncService)),ve.set(qe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,We,Ve,Je))),ve.set(we.IExtensionHostStarter,this._register(new Re.ExtensionHostStarter(Ve))),ve.set(Ae.ISignService,new q.SyncDescriptor(Me.SignService)),ve.set(it.ITunnelService,new q.SyncDescriptor(Ke.TunnelService)),ve.set(xe.ISharedProcessTunnelService,new q.SyncDescriptor(wt.SharedProcessTunnelService)),new $.InstantiationService(ve)}initChannels(ve){const Ue=new O.ExtensionManagementChannel(ve.get(_.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const ze=m.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ye=m.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const We=new O.ExtensionTipsChannel(ve.get(_.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const rt=m.ProxyChannel.fromService(ve.get(c.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new Y.UserDataSyncMachinesServiceChannel(ve.get(le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const ot=m.ProxyChannel.fromService(ve.get(Ce.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ot);const Ve=new Y.UserDataSyncAccountServiceChannel(ve.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const Ze=new Y.UserDataSyncStoreManagementServiceChannel(ve.get(pe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ze);const ct=new be.UserDataSyncChannel(ve.get(pe.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(ve.get(W.IInstantiationService).createInstance(Le.UserDataAutoSyncService)),tt=new Y.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",tt);const st=ve.get(qe.ILocalPtyService),lt=m.ProxyChannel.fromService(st);this.server.registerChannel(Ne.TerminalIpcChannels.LocalPty,lt);const ut=m.ProxyChannel.fromService(ve.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,ut);const Je=m.ProxyChannel.fromService(ve.get(xe.ISharedProcessTunnelService));this.server.registerChannel(xe.ipcSharedProcessTunnelChannelName,Je);const Xe=m.ProxyChannel.fromService(ve.get(at.ISharedProcessWorkerService));this.server.registerChannel(at.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,P.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ue=>{const ze=(0,A.toErrorMessage)(Ue,!0);!ze||ve.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function It(gt){const ve=new bt(gt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=It})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/729d81623815a428160b93e930054a1a2a5403ef/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
